'*********************************************************
'* Controller.bi                               12/19/2021
'*
'* Contains all the code pretaining to controller setup
'* and settings
'*********************************************************




'*********************************************************
'* SetupController
'*
'* Called from main menu to bind buttons and set analog deadzone
'*********************************************************
SUB SetupController
    COLOR _RGB(255, 255, 255)
    CALL NoInputKeyboard

    FOR i = 1 TO _DEVICES
        PRINT STR$(i) + ")" + _DEVICE$(i)
    NEXT i
    PRINT
    INPUT "Select a device:"; Controller.Device

    CALL NoInputKeyboard

    PRINT "Play with Controller to memorize what is what. Press 'Y' on keyboard when ready"
    PRINT
    DO
        IF UCASE$(INKEY$) = "Y" THEN EXIT DO
        CALL ControllerInfo
    LOOP

    LOCATE 30, 1
    CALL NoInputKeyboard
    INPUT "Which button for 'A'"; Controller.A
    CALL NoInputKeyboard
    INPUT "Which button for 'B'"; Controller.B
    CALL NoInputKeyboard
    INPUT "Push Button for 'Start'"; Controller.Start
    CALL NoInputKeyboard
    INPUT "Which Axis to use for DPad up and down"; Controller.DpadV
    CALL NoInputKeyboard
    INPUT "Which Axis to use for DPad left and right"; Controller.DpadH
    CALL NoInputKeyboard
    Controller.Enabled = 1
    CALL SaveController
    CALL NoInputKeyboard
END SUB


SUB NoInputKeyboard
    DO
    LOOP UNTIL INKEY$ = ""
END SUB



'*********************************************************
'* SaveController
'*
'* Saves the controller info.
'*********************************************************
SUB SaveController
    OPEN "Data\Controller.inf" FOR RANDOM AS #1
    PUT #1, , Controller
    CLOSE #1
END SUB


'*********************************************************
'* LoadController
'*
'* Loads the controller config into the controller object
'*********************************************************
SUB LoadController
    'CALL PrintConsole("Engine -> Initializing Controller.", 1)

    OPEN "Data\Controller.inf" FOR RANDOM AS #1
    GET #1, , Controller
    CLOSE #1
END SUB


'*********************************************************
'* Controller Info
'*
'* Prints controller data table
'*********************************************************

SUB ControllerInfo
    D& = _DEVICEINPUT
    Lin = CSRLIN

    IF D& THEN
        IF D& = Controller.Device THEN
            LB = _LASTBUTTON(Controller.Device)

            FOR a = 1 TO _LASTAXIS(Controller.Device)
                PRINT "AXIS"; a; ") ", _AXIS(a)
            NEXT a
            PRINT
            PRINT "Button Table:"

            FOR x = 1 TO LB
                IF x = LB THEN
                    PRINT x
                ELSE
                    PRINT x;
                END IF
            NEXT x
            PRINT "=========================================================="
            FOR x = 1 TO LB
                IF x > 9 THEN
                    PRINT " "; _BUTTON(x);
                ELSE
                    PRINT _BUTTON(x);
                END IF
            NEXT x

            LOCATE Lin, 1
        END IF
    END IF
END SUB


'*********************************************************
'* ReadController
'*
'* Converts button presses into triggers
'*********************************************************
SUB ReadController

    Dev& = _DEVICEINPUT
    IF Dev& THEN
        IF Dev& = Controller.Device THEN
            ControllerInput.A = _BUTTON(Controller.A)
            ControllerInput.B = _BUTTON(Controller.B)
            ControllerInput.Start = _BUTTON(Controller.Start)
            ControllerInput.DpadH = _AXIS(Controller.DpadH)
            ControllerInput.DpadV = _AXIS(Controller.DpadV)
        END IF
    END IF
END SUB
