'*********************************************************
'* EditorError.bi                     6/13/2021
'*
'* Used when world editor runs into an issue. Dumps into E-Error.txt
'*********************************************************


SUB EditorErrorHandler
    _DEST Display&
    PRINT "Error Dumped to Error.txt"
    OPEN "E-Error.txt" FOR OUTPUT AS #9
    PRINT #9, "Error Timestamp "; DATE$; " : "; TIME$
    PRINT #9, ""
    IF _INCLERRORFILE$ = "" THEN
        PRINT #9, "Error Code:"; ERR; "in source file: Editor.bas on line:"; _ERRORLINE
    ELSE
        PRINT #9, "Error Code:"; ERR; "in source file: "; _INCLERRORFILE$; " on line:"; _INCLERRORLINE
    END IF
    PRINT #9, ErrorDescription$(ERR)
    PRINT #9,
    PRINT #9, "Sub Data: "; Settings.ErrorTracker
    PRINT #9,


    PRINT #9, "Map Type:"; ActiveMap.Type
    PRINT #9, "Map Sybtype:"; ActiveMap.SubType
    PRINT #9, "BGM Value:"; ActiveMap.BGM
    PRINT #9, "Ambient Sound Value:"; ActiveMap.AmbientSound


    PRINT #9, ""
    PRINT #9, "Zone Data"
    PRINT #9, ActiveMap.DoorN, ActiveMap.DoorE, ActiveMap.DoorS, ActiveMap.DoorW
    PRINT #9, ActiveMap.NFile, ActiveMap.EFile, ActiveMap.SFile, ActiveMap.WFile

    PRINT #9, ""
    PRINT #9, "Spawn Matrix"
    FOR y = 1 TO ActiveMap.SpriteLimitY
        FOR x = 1 TO ActiveMap.SpriteLimitX - 1
            PRINT #9, USING "### "; SpriteMatrix(x, y);
        NEXT x
        PRINT #9, USING "### "; SpriteMatrix(ActiveMap.SpriteLimitX, y)
    NEXT y

    CLOSE ALL
    END
END SUB