'*********************************************************
'* Error.bi                             6/12/2021
'*
'* Contains all the crash stuff
'*
'* Only used by game
'*********************************************************



'*********************************************************
'* ErrorHandler
'*
'* Dumps all data to Error.txt
'*********************************************************

SUB ErrorHandler
    CALL JukeBox(-3)
    _DEST Display&
    PRINT "Error Dumped to Error.txt"
    OPEN "Error.txt" FOR OUTPUT AS #9
    PRINT #9, "Error Timestamp "; DATE$; " : "; TIME$
    PRINT #9, ""
    IF _INCLERRORFILE$ = "" THEN
        PRINT #9, "Error Code:"; ERR; "in source file: Main.bas on line:"; _ERRORLINE
    ELSE
        PRINT #9, "Error Code:"; ERR; "in source file: "; _INCLERRORFILE$; " on line:"; _INCLERRORLINE
    END IF
    PRINT #9, ErrorDescription$(ERR)

    PRINT #9,
    PRINT #9, "Sub Data: "; Settings.ErrorTracker
    PRINT #9, "Alpha Effect: "; Settings.Alpha
    PRINT #9, "Show Stairs: "; Settings.ShowStairs
    PRINT #9, "Lockdown: "; Settings.LockDown
    PRINT #9,
    PRINT #9,

    PRINT #9, "Link Dump:"
    PRINT #9, "Attacking:"; Player1.CanAttack
    PRINT #9, "Primary Selected:"; Player1.Sword
    PRINT #9, "Sword Damage:"; Player1.SwordDamage
    PRINT #9, "Primary Attacking:"; Player1.Attacking
    PRINT #9, "Secondary Selected:"; Player1.SecondaryWeapon
    PRINT #9, "Secondary Attacking:"; Player1.LockSecondary
    PRINT #9, "Health:"; Player1.Health; " /  Max Health:"; Player1.MaxHealth
    FOR x = 1 TO 3
        PRINT #9, "Attack:"; x, "Active:"; Attack(x).Active, "Frame:"; Attack(x).Active, "Direction:"; Attack(x).Direction
    NEXT x
    PRINT #9,
    PRINT #9, "Position:"; Player1.XPos; ":"; Player1.YPos
    PRINT #9, "Direction:"; Player1.Direction
    PRINT #9, "Movement Enabled:"; Player1.CanMove
    PRINT #9, "Movement Speed:"; Player1.MoveSpeed
    PRINT #9, "Check Offset:"; Player1.CheckOffset
    PRINT #9, "Time Freeze:"; Player1.Clock
    PRINT #9,
    PRINT #9, "Animation Enabled:"; Player1.Animate
    PRINT #9, "Animation Delay:"; Player1.AnimationDelay; "Of Max Delay:"; Player1.MaxDelay
    PRINT #9, "Frame:"; Player1.Frame
    PRINT #9,
    PRINT #9, "Counter:"; Player1.Counter
    PRINT #9, "Is Hurt:"; Player1.Hurt
    PRINT #9, "Throwback Direction:"; Player1.HurtMove
    PRINT #9, "Is Inside Room:"; Player1.InRoom
    PRINT #9, "Like-Like Locked:"; Player1.LikeLocked
    PRINT #9, "Sprite Size:"; Player1.Size
    PRINT #9, "Width Mod:"; Player1.WidthMod
    PRINT #9,
    PRINT #9, "Health:"; Player1.Health; "Of Max:"; Player1.MaxHealth
    PRINT #9, "Rupees:"; Player1.Cash
    PRINT #9, "Keys:"; Player1.Keys
    PRINT #9, "Bombs:"; Player1.Bombs
    PRINT #9, "Ring:"; Player1.Ring
    PRINT #9, "Triforce Pieces:"; Player1.Triforce
    PRINT #9,
    PRINT #9, "Have Book:"; Player1.HaveBook
    PRINT #9, "Have Boomerang:"; Player1.Boomerang
    PRINT #9, "Have Candle:"; Player1.Candle
    PRINT #9, "Have Magic Shield:"; Player1.HaveMagicShield
    PRINT #9, "Have Silver Arrow:"; Player1.SilverArrow
    PRINT #9, "Have Food:"; Player1.HaveFood
    PRINT #9, "On Raft:"; Player1.OnRaft
    PRINT #9,
    PRINT #9,
    PRINT #9, "Zone Data:"
    PRINT #9, "ActiveFile$: "; ActiveFile$
    PRINT #9, ActiveMap.DoorN, ActiveMap.DoorE, ActiveMap.DoorS, ActiveMap.DoorW
    PRINT #9, ActiveMap.NFile, ActiveMap.EFile, ActiveMap.SFile, ActiveMap.WFile
    PRINT #9, "Name: "; ActiveMap.Name
    PRINT #9, "BGM:"; ActiveMap.BGM
    PRINT #9, "Zone Type:"; ActiveMap.Type
    PRINT #9, "Zone SubType:"; ActiveMap.SubType
    PRINT #9, "Sprite Limits:"; ActiveMap.SpriteLimitX; ":"; ActiveMap.SpriteLimitY
    PRINT #9, "Ambient Sound:"; ActiveMap.AmbientSound
    PRINT #9, "Secret Zone: "; ActiveMap.SecretZone
    PRINT #9, "Open Condition:"; ActiveMap.OpenCondition
    PRINT #9, "Blackout Map (SubType > 10):"; ActiveMap.Blackout
    PRINT #9, ""
    PRINT #9, ""
    PRINT #9, "Spawn Matrix"
    FOR y = 1 TO ActiveMap.SpriteLimitY
        FOR x = 1 TO ActiveMap.SpriteLimitX - 1
            PRINT #9, USING "### "; SpriteMatrix(x, y);
        NEXT x
        PRINT #9, USING "### "; SpriteMatrix(ActiveMap.SpriteLimitX, y)
    NEXT y

    PRINT #9, ""
    PRINT #9, "Sprite Dump"
    FOR x = 1 TO Settings.MatrixSize
        PRINT #9, "Sprite:"; x, "Name:"; Sprites(x).Name, "Active:"; Sprites(x).Active, "Direction:"; Sprites(x).Direction, "Size:"; Sprites(x).Size, "Frame:"; Sprites(x).Frame, "XPos:"; Sprites(x).XPos, "YPos:"; Sprites(x).YPos, "MoveX:"; Sprites(x).MoveX, "MoveY:"; Sprites(x).MoveY, "Health:"; Sprites(x).Health, "Attacking:"; Sprites(x).Attacking, "Paused:"; Sprites(x).Pause, "Hurt:"; Sprites(x).Hurt, "Hurt Move:"; Sprites(x).HurtMove, "Stage:"; Sprites(x).Stage, "Frame2:"; Sprites(x).Frame2, "Animation Delay:"; Sprites(x).AnimationDelay, , "Max Delay:"; Sprites(x).MaxDelay, "Counter:"; Sprites(x).Counter, "MaxCount:"; Sprites(x).MaxCount, "Counter2:"; Sprites(x).Counter2, "MaxCount2:"; Sprites(x).MaxCount2, "Segments:"; Sprites(x).Segments, "SnakeNum:"; Sprites(x).SnakeNum, "Angle:"; Sprites(x).Angle, "Flash:"; Sprites(x).Flash, "Max Flash:"; Sprites(x).MaxFlash, "ControlLoc:"; Sprites(x).PatraLoc, "Master:"; Sprites(x).Master, "Misc:"; Sprites(x).Misc, "Jumping:"; Sprites(x).Jumping, "Stunned:"; Sprites(x).Stunned
    NEXT x

    PRINT #9, ""
    PRINT #9, "Special Dump"
    FOR x = 1 TO Settings.MatrixSize
        PRINT #9, "Sprite:"; x, "Name:"; Special(x).Name, "Active:"; Special(x).Active, "Direction:"; Special(x).Direction, "Frame:"; Special(x).Frame, "XPos:"; Special(x).XPos, "YPos:"; Special(x).YPos, "MoveX:"; Special(x).MoveX, "MoveY:"; Special(x).MoveY, "Stage:"; Special(x).Stage, "Counter:"; Special(x).Counter, "MaxCount:"; Special(x).MaxCount, "Master:"; Special(x).Master
    NEXT x

    PRINT #9, ""
    PRINT #9, "Projectile Dump"
    FOR x = 1 TO Settings.MatrixSize
        PRINT #9, "Sprite:"; x, "Name:"; Projectile(x).Name, "Active:"; Projectile(x).Active, "Direction:"; Projectile(x).Direction, "Frame:"; Projectile(x).Frame, "Xpos:"; Projectile(x).XPos, "YPos:"; Projectile(x).YPos, "MoveX:"; Projectile(x).MoveX, "MoveY:"; Projectile(x).MoveY, "Stage:"; Projectile(x).Stage, "Counter:"; Projectile(x).Counter, "MobControl:"; Projectile(x).MobControl
    NEXT x

    PRINT #9, ""
    PRINT #9, "Cleared Array Dump"
    FOR x = 1 TO Settings.ClearedArraySize
        PRINT #9, ClearedArray(x)
    NEXT x

    PRINT #9, ""
    PRINT #9, "Segment Data"
    PRINT #9, Snakes(1), , Snakes(2), , Snakes(3), , Snakes(4)
    FOR x = 1 TO 120
        PRINT #9, "X1:"; SnakePosX(1, x), "Y1:"; SnakePosY(1, x), "X2:"; SnakePosX(2, x), "Y2:"; SnakePosY(2, x), "X3:"; SnakePosX(3, x), "Y3:"; SnakePosY(3, x), "X4:"; SnakePosX(4, x), "Y4:"; SnakePosY(4, x)
    NEXT x

    CLOSE ALL

    DO
        _LIMIT 10

        IF _KEYDOWN(27) = -1 THEN
            END
        ELSEIF _KEYDOWN(15104) = -1 THEN
            SCREEN Display&
        ELSEIF _KEYDOWN(15360) = -1 THEN
            SCREEN Collision&
        ELSEIF _KEYDOWN(15616) = -1 THEN
            SCREEN Transition&
        ELSEIF _KEYDOWN(15872) = -1 THEN
            SCREEN Scene&
        ELSEIF _KEYDOWN(16128) = -1 THEN
            SCREEN Sprites&
        END IF
    LOOP
END SUB