'*********************************************************
'* ErrorDescription.bi                   6/12/2021
'*
'* Contains the error listings for Error.bi and EError.bi 
'*
'* Used by both world editor and game
'*********************************************************


FUNCTION ErrorDescription$ (Code)
    IF Code = 1 THEN ErrorDescription$ = "NEXT without FOR: Missing loop end or look for a missing END IF or END SELECT statement."
    IF Code = 2 THEN ErrorDescription$ = "Syntax error: Mistyped keyword statements or puctuation errors can create syntax errors."
    IF Code = 3 THEN ErrorDescription$ = "RETURN without GOSUB: Place sub-procedure line label after program END or EXIT in a SUB-procedure."
    IF Code = 4 THEN ErrorDescription$ = "Out of Data: A READ has read past the end of DATA. Use RESTORE to reset to data start. ."
    IF Code = 5 THEN ErrorDescription$ = "Illegal function call: A parameter passed does not match the function type or exceeds certain function limitations. See Illegal Function."
    IF Code = 6 THEN ErrorDescription$ = "Overflow: A numerical value has exceeded the limitations of a variable type."
    IF Code = 7 THEN ErrorDescription$ = "Out of memory: A module has exceeded the 64K memory limitation of QB. Try breaking the code up to smaller modules."
    IF Code = 8 THEN ErrorDescription$ = "Label not defined: GOTO or GOSUB tries to branch to a label that doesn't exist."
    IF Code = 9 THEN ErrorDescription$ = "Subscript out of range: An array's upper or lower dimensioned boundary has been exceeded."
    IF Code = 52 THEN ErrorDescription$ = "Bad file name or number: The filename must follow the rules for filenames in the OS and use filenumbers from 1 and 255. Use FREEFILE to avoid duplicate OPEN file numbers."
    IF Code = 53 THEN ErrorDescription$ = "File not found."
    IF Code = 55 THEN ErrorDescription$ = "File already open: CLOSE a file to open it in a different mode."
    IF Code = 62 THEN ErrorDescription$ = "Input past end of file: Check for the end of file with EOF when reading from a file"
    IF Code = 76 THEN ErrorDescription$ = "Path is not access-able or does not exist. Use _DIREXISTS to check paths."
    IF Code = 92 THEN ErrorDescription$ = "String to display is too long."
    IF Code = 93 THEN ErrorDescription$ = "Too many projectiles, matrix overfilled."
    IF Code = 94 THEN ErrorDescription$ = "Too many special sprites."
    IF Code = 95 THEN ErrorDescription$ = "Invalid String value NULL."
    IF Code = 96 THEN ErrorDescription$ = "Surpassed 4 snakes max."
    IF Code = 97 THEN ErrorDescription$ = "Intentional error to cause a dump"
    IF Code = 98 THEN ErrorDescription$ = "Sprite Matrix not large enough"
    IF Code = 99 THEN ErrorDescription$ = "Mob direction change could not find a suitable direction."
    IF Code = 258 THEN ErrorDescription$ = "Zero or bad handle values cannot be used by the QB64 procedure creating the error."
END FUNCTION


