'****************************************************************************
'* Leaderboard Client v1.0
'*
'* Handles leaderboard communication to server.
'* Requires ipcommsg.bi from ipcomtools
'*
'****************************************************************************




'**************************************************************************
'* Gets leader board info from server
'**************************************************************************
Function GetLeaderBoard
    GetLeaderBoard = 0
    SENDMSG Server, "GETBOARD"
    If WAITFORREPLY$(Server) = "GAMENO" Then SENDMSG Server, Str$(GameID)

    If WAITFORREPLY$(Server) = "OK" Then
        For x = 1 To 20
            SENDMSG Server, "NAME"
            LeaderBoard(x).User = WAITFORREPLY$(Server)
            SENDMSG Server, "SCORE"
            LeaderBoard(x).Score = VAL(WAITFORREPLY$(Server))
            SENDMSG Server, "OK"
            IF WAITFORREPLY$(Server) <> "NEXT" THEN EXIT SUB
        NEXT x
        IF WAITFORREPLY$(Server) = "DONE" THEN GetLeaderBoard = 1
    END IF
END FUNCTION

'**************************************************************************
'* Ends session
'**************************************************************************
SUB CloseConnection
    SENDMSG Server, "CLOSE"
    IF WAITFORREPLY$(Server) = "GOODBYE" THEN CLOSE #Server
END SUB


'**************************************************************************
'* Opens connection to server, als handles authentication
'**************************************************************************
FUNCTION OpenConnection
    Server = _OPENCLIENT("TCP/IP:3571:" + ServerAddress)
    IF Server THEN
        SENDMSG Server, "HELLO"
        Step2$ = WAITFORREPLY$(Server)
        IF Step2$ = "OK" THEN
            SENDMSG Server, "PREADY"
            Tmp = VAL(WAITFORREPLY$(Server))
            PW = (Tmp * 2) + (Tmp * 7) + 41 - (Tmp * 3)
            SENDMSG Server, STR$(PW)
            IF WAITFORREPLY$(Server) = "LOCKED" THEN
                OpenConnection = 1
            ELSE
                OpenConnection = 0
            END IF
        ELSEIF Step2$ = "BANNED" THEN
            OpenConnection = 2
        END IF
    ELSE
        OpenConnection = 0
    END IF
END FUNCTION


'*************************************************************************
'* Sends score to server
'*************************************************************************
FUNCTION SendScore (User$, Score)
    SendScore = 0
    SENDMSG Server, "SENDSCORE"
    IF WAITFORREPLY$(Server) = "GAMENO" THEN SENDMSG Server, STR$(GameID)
    IF WAITFORREPLY$(Server) = "OK" THEN
        SENDMSG Server, User$
        Step2$ = WAITFORREPLY$(Server)
        IF Step2$ = "SCORE" THEN
            SENDMSG Server, STR$(Score)
            SendScore = 1
        ELSEIF Step2$ = "BANNED" THEN
            SendScore = 2
        END IF
    END IF
END FUNCTION




'$include:'ipcommsg.bi'
