$ExeIcon:'Images\Link.ico'
WindowTitle$ = "Master Sword v1.2"
_Title WindowTitle$


Type Sprite
    Active As Integer
    Angle As Single
    AnimationDelay As Integer
    Ambient As Integer
    Attacking As Integer
    AttackPointer As Integer
    Boss As Integer
    Counter As Integer
    Counter2 As Integer
    Damage As Single
    Direction As Integer
    Flash As Integer
    Flying As Integer
    Frame As Integer
    Frame2 As Integer
    HardCount As Integer
    Health As Integer
    Hurt As Integer
    HurtMove As Integer
    HP As Integer
    Jumping As Integer
    LootCategory As Integer
    Master As Integer
    MaxDelay As Integer
    MaxCount As Integer
    MaxCount2 As Integer
    MaxFlash As Integer
    Misc As Integer
    MoveCheckBypass As Integer
    MoveX As Single
    MoveY As Single
    Name As String * 5
    OXPos As Single
    OYPos As Single
    PatraLoc As Single
    Pause As Integer
    RadX As Single
    RadY As Single
    Segments As Integer
    Size As Integer
    SnakeDivider As Integer
    SnakeNum As Integer
    SnakeSize As Integer
    Speed As Single
    Stage As Integer
    Stunned As Integer
    WalkAdd As Integer
    WalkTime As Integer
    XPos As Single
    YPos As Single
End Type

Type SpecialSprite
    Active As Integer
    AnimationDelay As Integer
    Counter As Integer
    Damage As Integer
    Direction As Integer
    Frame As Integer
    Master As Integer
    MaxCount As Integer
    MaxDelay As Integer
    MoveX As Single
    MoveY As Single
    Name As String * 5
    Size As Integer
    SizeW As Integer
    SizeH As Integer
    Speed As Single
    Stage As Integer
    XPos As Single
    YPos As Single
    Controller As Integer
End Type

Type ProJectile
    Active As Integer
    AnimationDelay As Integer
    Counter As Integer
    Damage As Integer
    Direction As Integer
    Distance As Integer
    Frame As Integer
    Name As String * 5
    MaxDelay As Integer
    MobControl As Single
    MoveX As Single
    MoveY As Single
    ShieldUpgrade As Integer
    Size As Integer
    SizeW As Integer
    SizeH As Integer
    Speed As Integer
    Stage As Integer
    XPos As Single
    YPos As Single
    PlayerSpawned As Integer
End Type

Type WaterType
    MaxCount As Integer
    Counter As Integer
    Frame As Integer
End Type

Dim Shared Collision As Long
Dim Shared Foreground As Long
Dim Shared WaterScreen As Long
Dim Shared Transition As Long
Dim Shared DebugScreen As Long
Dim Shared UiComposite As Long

Dim Shared LinkSprites(4, 5, 3) As Long
Dim Shared AttackSprites(4, 6) As Long
Dim Shared BowSprite As Long
Dim Shared BombSprite As Long
Dim Shared ClockSprite As Long
Dim Shared FluteSprite As Long
Dim Shared UiBase As Long
Dim Shared WandSprites(4) As Long
Dim Shared WaterSprites(4) As Long
Dim Shared CandleSprites(2) As Long
Dim Shared DeathSprites(3) As Long
Dim Shared CloudSprites(4) As Long
Dim Shared PotionSprites(2) As Long
Dim Shared RingSprites(2) As Long
Dim Shared BookSprite As Long
Dim Shared FoodSprite As Long
Dim Shared HeartSprites(7) As Long
Dim Shared RupeeSprites(2) As Long
Dim Shared FairySprites(2) As Long
Dim Shared KeySprites(2) As Long
Dim Shared LadderSprite As Long
Dim Shared RaftSprites(4) As Long
Dim Shared TriforceSprites(4) As Long
Dim Shared TriforceUISprites(4) As Long
Dim Shared ShieldSprites(4) As Long
Dim Shared CharacterSprites(5) As Long
Dim Shared StoreItemSprites(9) As Long
Dim Shared CursorSprite As Long
Dim Shared WaterfallTop(2) As Long
Dim Shared IntroWaterfall(6) As Long
Dim Shared IntroBackDrop As Long

Dim Shared SparkSprites(4, 4) As Long
Dim Shared OctorokSprites(4, 4) As Long
Dim Shared GoriyaSprites(4, 4) As Long
Dim Shared MoblinSprites(4, 4) As Long
Dim Shared RopeSprites(2, 2) As Long
Dim Shared DarknutSprites(4, 4) As Long
Dim Shared LynelSprites(4, 4) As Long
Dim Shared KeeseSprites(4) As Long
Dim Shared PeahatSprites(2) As Long
Dim Shared GibdoSprites(2) As Long
Dim Shared ArmosSprites(2, 2) As Long
Dim Shared FlameSprites(2) As Long
Dim Shared FireballSprite As Long
Dim Shared LanmolaSprites(2, 2) As Long
Dim Shared StalfosSprites(2) As Long
Dim Shared GelSprites(2) As Long
Dim Shared ZolSprites(2) As Long
Dim Shared TrapSprite As Long
Dim Shared PatraSprites(2, 2) As Long
Dim Shared WizzrobeSprites(8, 2) As Long
Dim Shared GhiniSprites(4) As Long
Dim Shared LeeverSprites(2, 5) As Long
Dim Shared TektiteSprites(2, 2) As Long
Dim Shared WaterfallSprites(3) As Long
Dim Shared ZoraSprites(3) As Long
Dim Shared VireSprites(2, 2) As Long
Dim Shared BubbleSprite As Long
Dim Shared LikeLikeSprites(3) As Long
Dim Shared PolsVoiceSprites(2) As Long

Dim Shared AquamentusSprites(2, 2) As Long
Dim Shared DodongoSprites(4, 3) As Long
Dim Shared ManhandlaSprites(5, 2) As Long
Dim Shared GleeokSprites(3, 3) As Long
Dim Shared DigdoggerSprites(2, 2) As Long
Dim Shared GohmaSprites(8, 2) As Long
Dim Shared GannonSprites(6) As Long

Dim Shared OctoRockSprite As Long
Dim Shared ArrowSprites(4, 3) As Long
Dim Shared BoomerangSprites(8, 2) As Long
Dim Shared MagicSprites(4) As Long

Dim Shared SnakePosX(4, 120) As Single
Dim Shared SnakePosY(4, 120) As Single

Dim Shared ClearedArray(Settings.ClearedArraySize) As String * 8
Dim Shared ReturnMap As String

Dim Shared Snakes(4) As Integer
Dim Shared Framecount As Integer
Dim Shared LootTable(4, 10) As Integer
Dim Shared TransMatrix(24, 14) As Integer
Dim Shared ClockTrack As Integer

Dim Shared Attack(3) As Sprite
Dim Shared Special(Settings.MatrixSize) As SpecialSprite
Dim Shared Sprites(Settings.MatrixSize) As Sprite
Dim Shared Projectile(Settings.MatrixSize) As ProJectile
Dim Shared Water As WaterType

Dim Shared SwordDelayTimer
Dim Shared FramerateTimer
Dim Shared WizzFireTimer
Dim Shared BubbleTimer
Dim Shared PotionTimer
Dim Shared CashTimer
Dim Shared GameOverTimer
Dim Shared MenuTimer

Randomize Timer

If Settings.Debug > 1 Then
    '$CONSOLE
    _ConsoleTitle "Master Sword Debug Console"
    _Console On
End If

Open "Data\User.txt" For Input As #1
Input #1, Settings.User
Close #1


