'*********************************************************
'* Menus.bi                                   12/19/2021
'*
'* All the Game Menus
'*********************************************************


'*********************************************************
'* Intro screen
'*
'*
'*********************************************************
SUB Intro
    ExitIntro = 0
    Animationdelay = 5
    WFDelay = 3
    WFTop = 1
    WF1 = 1
    Settings.Ending = 0
    CALL JukeBox(7)
    CLS

    _PUTIMAGE , IntroBackDrop, Scene&

    DO
        _DEST Buffer&
        CLS
        _DEST Sprites&
        CLS
        _CLEARCOLOR _RGB(0, 0, 0)


        _LIMIT 60
        IF Controller.Enabled = 1 then Call ReadController
        IF ControllerInput.Start = -1 OR _KEYDOWN(13) = -1 THEN ExitIntro = 1
        CALL CheckForAudioLoop

        Delay = Delay + 1
        WFDel = WFDel + 1
        IF Delay = Animationdelay THEN
            Delay = 0
            WFTop = WFTop + 1
            IF WFTop = 3 THEN WFTop = 1
        END IF

        IF WFDel = WFDelay THEN
            WFDel = 0
            WF1 = WF1 + 1
            IF WF1 = 4 THEN WF1 = 1
        END IF

        _PUTIMAGE (320, 545)-(447, 605), WaterfallTop(WFTop), Sprites&
        _PUTIMAGE (320, 625)-(447, 685), IntroWaterfall(WF1 + 3), Sprites&
        _PUTIMAGE (320, 605)-(447, 665), IntroWaterfall(WF1), Sprites&
        _PUTIMAGE (320, 685)-(447, 745), IntroWaterfall(WF1 + 3), Sprites&
        _PUTIMAGE (320, 745)-(447, 805), IntroWaterfall(WF1 + 3), Sprites&

        _PUTIMAGE , Scene&, Buffer&
        _PUTIMAGE , Sprites&, Buffer&
        _PUTIMAGE , Buffer&, Display&

    LOOP UNTIL ExitIntro = 1

    CALL JukeBox(-1)
    _DEST Buffer&
    CLS
    DO
    LOOP UNTIL STRIG(Controller.Start) = 0 AND _KEYDOWN(13) = 0
END SUB


'*********************************************************
'* Main menu
'*
'*
'*********************************************************
SUB MainMenu
    MenuTimer = _FREETIMER
    ON TIMER(MenuTimer, 1) LockMenu
    Settings.MainMenu = 0
    Settings.Intro = 0

    MenuStart:
    Flash = 0
    Menu = 1
    Size = 10
    XLoc = 390
    YLoc = 310
    MaxCount = 2
    SpriteNum = 2
    Counts = 0
    Counter = 0
    _DEST UI&
    CLS
    _FONT Settings.Font
    COLOR _RGB(255, 255, 255)
    LOCATE 16, 25
    PRINT "START"
    LOCATE 22, 25
    PRINT "CONTROLLER SETUP"
    LOCATE 28, 25
    PRINT "RANKINGS (MUST EDIT USER.TXT)"
    LOCATE 34, 25
    PRINT "EXIT"

    DO
        _DEST UI&
        _LIMIT 30

        IF Controler.Enabled = 1 THEN CALL ReadController

        IF Flash = 1 THEN
            Counter = Counter + 1

            IF Counter = MaxCount THEN
                IF SpriteNum = 2 THEN
                    SpriteNum = 1
                ELSE
                    SpriteNum = 2
                END IF

                Counts = Counts + 1
                Counter = 0
                IF Counts = 10 THEN Flash = 2
            END IF

        ELSEIF Flash = 2 THEN
            EXIT DO

        ELSEIF Settings.LockInput = 0 THEN
            IF _KEYDOWN(87) = -1 OR _KEYDOWN(119) = -1 OR ControllerInput.DpadV = -1 THEN
                Menu = Menu - 1
                IF Menu = 0 THEN Menu = 4
                CALL SoundBoard("Rupee", -1)
                Settings.LockInput = 1
                TIMER(MenuTimer) ON
            ELSEIF _KEYDOWN(83) = -1 OR _KEYDOWN(115) = -1 OR ControllerInput.DpadV = 1 THEN
                Menu = Menu + 1
                IF Menu = 5 THEN Menu = 1
                CALL SoundBoard("Rupee", -1)
                Settings.LockInput = 1
                TIMER(MenuTimer) ON
            END IF

            IF ControllerInput.Start = -1 OR _KEYDOWN(13) = -1 THEN Flash = 1
        END IF

        IF Menu = 1 THEN
            YLoc = 248
        ELSEIF Menu = 2 THEN
            YLoc = 342
        ELSEIF Menu = 3 THEN
            YLoc = 440
        ELSEIF Menu = 4 THEN
            YLoc = 538
        END IF

        LINE (XLoc - Size, 248 - Size)-(XLoc + Size, 548 + Size), _RGB(0, 0, 0), BF
        _PUTIMAGE (XLoc - Size, YLoc - Size)-(XLoc + Size, YLoc + Size), HeartSprites(SpriteNum), UI&

        _PUTIMAGE , UI&, Display&

    LOOP




    IF Menu = 1 THEN
        Player1.Health = 6
        Settings.Alpha = 0
        CALL KillAllSprites
        ActiveFile$ = "Start32.msz" 'Start32
        CALL TransitionMap(ActiveFile$, 10)
        'CALL LoadMap(ActiveFile$, 1)
        'CALL DrawMap(Scene&, Foreground&, 0)
        CALL SetStartPos(1, 1)
        CALL DrawWalls
        CALL SpawnSpriteMatrix(0)
        CALL DrawUI
    ELSEIF Menu = 2 THEN
        _DEST Display&
        CLS
        CALL SetupController
        GOTO MenuStart

    ELSEIF Menu = 3 THEN
        _DEST Display&
        CLS
        CALL DisplayRankings
        GOTO MenuStart

    ELSE
        CALL EndCredits
    END IF

END SUB


'*********************************************************
'* Displays the leaderboard for speedrunning
'*
'*
'*********************************************************

SUB DisplayRankings

    _DEST UI&
    CLS
    _FONT Settings.Font
    COLOR _RGB(255, 255, 255)
    LOCATE 16, 15
    PRINT "Top 10 of 20 on server"
    PRINT
    LOCATE , 15
    PRINT "Name", ,"Time"
    PRINT

    FOR x = 1 TO 10
        LOCATE ,15
        PRINT LeaderBoard(x).User, LeaderBoard(x).Score
        PRINT
    NEXT x
    LOCATE ,15
    PRINT "Hit TAB to return."

    _PUTIMAGE , UI&, Display&

    DO
        _LIMIT 5

    LOOP UNTIL _KEYDOWN(9) = -1
END SUB



'*********************************************************
'* Gameover screen
'*
'*
'*********************************************************
SUB GameOver
    Settings.GameOver = 0
    Menu = 1
    Size = 10
    XLoc = 390
    YLoc = 310
    MaxCount = 2
    SpriteNum = 2
    TIMER(GameOverTimer) OFF
    CALL JukeBox(-1)
    CALL JukeBox(5)
    _DEST UI&
    CLS
    _FONT Settings.Font
    LOCATE 20, 25
    PRINT "CONTINUE"
    LOCATE 27, 25
    PRINT "EXIT"

    DO
        _DEST UI&
        _LIMIT 30

        IF Controller.Enabled = 1 THEN CALL ReadController

        IF Flash = 1 THEN
            Counter = Counter + 1

            IF Counter = MaxCount THEN
                IF SpriteNum = 2 THEN
                    SpriteNum = 1
                ELSE
                    SpriteNum = 2
                END IF

                Counts = Counts + 1
                Counter = 0
                IF Counts = 10 THEN Flash = 2
            END IF
        ELSEIF Flash = 2 THEN
            EXIT DO
        ELSE
            IF _KEYDOWN(87) = -1 OR _KEYDOWN(119) = -1 OR ControllerInput.DpadV = -1 THEN
                YLoc = 310
                CALL SoundBoard("Shield", -1)
                Menu = 1
            ELSEIF _KEYDOWN(83) = -1 OR _KEYDOWN(115) = -1 OR ControllerInput.DpadV = 1 THEN
                YLoc = 423
                CALL SoundBoard("Shield", -1)
                Menu = 2
            END IF

            IF ControllerInput.Start = -1 OR _KEYDOWN(13) = -1 THEN Flash = 1
        END IF

        LINE (XLoc - Size, 310 - Size)-(XLoc + Size, 423 + Size), _RGB(0, 0, 0), BF
        _PUTIMAGE (XLoc - Size, YLoc - Size)-(XLoc + Size, YLoc + Size), HeartSprites(SpriteNum), UI&

        CALL AssembleDisplay
        CALL CheckForAudioLoop

    LOOP

    IF Menu = 1 THEN
        Player1.Health = 6
        Settings.Alpha = 0
        FOR x = 1 TO Settings.ClearedArraySize
            ClearedArray(x) = "Junk"
        NEXT x
        CALL LoadContinuePoint
        CALL SetStartPos(1, 1)
        CALL DrawWalls
        CALL SpawnSpriteMatrix(0)
        CALL DrawUI
    ELSE
        Settings.MainMenu = 1
        Settings.Intro = 1
        Player1.Health = 6
        Settings.Alpha = 0
        FOR x = 1 TO Settings.ClearedArraySize
            ClearedArray(x) = "Junk"
        NEXT x
        CALL KillAllSprites


    END IF
END SUB



'*********************************************************
'* Called by gameover screen to return the player to the
'* proper zone
'*
'*********************************************************

SUB LoadContinuePoint
    IF Settings.Debug > 0 THEN CALL PrintConsole("Engine -> Continue point set to: " + ActiveMap.Name, 1)

    IF RTRIM$(ActiveMap.Name) = "Level-1" THEN
        CALL TransitionMap("L1" + Settings.MapExtension, 10)
    ELSEIF RTRIM$(ActiveMap.Name) = "Level-2" THEN
        CALL TransitionMap("Level2" + Settings.MapExtension, 10)
    ELSEIF RTRIM$(ActiveMap.Name) = "Level-3" THEN
        CALL TransitionMap("L3" + Settings.MapExtension, 10)
    ELSEIF RTRIM$(ActiveMap.Name) = "Level-4" THEN
        CALL TransitionMap("L4" + Settings.MapExtension, 10)
    ELSEIF RTRIM$(ActiveMap.Name) = "Level-5" THEN
        CALL TransitionMap("L5" + Settings.MapExtension, 10)
    ELSEIF RTRIM$(ActiveMap.Name) = "Level-6" THEN
        CALL TransitionMap("L6" + Settings.MapExtension, 10)
    ELSEIF RTRIM$(ActiveMap.Name) = "Level-7" THEN
        CALL TransitionMap("L7" + Settings.MapExtension, 10)
    ELSEIF RTRIM$(ActiveMap.Name) = "Level-8" THEN
        CALL TransitionMap("Level8" + Settings.MapExtension, 10)
    ELSEIF RTRIM$(ActiveMap.Name) = "Level-9" THEN
        CALL TransitionMap("L9" + Settings.MapExtension, 10)
    ELSE
        CALL TransitionMap("Start32" + Settings.MapExtension, 10)
    END IF
END SUB



SUB EndCredits
    _FULLSCREEN _OFF
    CLS
    SCREEN 0
    SCREEN 12
    COLOR 14, 4
    PRINT "                    Developed by ";
    COLOR 14, 1
    PRINT "Craz1000";
    COLOR 14, 4
    PRINT " 2020 - 2021                           "
    COLOR 15, 4
    PRINT "                                                                                "
    PRINT "Downloaded from http://Craz1000.net                                             "
    PRINT "Source code available there too                                                 "
    PRINT "Programmed and compiled with QB64                                               "
    PRINT "                                                                                "
    PRINT "Thanks to:                                                                      "
    PRINT "bplus for the code used to convert screen to black and white                    "
    PRINT "Petr for the code used to swap colors on the sprites                            "
    PRINT "                                                                                "
    PRINT "EMAIL: Uaeladen@gmail.com                                                       "
    PRINT "WEB: http://Craz1000.net                                                        "
    PRINT "                                                                                "
    COLOR 15, 0
    PRINT "                                                                                "
    END
END SUB

