'*********************************************************
'* Main code for Arrows
'*
'*
'*********************************************************

SUB ArrowMain (x)
    Projectile(x).XPos = Projectile(x).XPos + Projectile(x).MoveX
    Projectile(x).YPos = Projectile(x).YPos + Projectile(x).MoveY

    IF Projectile(x).XPos < Settings.LeftLimit - 20 OR Projectile(x).XPos < 0 THEN CALL KillProjectile(x)
    IF Projectile(x).XPos > Settings.RightLimit + 20 OR Projectile(x).XPos > Settings.RezX THEN CALL KillProjectile(x)
    IF Projectile(x).YPos < Settings.TopLimit - 20 OR Projectile(x).YPos < 200 THEN CALL KillProjectile(x)
    IF Projectile(x).YPos > Settings.BottomLimit + 20 OR Projectile(x).YPos > Settings.RezY THEN CALL KillProjectile(x)

    CALL ProjectileCollision(x)

    IF Projectile(x).Active = 1 THEN
        IF Projectile(x).Direction = 1 OR Projectile(x).Direction = 3 THEN _PUTIMAGE (Projectile(x).XPos - Projectile(x).Size, Projectile(x).YPos - (Projectile(x).Size * 4))-(Projectile(x).XPos + Projectile(x).Size, Projectile(x).YPos + (Projectile(x).Size * 4)), ArrowSprites&(Projectile(x).Direction, Projectile(x).Frame), Sprites&
        IF Projectile(x).Direction = 2 OR Projectile(x).Direction = 4 THEN _PUTIMAGE (Projectile(x).XPos - (Projectile(x).Size * 4), Projectile(x).YPos - Projectile(x).Size)-(Projectile(x).XPos + (Projectile(x).Size * 4), Projectile(x).YPos + Projectile(x).Size), ArrowSprites&(Projectile(x).Direction, Projectile(x).Frame), Sprites&
    END IF
END SUB


'*********************************************************
'* Sub CollectableSilverArrow (x)
'*
'* Silver arrow collectable
'*********************************************************
SUB CollectableSilverArrow (x)
    IF Special(x).Stage = 1 THEN
        Special(x).Stage = 2
        CALL Fanfare(x, 1)

    ELSEIF Special(x).Stage = 2 THEN
        Special(x).Counter = Special(x).Counter + 1
        IF Special(x).Counter = Special(x).MaxCount THEN
            Player1.SilverArrow = 1
            CALL KillSpecialSprite(x)
            CALL Fanfare(x, -1)
            CALL DeleteSprite(Special(x).Master)
            CALL SaveGame("Arrow Upgrade")
        END IF
    END IF

    _PUTIMAGE (Special(x).XPos - (Special(x).Size / 2), Special(x).YPos - Special(x).Size)-(Special(x).XPos + (Special(x).Size / 2), Special(x).YPos + Special(x).Size), ArrowSprites(1, 3), Sprites&
    _DEST Collision&
    LINE (Special(x).XPos - Special(x).Size, Special(x).YPos - Special(x).Size)-(Special(x).XPos + Special(x).Size, Special(x).YPos + Special(x).Size), _RGB(60, 0, x), BF
END SUB


'************************************************************
'* SUB ArrowCode
'*
'* Checks if player has enough rupees and if so spawns the appropriate arrow
'************************************************************
SUB ArrowCode
    IF Player1.Cash > 0 THEN
        IF Player1.SilverArrow = 1 THEN
            CALL SpawnSprite("BArro", Player1.XPos, Player1.YPos, Player1.Direction, 0, 0, 1)
        ELSE
            CALL SpawnSprite("RArro", Player1.XPos, Player1.YPos, Player1.Direction, 0, 0, 1)
        END IF
        Settings.ModifyCash = Settings.ModifyCash - 1
        CALL SoundBoard("Boomerang", -1)
    END IF
    Player1.Attacking = 0
    Player1.LockSecondary = 1
END SUB