'*********************************************************
'* SUB BombableRockMain (x)
'*
'* Main code for bombable rocks
'*********************************************************

SUB BombableRockMain (x)
    IF Special(x).Stage = 0 THEN
        CALL RockCollision(x)

    ELSEIF Special(x).Stage = 1 THEN
        Special(x).Stage = 2
        CALL SpawnSprite("Cloud", Special(x).XPos, Special(x).YPos, 0, x, 0, 1)

    ELSEIF Special(x).Stage = 3 THEN
        MatrixX = GetMatrixX(x, 3)
        MatrixY = GetMatrixY(x, 3)
        SpriteMatrix(MatrixX, MatrixY) = 111
        CALL KillSpecialSprite(x)
        CALL DrawMap(Scene&, Foreground&, 2, 0)
        CALL SoundBoard("Secret", -1)
        CALL SaveMap
    END IF
END SUB


'*********************************************************
'* RockCollision
'*
'* Used to check if bomb went off nearby
'*********************************************************
SUB RockCollision (SpriteNum)
    IF Special(SpriteNum).Stage = 0 THEN
        _SOURCE Collision&

        Point1& = POINT(Special(SpriteNum).XPos, Special(SpriteNum).YPos - SpriteHeight)
        Point2& = POINT(Special(SpriteNum).XPos + SpriteWidth, Special(SpriteNum).YPos)
        Point3& = POINT(Special(SpriteNum).XPos, Special(SpriteNum).YPos + SpriteHeight)
        Point4& = POINT(Special(SpriteNum).XPos - SpriteWidth, Special(SpriteNum).YPos)

        IF Settings.Debug <> 0 THEN
            _DEST DebugScreen&

            LINE (Special(SpriteNum).XPos - Special(SpriteNum).SizeW, Special(SpriteNum).YPos - Special(SpriteNum).SizeH)-(Special(SpriteNum).XPos + Special(SpriteNum).SizeW, Special(SpriteNum).YPos + Special(SpriteNum).SizeH), _RGB(255, 0, 255), B
            CIRCLE (Special(SpriteNum).XPos, Special(SpriteNum).YPos - SpriteHeight), 5, _RGB(255, 0, 255)
            CIRCLE (Special(SpriteNum).XPos + SpriteWidth, Special(SpriteNum).YPos), 5, _RGB(255, 0, 255)
            CIRCLE (Special(SpriteNum).XPos, Special(SpriteNum).YPos + SpriteHeight), 5, _RGB(255, 0, 255)
            CIRCLE (Special(SpriteNum).XPos - SpriteWidth, Special(SpriteNum).YPos), 5, _RGB(255, 0, 255)
        END IF

        IF _RED(Point1&) = 80 OR _RED(Point2&) = 80 OR _RED(Point3&) = 80 OR _RED(Point4&) = 80 THEN
            Special(SpriteNum).Stage = 1
        END IF
    END IF
END SUB