'*********************************************************
'* Boomerang code used by both Goriya and Link
'*
'*
'*********************************************************

SUB BoomerangMain (x)
    IF Projectile(x).Stage = 1 THEN
        Projectile(x).Counter = Projectile(x).Counter + 1
        IF Projectile(x).XPos < Settings.LeftLimit - 20 OR Projectile(x).XPos < 0 THEN Projectile(x).Stage = 2
        IF Projectile(x).XPos > Settings.RightLimit + 20 OR Projectile(x).XPos > Settings.RezX THEN Projectile(x).Stage = 2
        IF Projectile(x).YPos < Settings.TopLimit - 20 OR Projectile(x).YPos < 200 THEN Projectile(x).Stage = 2
        IF Projectile(x).YPos > Settings.BottomLimit + 20 OR Projectile(x).YPos > Settings.RezY THEN Projectile(x).Stage = 2
        IF Projectile(x).Name = "RBoom" AND Projectile(x).Counter = 50 THEN Projectile(x).Stage = 2
    ELSEIF Projectile(x).Stage = 2 THEN

        IF Projectile(x).Direction = 1 THEN
            Projectile(x).MoveY = Projectile(x).MoveY * -1
            Projectile(x).Direction = 3
        ELSEIF Projectile(x).Direction = 3 THEN
            Projectile(x).MoveY = Projectile(x).MoveY * -1
            Projectile(x).Direction = 1
        ELSEIF Projectile(x).Direction = 2 THEN
            Projectile(x).MoveX = Projectile(x).MoveX * -1
            Projectile(x).Direction = 4
        ELSE
            Projectile(x).MoveX = Projectile(x).MoveX * -1
            Projectile(x).Direction = 2
        END IF

        Projectile(x).Stage = 3

    ELSEIF Projectile(x).Stage = 3 THEN
        IF Projectile(x).PlayerSpawned = 0 THEN
            Projectile(x).Counter = Projectile(x).Counter - 1
            IF Projectile(x).Counter = 0 THEN CALL KillProjectile(x): Sprites(Projectile(x).MobControl).Pause = 0
        ELSE

            Rise = Player1.YPos - Projectile(x).YPos
            Runn = Player1.XPos - Projectile(x).XPos

            Distance = SQR((Rise ^ 2) + (Runn ^ 2))
            DeltaY = (Rise / Distance) * Projectile(x).Speed
            DeltaX = (Runn / Distance) * Projectile(x).Speed

            Projectile(x).MoveY = DeltaY
            Projectile(x).MoveX = DeltaX
        END IF
    END IF

    Projectile(x).XPos = Projectile(x).XPos + Projectile(x).MoveX
    Projectile(x).YPos = Projectile(x).YPos + Projectile(x).MoveY

    CALL ProjectileCollision(x)
    Projectile(x).AnimationDelay = Projectile(x).AnimationDelay + 1

    IF Projectile(x).AnimationDelay = Projectile(x).MaxDelay THEN
        Projectile(x).AnimationDelay = 0
        Projectile(x).Frame = Projectile(x).Frame + 1
        IF Projectile(x).Frame = 9 THEN Projectile(x).Frame = 1
        IF Projectile(x).PlayerSpawned = 1 THEN
            IF Projectile(x).Frame = 1 OR Projectile(x).Frame = 5 THEN CALL SoundBoard("Boomerang", 0)
        END IF
        IF Player1.Attacking = 1 THEN Player1.Attacking = 0
    END IF


    IF Projectile(x).Active = 1 AND Projectile(x).Name = "RBoom" THEN _PUTIMAGE (Projectile(x).XPos - Projectile(x).Size, Projectile(x).YPos - Projectile(x).Size)-(Projectile(x).XPos + Projectile(x).Size, Projectile(x).YPos + Projectile(x).Size), BoomerangSprites(Projectile(x).Frame, 1), Sprites&
    IF Projectile(x).Active = 1 AND Projectile(x).Name = "BBoom" THEN _PUTIMAGE (Projectile(x).XPos - Projectile(x).Size, Projectile(x).YPos - Projectile(x).Size)-(Projectile(x).XPos + Projectile(x).Size, Projectile(x).YPos + Projectile(x).Size), BoomerangSprites(Projectile(x).Frame, 2), Sprites&
END SUB



'*********************************************************
'* SUB CollectableBoomerang (x)
'*
'* Code for collectable boomerang
'*********************************************************

SUB CollectableBoomerang (x)
    IF Special(x).Stage = 1 THEN
        Special(x).Stage = 2
        CALL Fanfare(x, 1)

    ELSEIF Special(x).Stage = 2 THEN
        Special(x).Counter = Special(x).Counter + 1
        IF Special(x).Counter = Special(x).MaxCount THEN
            IF Special(x).Name = "P-Bom" THEN
                Player1.Boomerang = 1
            ELSE
                Player1.Boomerang = 2
            END IF
            CALL KillSpecialSprite(x)
            CALL Fanfare(x, -1)
            CALL DeleteSprite(Special(x).Master)
            CALL SaveGame("Boomerang Upgrade")
        END IF

    END IF

    IF Special(x).Name = "P-Bom" THEN
        _PUTIMAGE (Special(x).XPos - Special(x).Size, Special(x).YPos - Special(x).Size)-(Special(x).XPos + Special(x).Size, Special(x).YPos + Special(x).Size), BoomerangSprites(1, 1), Sprites&
    ELSE
        _PUTIMAGE (Special(x).XPos - Special(x).Size, Special(x).YPos - Special(x).Size)-(Special(x).XPos + Special(x).Size, Special(x).YPos + Special(x).Size), BoomerangSprites(1, 2), Sprites&
    END IF

    _DEST Collision&
    DrawSize = Special(x).Size * 2
    LINE (Special(x).XPos - DrawSize, Special(x).YPos - DrawSize)-(Special(x).XPos + DrawSize, Special(x).YPos + DrawSize), _RGB(60, 0, x), BF
END SUB


'************************************************************
'* SUB BoomerangCode
'*
'* Called when player throws the boomerang, and spawns the
'* appropriate boomerang.
'************************************************************
SUB BoomerangCode
    Player1.Attacking = 0
    Player1.LockSecondary = 1

    IF Player1.Boomerang = 2 THEN
        CALL SpawnSprite("BBoom", Player1.XPos, Player1.YPos, Player1.Direction, 0, 0, 1)
    ELSE
        CALL SpawnSprite("RBoom", Player1.XPos, Player1.YPos, Player1.Direction, 0, 0, 1)
    END IF
END SUB
