'*********************************************************
'* Burnable tree's main code
'*
'*
'*********************************************************

SUB BurnableTreeMain (x)
    IF Projectile(x).Stage = 0 THEN
        CALL TreeCollision(x)

    ELSEIF Projectile(x).Stage = 1 THEN
        MatrixX = GetMatrixX(x, 2)
        MatrixY = GetMatrixY(x, 2)
        SpriteMatrix(MatrixX, MatrixY) = 145
        CALL KillProjectile(x)
        CALL DrawMap(Scene&, Foreground&, 2, 0)
        CALL SoundBoard("Secret", -1)
        CALL SaveMap
    END IF
END SUB




'*********************************************************
'* TreeCollision
'*
'* Used to detect if fire is nearby
'*********************************************************

SUB TreeCollision (SpriteNum)
    IF Projectile(SpriteNum).Stage = 0 THEN
        _SOURCE Collision&

        Point1& = POINT(Projectile(SpriteNum).XPos, Projectile(SpriteNum).YPos - SpriteHeight)
        Point2& = POINT(Projectile(SpriteNum).XPos + SpriteWidth, Projectile(SpriteNum).YPos)
        Point3& = POINT(Projectile(SpriteNum).XPos, Projectile(SpriteNum).YPos + SpriteHeight)
        Point4& = POINT(Projectile(SpriteNum).XPos - SpriteWidth, Projectile(SpriteNum).YPos)

        IF Settings.Debug <> 0 THEN
            _DEST DebugScreen&

            LINE (Projectile(SpriteNum).XPos - Projectile(SpriteNum).SizeW, Projectile(SpriteNum).YPos - Projectile(SpriteNum).SizeH)-(Projectile(SpriteNum).XPos + Projectile(SpriteNum).SizeW, Projectile(SpriteNum).YPos + Projectile(SpriteNum).SizeH), _RGB(255, 0, 255), B
            CIRCLE (Projectile(SpriteNum).XPos, Projectile(SpriteNum).YPos - SpriteHeight), 5, _RGB(255, 0, 255)
            CIRCLE (Projectile(SpriteNum).XPos + SpriteWidth, Projectile(SpriteNum).YPos), 5, _RGB(255, 0, 255)
            CIRCLE (Projectile(SpriteNum).XPos, Projectile(SpriteNum).YPos + SpriteHeight), 5, _RGB(255, 0, 255)
            CIRCLE (Projectile(SpriteNum).XPos - SpriteWidth, Projectile(SpriteNum).YPos), 5, _RGB(255, 0, 255)
        END IF

        IF _RED(Point1&) = 90 OR _RED(Point2&) = 90 OR _RED(Point3&) = 90 OR _RED(Point4&) = 90 THEN
            Projectile(SpriteNum).Stage = 1
        END IF
    END IF
END SUB