'*********************************************************
'* Main code for Flame. Either spawned by candle or wand
'*
'*
'*********************************************************

SUB FlameMain (x)
    IF Projectile(x).Stage = 0 AND Projectile(x).PlayerSpawned = 1 THEN
        CALL SoundBoard("Flame", -1)
        Projectile(x).Stage = 1
        IF Projectile(x).Direction = 1 THEN Projectile(x).YPos = Projectile(x).YPos - (Player1.Size * 2)
        IF Projectile(x).Direction = 2 THEN Projectile(x).XPos = Projectile(x).XPos + (Player1.Size * 2)
        IF Projectile(x).Direction = 3 THEN Projectile(x).YPos = Projectile(x).YPos + (Player1.Size * 2)
        IF Projectile(x).Direction = 4 THEN Projectile(x).XPos = Projectile(x).XPos - (Player1.Size * 2)
    END IF


    IF Projectile(x).Stage = 1 THEN
        IF Projectile(x).Counter = 0 THEN
            Projectile(x).Stage = 2
        ELSE
            Projectile(x).Counter = Projectile(x).Counter - 1
            Projectile(x).XPos = Projectile(x).XPos + Projectile(x).MoveX
            Projectile(x).YPos = Projectile(x).YPos + Projectile(x).MoveY

            IF Projectile(x).XPos < Settings.LeftLimit - 20 OR Projectile(x).XPos < 0 THEN Projectile(x).XPos = Projectile(x).XPos + Projectile(x).MoveX
            IF Projectile(x).XPos > Settings.RightLimit + 20 OR Projectile(x).XPos > Settings.RezX THEN Projectile(x).XPos = Projectile(x).XPos - Projectile(x).MoveX
            IF Projectile(x).YPos < Settings.TopLimit - 20 OR Projectile(x).YPos < 200 THEN Projectile(x).YPos = Projectile(x).YPos + Projectile(x).MoveY
            IF Projectile(x).YPos > Settings.BottomLimit + 20 OR Projectile(x).YPos > Settings.RezY THEN Projectile(x).YPos = Projectile(x).YPos - Projectile(x).MoveY
        END IF

    ELSEIF Projectile(x).Stage = 2 THEN
        IF Settings.BlackedOut = 1 THEN
            CALL TransitionMap(LTRIM$(RTRIM$(Settings.CurrentZone)) + Settings.MapExtension, 7)
            Settings.BlackedOut = 0
        END IF

        Projectile(x).Counter = Projectile(x).Counter + 1
        IF Projectile(x).Counter = 180 THEN
            IF Player1.Candle = 2 THEN Player1.LockCandle = 0

            Projectile(x).Stage = 3
            Projectile(x).Counter = 0
        END IF

    ELSE
        Projectile(x).Counter = Projectile(x).Counter + 1
        IF Projectile(x).Counter = 5 THEN KillProjectile (x)
    END IF


    IF Projectile(x).AnimationDelay = Projectile(x).MaxDelay THEN
        Projectile(x).AnimationDelay = 0
        Projectile(x).Frame = Projectile(x).Frame + 1
        IF Projectile(x).Frame = 3 THEN Projectile(x).Frame = 1
    ELSE
        Projectile(x).AnimationDelay = Projectile(x).AnimationDelay + 1
    END IF


    IF Projectile(x).Active = 1 THEN
        CALL ProjectileCollision2(x, Projectile(x).Stage)
        _PUTIMAGE (Projectile(x).XPos - Projectile(x).Size, Projectile(x).YPos - Projectile(x).Size)-(Projectile(x).XPos + Projectile(x).Size, Projectile(x).YPos + Projectile(x).Size), FlameSprites(Projectile(x).Frame), Sprites&
        _DEST Collision&
        IF Projectile(x).Stage < 3 THEN LINE (Projectile(x).XPos - Projectile(x).Size, Projectile(x).YPos - Projectile(x).Size)-(Projectile(x).XPos + Projectile(x).Size, Projectile(x).YPos + Projectile(x).Size), _RGB(70, 0, x), BF
        IF Projectile(x).Stage = 3 THEN LINE (Projectile(x).XPos - Projectile(x).Size, Projectile(x).YPos - Projectile(x).Size)-(Projectile(x).XPos + Projectile(x).Size, Projectile(x).YPos + Projectile(x).Size), _RGB(90, 50, x), BF
    END IF
END SUB




'*********************************************************
'* Flames that link can attack, ones around Zelda
'*
'*
'*********************************************************

SUB AttackableFire (x)
    IF Sprites(x).Hurt = 0 THEN
        Sprites(x).AnimationDelay = Sprites(x).AnimationDelay + 1

        IF Sprites(x).AnimationDelay = Sprites(x).MaxDelay THEN
            Sprites(x).AnimationDelay = 0
            Sprites(x).Frame = Sprites(x).Frame + 1
            IF Sprites(x).Frame = 3 THEN Sprites(x).Frame = 1
        END IF

        CALL MobCollision2(Sprites(x).XPos, Sprites(x).YPos, Sprites(x).Size, x)

        IF Sprites(x).Active = 1 THEN
            CALL ProjectileCollision2(x, Sprites(x).Stage)
            _PUTIMAGE (Sprites(x).XPos - Sprites(x).Size, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + Sprites(x).Size, Sprites(x).YPos + Sprites(x).Size), FlameSprites(Sprites(x).Frame), Sprites&
            _DEST Collision&
            LINE (Sprites(x).XPos - Sprites(x).Size, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + Sprites(x).Size, Sprites(x).YPos + Sprites(x).Size), _RGB(251, 0, x), BF
        END IF

    ELSE
        Sprites(x).Health = 0
    END IF
END SUB