
'*********************************************************
'* SUB CollectableFlute (x)
'*
'* Code for collectable flute
'*********************************************************

SUB CollectableFlute (x)
    IF Special(x).Stage = 1 THEN
        Special(x).Stage = 2
        CALL Fanfare(x, 1)

    ELSEIF Special(x).Stage = 2 THEN
        Special(x).Counter = Special(x).Counter + 1
        IF Special(x).Counter = Special(x).MaxCount THEN
            Player1.HaveFlute = 1
            CALL KillSpecialSprite(x)
            CALL Fanfare(x, -1)
            CALL DeleteSprite(Special(x).Master)
            CALL SaveGame("Flute Upgrade")
        END IF

    END IF

    _PUTIMAGE (Special(x).XPos - Special(x).Size, Special(x).YPos - Special(x).Size)-(Special(x).XPos + Special(x).Size, Special(x).YPos + Special(x).Size), FluteSprite, Sprites&
    _DEST Collision&
    LINE (Special(x).XPos - Special(x).Size, Special(x).YPos - Special(x).Size)-(Special(x).XPos + Special(x).Size, Special(x).YPos + Special(x).Size), _RGB(60, 0, x), BF
END SUB


'************************************************************
'* SUB FluteCode
'*
'* Called when flute is used. Checks if Digdogger is on screen
'* and if so breaks him apart.
'************************************************************
SUB FluteCode
    CALL SoundBoard("Flute", -1)
    Player1.Attacking = 0
    Player1.LockSecondary = 0
    Player1.PlayedFlute = 1
    FOR x = 1 TO Settings.MatrixSize
        IF Sprites(x).Name = "Digdo" THEN
            IF Sprites(x).Stage = 1 THEN Sprites(x).Stage = 2
            EXIT FOR
        END IF
    NEXT x
END SUB


'*********************************************************
'* SUB DryLakeMain (x)
'*
'* Code for water that dries with flute
'*********************************************************

SUB DryLakeMain (x)
    IF Special(x).Stage = 0 THEN
        IF Special(x).Name = "DLakS" THEN Special(x).Stage = 4
        IF Player1.PlayedFlute = 1 THEN Special(x).Stage = 1

    ELSEIF Special(x).Stage = 1 THEN
        Temp& = _COPYIMAGE(OverworldTile(Special(x).Frame + 21))
        Special(x).Counter = Special(x).Counter + 1
        _SETALPHA Special(x).Counter, , Temp&
        _CLEARCOLOR _RGB(255, 255, 255), Temp&
        _PUTIMAGE (Special(x).XPos - Special(x).SizeW, Special(x).YPos - Special(x).SizeH)-(Special(x).XPos + Special(x).SizeW, Special(x).YPos + Special(x).SizeH), Temp&, Sprites&
        _FREEIMAGE Temp&
        IF Special(x).Counter = 255 THEN Special(x).Stage = 2

    ELSEIF Special(x).Stage = 2 AND RIGHT$(Special(x).Name, 1) = "X" THEN
        FOR SpriteSwap = 97 TO 105
            CALL ReplaceSprite(Settings.SpriteDivider + SpriteSwap, Settings.SpriteDivider + (SpriteSwap - 75), 1)
        NEXT SpriteSwap
        CALL ReplaceSprite(Settings.SpriteDivider + 106, Settings.SpriteDivider + 107, 1)
        CALL SaveMap
        CALL DrawMap(Scene&, Foreground&, 0, 0)
        Special(x).Stage = 3
        CALL SoundBoard("Secret", -1)
        Special(x).Name = "DLakeS"
        Special(x).Stage = 4
    ELSEIF Special(x).Stage = 2 AND RIGHT$(Special(x).Name, 1) <> "X" THEN
        Special(x).Stage = 3

    ELSEIF Special(x).Stage = 3 THEN
        KillSpecialSprite (x)

    ELSEIF Special(x).Stage = 4 THEN
        _PUTIMAGE (Special(x).XPos - Special(x).SizeW, Special(x).YPos - Special(x).SizeH)-(Special(x).XPos + Special(x).SizeW, Special(x).YPos + Special(x).SizeH), OverworldTile(65), Sprites&
        _DEST Collision&
        LINE (Special(x).XPos - Special(x).SizeW, Special(x).YPos - Special(x).SizeH)-(Special(x).XPos + Special(x).SizeW, Special(x).YPos + Special(x).SizeH), _RGB(10, 0, 7), BF
    END IF
END SUB