'*********************************************************
'* Main Code for Gohma
'*
'*
'*********************************************************
SUB GohmaMain (x)
    IF Sprites(x).Stage = -1 THEN
        Sprites(x).Stage = 0
        CALL SoundBoard("", 4)
    END IF

    IF Sprites(x).Stage = 0 THEN
        Sprites(x).Counter = 0
        Sprites(x).Stage = 1
        Sprites(x).Direction = RandomGen(2, 1, "+", 0)
        Sprites(x).MaxCount = RandomGen(50, 50, "+", 0)
        Sprites(x).MoveX = Sprites(x).Speed
        Sprites(x).MoveY = 0
        IF Sprites(x).Direction = 2 THEN Sprites(x).MoveX = Sprites(x).MoveX * -1
        IF PercentChance(25) = 1 AND Sprites(x).Misc = 0 THEN Sprites(x).Misc = 1
        IF Sprites(x).Misc = 1 THEN Sprites(x).MaxDelay = 16
    END IF

    CALL MoveGohma(x)

    Sprites(x).Counter2 = Sprites(x).Counter2 + 1
    IF Sprites(x).Counter2 >= Sprites(x).MaxCount2 THEN
        Sprites(x).MaxCount2 = RandomGen(50, 50, "+", 0)
        Sprites(x).Counter2 = 0
    END IF

    Sprites(x).AnimationDelay = Sprites(x).AnimationDelay + 1

    IF Sprites(x).AnimationDelay >= Sprites(x).MaxDelay THEN
        Sprites(x).AnimationDelay = 0
        Sprites(x).Frame = Sprites(x).Frame + 1
    END IF

    IF Sprites(x).Misc > 0 THEN CALL EyeCode(x)

    IF Sprites(x).Misc = 1 OR Sprites(x).Misc = 3 THEN
        IF Sprites(x).Frame > 6 THEN Sprites(x).Frame = 5
    ELSEIF Sprites(x).Misc = 2 THEN
        IF Sprites(x).Frame = 9 THEN Sprites(x).Frame = 7
    ELSE
        IF Sprites(x).Frame > 4 THEN Sprites(x).Frame = 1
    END IF

    IF Sprites(x).Counter2 = 50 OR Sprites(x).Counter2 = 15 THEN CALL SpawnSprite("FireB", Sprites(x).XPos, Sprites(x).YPos, 0, 0, 0, 0)

    Sprites(x).XPos = Sprites(x).XPos + Sprites(x).MoveX
    Sprites(x).YPos = Sprites(x).YPos + Sprites(x).MoveY

    IF Sprites(x).Hurt = 0 THEN
        _PUTIMAGE (Sprites(x).XPos - (Sprites(x).Size * 3), Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + (Sprites(x).Size * 3), Sprites(x).YPos + Sprites(x).Size), GohmaSprites(Sprites(x).Frame, Sprites(x).Frame2), Sprites&
        _DEST Collision&
        LINE (Sprites(x).XPos - (Sprites(x).Size * 3), Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + (Sprites(x).Size * 3), Sprites(x).YPos + Sprites(x).Size), _RGB(255, 1, x), BF
        IF Sprites(x).Misc = 2 THEN LINE (Sprites(x).XPos - Sprites(x).Size, Sprites(x).YPos)-(Sprites(x).XPos + Sprites(x).Size, Sprites(x).YPos + Sprites(x).Size + 1), _RGB(252, 50, x), BF
    ELSE
        CALL MobHurt(x, GohmaSprites(Sprites(x).Frame, Sprites(x).Frame2), _RGB(104, 136, 255), 0, 0)
    END IF
END SUB


'************************************************************
'* SUB EyeCode
'*
'* Setus up and controls Gohma's eye
'************************************************************
SUB EyeCode (x)
    Sprites(x).Jumping = Sprites(x).Jumping + 1

    IF Sprites(x).Jumping >= Sprites(x).MaxDelay AND Sprites(x).Misc = 1 THEN
        Sprites(x).Misc = 2
        Sprites(x).Jumping = 0
        Sprites(x).Frame = 5
    ELSEIF Sprites(x).Jumping >= Sprites(x).MaxDelay * 10 AND Sprites(x).Misc = 2 THEN
        Sprites(x).Misc = 3
        Sprites(x).Jumping = 0
        Sprites(x).Frame = 7
    ELSEIF Sprites(x).Jumping >= Sprites(x).MaxDelay AND Sprites(x).Misc = 3 THEN
        Sprites(x).Misc = 0
        Sprites(x).Jumping = 0
        Sprites(x).MaxDelay = 8
    END IF
END SUB



'************************************************************
'* MoveGohma
'*
'* Special movement code just for Gohma. x is matrix position
'************************************************************
SUB MoveGohma (x)
    IF Sprites(x).Stage = 1 THEN
        Sprites(x).Counter = Sprites(x).Counter + 1
        IF Sprites(x).Counter = Sprites(x).MaxCount THEN
            IF PercentChance(10) = 1 THEN
                Sprites(x).Stage = 2
            ELSE
                Sprites(x).Stage = 0
            END IF
        END IF
        IF Sprites(x).XPos < Settings.LeftLimit + (Sprites(x).Size * 3) OR Sprites(x).XPos > Settings.RightLimit - (Sprites(x).Size * 3) THEN Sprites(x).MoveX = Sprites(x).MoveX * -1

    ELSEIF Sprites(x).Stage = 2 THEN
        Sprites(x).MoveX = 0
        Sprites(x).MoveY = Sprites(x).Speed
        Sprites(x).WalkTime = RandomGen(Player1.Size * 5, 0, "+", 0)
        Sprites(x).WalkAdd = 0
        Sprites(x).Stage = 3
        IF PercentChance(25) = 1 AND Sprites(x).Misc = 0 THEN Sprites(x).Misc = 1: Sprites(x).MaxDelay = 16

    ELSEIF Sprites(x).Stage = 3 THEN
        IF Sprites(x).YPos > Settings.BottomLimit - Sprites(x).Size OR Sprites(x).WalkAdd = Sprites(x).WalkTime THEN Sprites(x).MoveY = Sprites(x).MoveY * -1
        Sprites(x).WalkAdd = Sprites(x).WalkAdd + Sprites(x).MoveY
        IF Sprites(x).WalkAdd = 0 THEN Sprites(x).Stage = 0
    END IF
END SUB