'*********************************************************
'* Draws the regular hearts and hitbox so it can be collected
'*
'*
'*********************************************************
SUB DrawHeart (x)
    Sprites(x).AnimationDelay = Sprites(x).AnimationDelay + 1

    IF Sprites(x).AnimationDelay = Sprites(x).MaxDelay THEN
        Sprites(x).AnimationDelay = 0
        Sprites(x).Frame = Sprites(x).Frame + 1
        IF Sprites(x).Frame = 3 THEN Sprites(x).Frame = 1
    END IF

    _PUTIMAGE (Sprites(x).XPos - Sprites(x).Size, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + Sprites(x).Size, Sprites(x).YPos + Sprites(x).Size), HeartSprites(Sprites(x).Frame), Sprites&
    _DEST Collision&
    LINE (Sprites(x).XPos - (Sprites(x).Size * 2), Sprites(x).YPos - (Sprites(x).Size * 2))-(Sprites(x).XPos + (Sprites(x).Size * 2), Sprites(x).YPos + (Sprites(x).Size * 2)), _RGB(50, 20, x), BF
END SUB



'*********************************************************
'* SUB CollectableHeartContainer (x)
'*
'* Main code for when heart containers are collected
'*********************************************************

SUB CollectableHeartContainer (x)
    IF Special(x).Stage = 1 THEN
        Special(x).Stage = 2
        CALL Fanfare(x, 1)

    ELSEIF Special(x).Stage = 2 THEN
        Special(x).Counter = Special(x).Counter + 1
        IF Special(x).Counter = Special(x).MaxCount THEN
            Player1.MaxHealth = Player1.MaxHealth + 2
            Player1.Health = Player1.MaxHealth
            CALL KillSpecialSprite(x)
            CALL Fanfare(x, -1)
            CALL DeleteSprite(Special(x).Master)
            CALL SaveGame("Health Upgrade")
        END IF

    END IF

    _PUTIMAGE (Special(x).XPos - (Special(x).Size), Special(x).YPos - Special(x).Size)-(Special(x).XPos + (Special(x).Size), Special(x).YPos + Special(x).Size), HeartSprites(3), Sprites&
    _DEST Collision&
    LINE (Special(x).XPos - Special(x).Size, Special(x).YPos - Special(x).Size)-(Special(x).XPos + Special(x).Size, Special(x).YPos + Special(x).Size), _RGB(60, 0, x), BF
END SUB


'*********************************************************
'* Stays hidden until room is cleared. Then spawns heart container.
'*
'*
'*********************************************************

SUB HiddenHeartContainer (x)
    IF AreAllDead = 1 THEN
        CALL SpawnSprite("P-Hea", Special(x).XPos, Special(x).YPos, 0, 53, 0, 0)
        CALL ReplaceSprite(76, 53, 0)
        CALL KillSpecialSprite(x)
        CALL SoundBoard("Key", 0)
    END IF
END SUB