'*********************************************************
'* Main code for the moveable blocks
'*
'*
'*********************************************************

SUB MoveableBlockMain (x)
    IF Special(x).Stage = 0 THEN
        IF AreAllDead = 1 THEN CALL BlockCollision(x)
        IF Special(x).Counter = Special(x).MaxCount THEN Special(x).Stage = 1

    ELSEIF Special(x).Stage = 1 THEN
        Special(x).Stage = 2
        IF Special(x).Direction = 1 THEN Special(x).Counter = Settings.SquareHeight: Special(x).MoveY = Special(x).Speed * -1
        IF Special(x).Direction = 2 THEN Special(x).Counter = Settings.SquareWidth: Special(x).MoveX = Special(x).Speed
        IF Special(x).Direction = 3 THEN Special(x).Counter = Settings.SquareHeight: Special(x).MoveY = Special(x).Speed
        IF Special(x).Direction = 4 THEN Special(x).Counter = Settings.SquareWidth: Special(x).MoveX = Special(x).Speed * -1

    ELSEIF Special(x).Stage = 2 THEN
        Special(x).XPos = Special(x).XPos + Special(x).MoveX
        Special(x).YPos = Special(x).YPos + Special(x).MoveY
        Special(x).Counter = Special(x).Counter - 1
        IF Special(x).Counter = 0 THEN Special(x).Stage = 3

    ELSEIF Special(x).Stage = 3 THEN
        IF Special(x).Name = "SBloc" THEN
            Special(x).Stage = 0
            Special(x).MoveX = 0
            Special(x).MoveY = 0
        ELSE
            Special(x).Stage = 4
            CALL CheckLockdown(1)
            Settings.ShowStairs = 1
        END IF
    END IF


    _DEST Collision&
    Settings.BlockTrigger = x
    LINE (Special(x).XPos - Special(x).SizeW + 1, Special(x).YPos - Special(x).SizeH + 1)-(Special(x).XPos + Special(x).SizeW - 1, Special(x).YPos + Special(x).SizeH - 1), _RGB(20, 0, x), BF
END SUB



'*********************************************************
'* BlockCollision
'*
'* Used to detect if link is near a movable block
'* SpriteNum - Location in object matrix
'*********************************************************
SUB BlockCollision (SpriteNum)
    _SOURCE Collision&

    SpriteWidth = (Settings.SquareWidth / 2) - 1
    SpriteHeight = (Settings.SquareHeight / 2) - 1

    Point1& = POINT(Special(SpriteNum).XPos, Special(SpriteNum).YPos - SpriteHeight - 5)
    Point2& = POINT(Special(SpriteNum).XPos + SpriteWidth + 5, Special(SpriteNum).YPos)
    Point3& = POINT(Special(SpriteNum).XPos, Special(SpriteNum).YPos + SpriteHeight + 5)
    Point4& = POINT(Special(SpriteNum).XPos - SpriteWidth - 5, Special(SpriteNum).YPos)

    IF Settings.Debug <> 0 THEN
        _DEST DebugScreen&
        CIRCLE (Special(SpriteNum).XPos, Special(SpriteNum).YPos - SpriteHeight - 5), 5, _RGB(255, 0, 255)
        CIRCLE (Special(SpriteNum).XPos + SpriteWidth + 5, Special(SpriteNum).YPos), 5, _RGB(255, 0, 255)
        CIRCLE (Special(SpriteNum).XPos, Special(SpriteNum).YPos + SpriteHeight + 5), 5, _RGB(255, 0, 255)
        CIRCLE (Special(SpriteNum).XPos - SpriteWidth - 5, Special(SpriteNum).YPos), 5, _RGB(255, 0, 255)
        _DEST Sprites&
    END IF

    IF _GREEN(Point1&) = 254 THEN
        IF _RED(POINT(Special(SpriteNum).XPos, Special(SpriteNum).YPos + (SpriteHeight * 2))) <> 20 THEN
            Special(SpriteNum).Counter = Special(SpriteNum).Counter + 1
            Special(SpriteNum).Direction = 3
        END IF

    ELSEIF _GREEN(Point2&) = 254 THEN
        IF _RED(POINT(Special(SpriteNum).XPos - (SpriteHeight * 2), Special(SpriteNum).YPos)) <> 20 THEN
            Special(SpriteNum).Counter = Special(SpriteNum).Counter + 1
            Special(SpriteNum).Direction = 4
        END IF

    ELSEIF _GREEN(Point3&) = 254 THEN
        IF _RED(POINT(Special(SpriteNum).XPos, Special(SpriteNum).YPos - (SpriteHeight * 2))) <> 20 THEN
            Special(SpriteNum).Counter = Special(SpriteNum).Counter + 1
            Special(SpriteNum).Direction = 1
        END IF

    ELSEIF _GREEN(Point4&) = 254 THEN
        IF _RED(POINT(Special(SpriteNum).XPos + (SpriteHeight * 2), Special(SpriteNum).YPos)) <> 20 THEN
            Special(SpriteNum).Counter = Special(SpriteNum).Counter + 1
            Special(SpriteNum).Direction = 2
        END IF
    END IF
END SUB


'*********************************************************
'* DrawBlock
'*
'* Used to make sure block is on top of everything on the screen
'*********************************************************
SUB DrawBlock
    _PUTIMAGE (Special(Settings.BlockTrigger).XPos - Special(Settings.BlockTrigger).SizeW + 1, Special(Settings.BlockTrigger).YPos - Special(Settings.BlockTrigger).SizeH + 1)-(Special(Settings.BlockTrigger).XPos + Special(Settings.BlockTrigger).SizeW - 1, Special(Settings.BlockTrigger).YPos + Special(Settings.BlockTrigger).SizeH - 1), DungTile(Special(Settings.BlockTrigger).Frame, ActiveMap.SubType), Sprites&
    Settings.BlockTrigger = 0
END SUB