
'*********************************************************
'* Code for Red Wizzrobe
'*
'*
'*********************************************************
SUB RedWizzrobeMain (x)
    IF Sprites(x).Stage = 0 THEN
        Sprites(x).YPos = RandomGen((Settings.BottomLimit - Sprites(x).Size) - Settings.TopLimit, Settings.TopLimit, "+", 0)
        Sprites(x).XPos = RandomGen((Settings.RightLimit - Sprites(x).Size) - Settings.LeftLimit, Settings.LeftLimit, "+", 0)
        Sprites(x).Direction = RandomGen(4, 1, "+", 0)
        Sprites(x).Counter = 0
        Sprites(x).MaxCount = 255
        IF CheckIfCanTeleport(x, 0, 0, 0) = 1 THEN Sprites(x).Stage = 1

    ELSEIF Sprites(x).Stage = 1 THEN
        Sprites(x).Counter = Sprites(x).Counter + 5
        CALL MobCollision2(Sprites(x).XPos, Sprites(x).YPos, Sprites(x).Size, x)
        IF Sprites(x).Hurt = 0 THEN
            Temp& = _COPYIMAGE(WizzrobeSprites(Sprites(x).Direction, Sprites(x).Frame), 32)
            _SOURCE Temp&
            _SETALPHA Sprites(x).Counter, , Temp&
            Clr& = POINT(0, 0)
            _CLEARCOLOR Clr&, Temp&
            _PUTIMAGE (Sprites(x).XPos - Sprites(x).Size, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + Sprites(x).Size, Sprites(x).YPos + Sprites(x).Size), Temp&, Sprites&
            _FREEIMAGE Temp&
        ELSE
            CALL MobHurt(x, WizzrobeSprites(Sprites(x).Direction, Sprites(x).Frame), _RGB(255, 160, 68), 0, 0)
        END IF

        _DEST Collision&
        LINE (Sprites(x).XPos - Sprites(x).Size, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + Sprites(x).Size, Sprites(x).YPos + Sprites(x).Size), _RGB(255, 1, x), BF

        IF Sprites(x).Counter = Sprites(x).MaxCount THEN
            Sprites(x).Stage = 2
            Sprites(x).Counter = 0
            Sprites(x).MaxCount = 90
            Sprites(x).Hurt = 0
        END IF

    ELSEIF Sprites(x).Stage = 2 THEN
        IF Sprites(x).AnimationDelay = Sprites(x).MaxDelay THEN
            Sprites(x).AnimationDelay = 0
            IF Sprites(x).Frame = 1 THEN
                Sprites(x).Frame = 2
            ELSE
                Sprites(x).Frame = 1
            END IF
        ELSE
            Sprites(x).AnimationDelay = Sprites(x).AnimationDelay + 1
        END IF

        CALL MobCollision2(Sprites(x).XPos, Sprites(x).YPos, Sprites(x).Size, x)
        Sprites(x).Counter = Sprites(x).Counter + 1
        IF Sprites(x).Counter = 40 THEN CALL SpawnSprite("Magic", Sprites(x).XPos, Sprites(x).YPos, Sprites(x).Direction, 0, 0, 0)
        IF Sprites(x).Counter = Sprites(x).MaxCount THEN
            Sprites(x).Stage = 3
            Sprites(x).Counter = 255
            Sprites(x).Hurt = 0
        END IF

        IF Sprites(x).Hurt = 0 THEN
            _DEST Sprites&
            _PUTIMAGE (Sprites(x).XPos - Sprites(x).Size, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + Sprites(x).Size, Sprites(x).YPos + Sprites(x).Size), WizzrobeSprites(Sprites(x).Direction, Sprites(x).Frame), Sprites&
            _DEST Collision&
            LINE (Sprites(x).XPos - Sprites(x).Size, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + Sprites(x).Size, Sprites(x).YPos + Sprites(x).Size), _RGB(254, 1, x), BF
        ELSE
            CALL MobHurt(x, WizzrobeSprites(Sprites(x).Direction, Sprites(x).Frame), _RGB(255, 160, 68), 0, 0)
        END IF

    ELSEIF Sprites(x).Stage = 3 THEN
        Sprites(x).Counter = Sprites(x).Counter - 5
        CALL MobCollision2(Sprites(x).XPos, Sprites(x).YPos, Sprites(x).Size, x)
        Temp& = _COPYIMAGE(WizzrobeSprites(Sprites(x).Direction, Sprites(x).Frame), 32)
        _SOURCE Temp&
        _SETALPHA Sprites(x).Counter, , Temp&
        Clr& = POINT(0, 0)
        _CLEARCOLOR Clr&, Temp&

        IF Sprites(x).Hurt = 0 THEN
            _DEST Sprites&
            _PUTIMAGE (Sprites(x).XPos - Sprites(x).Size, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + Sprites(x).Size, Sprites(x).YPos + Sprites(x).Size), Temp&, Sprites&
        ELSE
            CALL MobHurt(x, WizzrobeSprites(Sprites(x).Direction, Sprites(x).Frame), _RGB(255, 160, 68), 0, 0)
        END IF
        _FREEIMAGE Temp&

        _DEST Collision&
        LINE (Sprites(x).XPos - Sprites(x).Size, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + Sprites(x).Size, Sprites(x).YPos + Sprites(x).Size), _RGB(254, 1, x), BF

        IF Sprites(x).Counter = Sprites(x).MaxCount THEN
            Sprites(x).Stage = 4
            Sprites(x).Counter = 0
            Sprites(x).MaxCount = RandomGen(50, 100, "+", 0)
            Sprites(x).Hurt = 0
        END IF

    ELSEIF Sprites(x).Stage = 4 THEN
        Sprites(x).Counter = Sprites(x).Counter + 1
        IF Sprites(x).Counter = Sprites(x).MaxCount THEN Sprites(x).Stage = 0
    END IF
END SUB






'*********************************************************
'* Code for Blue Wizzrobe
'*
'*
'*********************************************************

SUB BlueWizzrobeMain (x)
    Direction = Sprites(x).Direction
    IF Direction > 4 THEN Direction = Direction - 4
    Temp& = _COPYIMAGE(WizzrobeSprites(Direction + 4, Sprites(x).Frame))

    IF Sprites(x).Stage = 0 THEN
        CALL MoveMob(4, x, Sprites(x).WalkTime, Sprites(x).WalkAdd, 1)
        IF PercentChance(1) = 1 AND Sprites(x).Attacking = 0 THEN Sprites(x).Stage = 1
    ELSEIF Sprites(x).Stage = 1 THEN
        Sprites(x).Speed = 4
        Sprites(x).Counter = 0
        Sprites(x).MaxCount = 0
        Sprites(x).WalkTime = 70
        Sprites(x).WalkAdd = 50
        Sprites(x).Stage = 2
        Sprites(x).Attacking = 0

    ELSEIF Sprites(x).Stage = 2 THEN
        CALL MoveMob(8, x, Sprites(x).WalkTime, Sprites(x).WalkAdd, 0)
        IF Sprites(x).Counter = Sprites(x).MaxCount THEN Sprites(x).Stage = 3
        _SOURCE Temp&
        _SETALPHA 128, , Temp&
        Clr& = POINT(0, 0)
        _CLEARCOLOR Clr&, Temp&

    ELSEIF Sprites(x).Stage = 3 THEN
        IF CheckIfCanTeleport(x, 0, 0, 0) = 1 THEN
            Sprites(x).Speed = 2
            Sprites(x).Counter = 0
            Sprites(x).MaxCount = RandomGen(50, 30, "+", 0)
            Sprites(x).Direction = RandomGen(4, 1, "+", Sprites(x).Direction)
            Sprites(x).WalkTime = 50
            Sprites(x).WalkAdd = 30
            Sprites(x).Stage = 0
        ELSE
            Sprites(x).Stage = 1
        END IF
    END IF

    IF Sprites(x).Attacking = 1 AND Sprites(x).HP = 0 THEN
        TIMER(WizzFireTimer) ON
        Sprites(x).HP = 1
    ELSEIF Sprites(x).Attacking = 0 AND Sprites(x).HP = 1 THEN
        Sprites(x).HP = 0
        TIMER(WizzFireTimer) OFF
    END IF

    IF Sprites(x).AnimationDelay = Sprites(x).MaxDelay THEN
        Sprites(x).AnimationDelay = 0
        IF Sprites(x).Frame = 1 THEN
            Sprites(x).Frame = 2
        ELSE
            Sprites(x).Frame = 1
        END IF
    ELSE
        Sprites(x).AnimationDelay = Sprites(x).AnimationDelay + 1
    END IF

    IF Sprites(x).Hurt = 0 THEN
        _PUTIMAGE (Sprites(x).XPos - Sprites(x).Size, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + Sprites(x).Size, Sprites(x).YPos + Sprites(x).Size), Temp&, Sprites&
        _DEST Collision&
        LINE (Sprites(x).XPos - Sprites(x).Size, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + Sprites(x).Size, Sprites(x).YPos + Sprites(x).Size), _RGB(254, 1, x), BF
    ELSE
        CALL MobHurt(x, WizzrobeSprites(Sprites(x).Direction + 4, Sprites(x).Frame), _RGB(104, 136, 255), 0, 0)
    END IF

    _FREEIMAGE Temp&
END SUB



'************************************************************
'* SUB WizzFire
'*
'* When WhizzRhobe timer goes off, this is ran to check if any.
'* Blue whizzrhobes are attacking and spawns the wave attack.
'************************************************************
SUB WizzFire
    FOR x = 1 TO Settings.MatrixSize
        IF Sprites(x).Name = "BWizz" AND Sprites(x).Attacking = 1 AND Sprites(x).Health > 0 THEN
            CALL SpawnSprite("Magic", Sprites(x).XPos, Sprites(x).YPos, Sprites(x).Direction, 0, 0, 0)
        END IF
    NEXT x
END SUB