'*********************************************************
'* SpawnSprite.bi                        6/13/2021
'*
'* Sets all the initial vales when spawned, for every sprite
'*********************************************************


SUB SpawnSprite (Spawn$, XPos, YPos, Direction, MobControl, PatraLoc, Master)
    IF Spawn$ = "Sword" AND Attack(1).Active = 0 THEN
        Attack(1).Active = 1
        Attack(1).Direction = Player1.Direction
        Attack(1).XPos = XPos
        Attack(1).YPos = YPos
        Attack(1).Stage = 0
        Attack(1).Frame = Player1.Sword
        Attack(1).AnimationDelay = 0
        Attack(1).MaxDelay = 1
        Attack(1).MoveX = 0
        Attack(1).MoveY = 0
        Attack(1).Counter = 0
        Attack(1).MaxCount = 2
        Attack(1).Speed = 12

        IF Attack(1).Direction = 1 THEN Attack(1).MoveY = -3: Attack(1).YPos = Attack(1).YPos - Attack(1).Speed
        IF Attack(1).Direction = 2 THEN Attack(1).MoveX = 3: Attack(1).XPos = Attack(1).XPos + Attack(1).Speed
        IF Attack(1).Direction = 3 THEN Attack(1).MoveY = 3: Attack(1).YPos = Attack(1).YPos + Attack(1).Speed
        IF Attack(1).Direction = 4 THEN Attack(1).MoveX = -3: Attack(1).XPos = Attack(1).XPos - Attack(1).Speed
        IF Settings.Debug > 2 THEN CALL PrintConsole("World -> Spawning sword facing direction:" + STR$(Attack(1).Direction), 3)

    ELSEIF Spawn$ = "Wand" THEN
        MatrixPos = EmptyProjectile(0)
        Player1.Attacking = 1
        Player1.LockSecondary = 1
        Projectile(MatrixPos).Active = 1
        Projectile(MatrixPos).Name = Spawn$
        Projectile(MatrixPos).Direction = Player1.Direction
        Projectile(MatrixPos).XPos = XPos
        Projectile(MatrixPos).YPos = YPos
        Projectile(MatrixPos).Stage = 0
        Projectile(MatrixPos).AnimationDelay = 0
        Projectile(MatrixPos).MaxDelay = 16

        IF Settings.Debug > 2 THEN CALL PrintConsole("World -> Spawning Wand facing direction:" + STR$(Projectile(MatrixPos).Direction), 3)


    ELSEIF Spawn$ = "FlyingSword" AND Attack(2).Active = 0 THEN
        Attack(2).Active = 1
        Attack(2).Direction = Attack(1).Direction
        Attack(2).XPos = XPos
        Attack(2).YPos = YPos
        Attack(2).Stage = 0
        Attack(2).Frame = 0
        Attack(2).AnimationDelay = 0
        Attack(2).MaxDelay = 1
        Attack(2).MoveX = 0
        Attack(2).MoveY = 0
        Attack(2).Counter = 0
        Attack(2).MaxCount = 2
        Attack(2).Speed = 10

        IF Attack(2).Direction = 1 THEN Attack(2).MoveY = Attack(2).Speed * -1
        IF Attack(2).Direction = 2 THEN Attack(2).MoveX = Attack(2).Speed
        IF Attack(2).Direction = 3 THEN Attack(2).MoveY = Attack(2).Speed
        IF Attack(2).Direction = 4 THEN Attack(2).MoveX = Attack(2).Speed * -1
        IF Settings.Debug > 2 THEN CALL PrintConsole("World -> Spawning sword projectile facing direction:" + STR$(Attack(2).Direction), 3)

    ELSEIF Spawn$ = "Spark" THEN
        FOR x = 1 TO 4
            MatrixPos = EmptySprite

            Sprites(MatrixPos).Active = 1
            Sprites(MatrixPos).Name = "Spark"
            Sprites(MatrixPos).Direction = x
            Sprites(MatrixPos).XPos = XPos
            Sprites(MatrixPos).YPos = YPos
            Sprites(MatrixPos).Frame = 1
            Sprites(MatrixPos).AnimationDelay = 0
            Sprites(MatrixPos).MaxDelay = 1
            Sprites(MatrixPos).Counter = 0
            Sprites(MatrixPos).MaxCount = 19
            Sprites(MatrixPos).Size = 12
            Sprites(MatrixPos).Health = 1
            Sprites(MatrixPos).Speed = 3

            IF x = 1 THEN
                Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
                Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
            ELSEIF x = 2 THEN
                Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
                Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
            ELSEIF x = 3 THEN
                Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
                Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
            ELSEIF x = 4 THEN
                Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
                Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
            END IF
        NEXT x
        IF Settings.Debug > 2 THEN CALL PrintConsole("World -> Spawning spark sprite", 3)

    ELSEIF Spawn$ = "Bomb" THEN
        Player1.Attacking = 1
        Player1.LockSecondary = 1
        Attack(3).Active = 1
        Attack(3).Direction = Player1.Direction
        Attack(3).XPos = XPos
        Attack(3).YPos = YPos
        Attack(3).Stage = 0
        Attack(3).MaxCount = 20
        Attack(3).MaxCount = 50
        Attack(3).Size = Player1.Size
        Attack(3).Counter = 0
        IF Settings.Debug > 2 THEN CALL PrintConsole("World -> Spawning player bomb", 3)



    ELSEIF Spawn$ = "ROcto" OR Spawn$ = "BOcto" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Damage = 1
        Sprites(MatrixPos).AnimationDelay = 0
        Sprites(MatrixPos).MaxDelay = 5
        Sprites(MatrixPos).MaxCount = RandomGen(50, 30, "+", 0)
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Speed = 2
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).HardCount = 1
        IF Spawn$ = "ROcto" THEN Sprites(MatrixPos).Frame = 1
        IF Spawn$ = "BOcto" THEN Sprites(MatrixPos).Frame = 3
        IF Spawn$ = "ROcto" THEN Sprites(MatrixPos).Health = 1
        IF Spawn$ = "BOcto" THEN Sprites(MatrixPos).Health = 2
        IF Spawn$ = "ROcto" THEN Sprites(MatrixPos).LootCategory = 1
        IF Spawn$ = "BOcto" THEN Sprites(MatrixPos).LootCategory = 2

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "Vire " THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).AnimationDelay = 0
        Sprites(MatrixPos).MaxDelay = 10
        Sprites(MatrixPos).MaxCount = RandomGen(50, 30, "+", 0)
        Sprites(MatrixPos).MaxCount2 = 30
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Speed = 2
        Sprites(MatrixPos).Health = 2
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).LootCategory = 2
        Sprites(MatrixPos).HardCount = 1
        Sprites(MatrixPos).MoveCheckBypass = 1

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "RGori" OR Spawn$ = "BGori" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).MaxDelay = 10
        Sprites(MatrixPos).MaxCount = RandomGen(50, 30, "+", 0)
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Speed = 2
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).HardCount = 1
        IF Spawn$ = "RGori" THEN Sprites(MatrixPos).Health = 3
        IF Spawn$ = "BGori" THEN Sprites(MatrixPos).Health = 5
        IF Spawn$ = "RGori" THEN Sprites(MatrixPos).Frame = 1
        IF Spawn$ = "BGori" THEN Sprites(MatrixPos).Frame = 3
        IF Spawn$ = "RGori" THEN Sprites(MatrixPos).LootCategory = 2
        IF Spawn$ = "BGori" THEN Sprites(MatrixPos).LootCategory = 4

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "OctoR" THEN
        MatrixPos = EmptyProjectile(0)
        Projectile(MatrixPos).Active = 1
        Projectile(MatrixPos).Direction = Direction
        Projectile(MatrixPos).Damage = 1
        Projectile(MatrixPos).MoveX = 0
        Projectile(MatrixPos).MoveY = 0
        Projectile(MatrixPos).Size = 12
        Projectile(MatrixPos).Name = Spawn$
        Projectile(MatrixPos).XPos = XPos
        Projectile(MatrixPos).YPos = YPos
        Projectile(MatrixPos).ShieldUpgrade = 0
        Projectile(MatrixPos).Speed = 10

        IF Direction = 1 THEN Projectile(MatrixPos).MoveY = Projectile(MatrixPos).Speed * -1
        IF Direction = 2 THEN Projectile(MatrixPos).MoveX = Projectile(MatrixPos).Speed
        IF Direction = 3 THEN Projectile(MatrixPos).MoveY = Projectile(MatrixPos).Speed
        IF Direction = 4 THEN Projectile(MatrixPos).MoveX = Projectile(MatrixPos).Speed * -1
        IF Settings.Debug > 2 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Projectile(MatrixPos).Direction), 3)

    ELSEIF Spawn$ = "TFire" THEN
        FOR x = 1 TO 3
            MatrixPos = EmptyProjectile(0)
            Projectile(MatrixPos).Active = 1
            Projectile(MatrixPos).Stage = 0
            Projectile(MatrixPos).Damage = 1
            Projectile(MatrixPos).Size = 12
            Projectile(MatrixPos).Name = "FireB"
            Projectile(MatrixPos).XPos = XPos
            Projectile(MatrixPos).YPos = YPos
            Projectile(MatrixPos).ShieldUpgrade = 1
            Projectile(MatrixPos).MoveY = 0
            Projectile(MatrixPos).Speed = 6

            IF x = 1 THEN
                Projectile(MatrixPos).MoveY = -1
            ELSEIF x = 3 THEN
                Projectile(MatrixPos).MoveY = 1
            END IF
        NEXT x
        IF Settings.Debug > 2 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Projectile(MatrixPos).Direction), 3)

    ELSEIF Spawn$ = "FireB" THEN
        MatrixPos = EmptyProjectile(0)
        Projectile(MatrixPos).Active = 1
        Projectile(MatrixPos).Stage = 0
        Projectile(MatrixPos).Damage = 1
        Projectile(MatrixPos).Size = 12
        Projectile(MatrixPos).Name = Spawn$
        Projectile(MatrixPos).XPos = XPos
        Projectile(MatrixPos).YPos = YPos
        Projectile(MatrixPos).ShieldUpgrade = 1
        Projectile(MatrixPos).Speed = 6
        IF Settings.Debug > 2 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 3)

    ELSEIF Spawn$ = "RBoom" OR Spawn$ = "BBoom" THEN
        MatrixPos = EmptyProjectile(0)
        Projectile(MatrixPos).Active = 1
        Projectile(MatrixPos).Direction = Direction
        IF Spawn$ = "RBoom" THEN Projectile(MatrixPos).Damage = 1
        IF Spawn$ = "BBoom" THEN Projectile(MatrixPos).Damage = 2
        Projectile(MatrixPos).MoveX = 0
        Projectile(MatrixPos).MoveY = 0
        Projectile(MatrixPos).Size = 10
        Projectile(MatrixPos).Name = Spawn$
        Projectile(MatrixPos).XPos = XPos
        Projectile(MatrixPos).YPos = YPos
        Projectile(MatrixPos).Distance = 50
        Projectile(MatrixPos).MobControl = MobControl
        Sprites(MobControl).AttackPointer = MatrixPos
        Projectile(MatrixPos).Counter = 0
        Projectile(MatrixPos).MaxDelay = 3
        Projectile(MatrixPos).ShieldUpgrade = 0
        Projectile(MatrixPos).Stage = 1
        Projectile(MatrixPos).Frame = 1
        Projectile(MatrixPos).PlayerSpawned = Master
        Projectile(MatrixPos).Speed = 6

        IF Direction = 1 THEN Projectile(MatrixPos).MoveY = Projectile(MatrixPos).Speed * -1
        IF Direction = 2 THEN Projectile(MatrixPos).MoveX = Projectile(MatrixPos).Speed
        IF Direction = 3 THEN Projectile(MatrixPos).MoveY = Projectile(MatrixPos).Speed
        IF Direction = 4 THEN Projectile(MatrixPos).MoveX = Projectile(MatrixPos).Speed * -1
        IF Settings.Debug > 2 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Projectile(MatrixPos).Direction), 3)

    ELSEIF Spawn$ = "RMobl" OR Spawn$ = "BMobl" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).AnimationDelay = 8
        Sprites(MatrixPos).MaxDelay = 10
        Sprites(MatrixPos).MaxCount = RandomGen(50, 30, "+", 0)
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Speed = 1
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).HardCount = 1
        IF Spawn$ = "RMobl" THEN Sprites(MatrixPos).Health = 2
        IF Spawn$ = "BMobl" THEN Sprites(MatrixPos).Health = 3
        IF Spawn$ = "RMobl" THEN Sprites(MatrixPos).Frame = 1
        IF Spawn$ = "BMobl" THEN Sprites(MatrixPos).Frame = 3
        IF Spawn$ = "RMobl" THEN Sprites(MatrixPos).LootCategory = 1
        IF Spawn$ = "BMobl" THEN Sprites(MatrixPos).LootCategory = 2

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF RIGHT$(Spawn$, 4) = "Arro" THEN
        MatrixPos = EmptyProjectile(0)
        Projectile(MatrixPos).Active = 1
        Projectile(MatrixPos).Direction = Direction
        IF Spawn$ = "RArro" THEN Projectile(MatrixPos).Damage = 2
        IF Spawn$ = "BArro" THEN Projectile(MatrixPos).Damage = 4
        Projectile(MatrixPos).MoveX = 0
        Projectile(MatrixPos).MoveY = 0
        Projectile(MatrixPos).Size = 6
        Projectile(MatrixPos).Name = Spawn$
        Projectile(MatrixPos).XPos = XPos
        Projectile(MatrixPos).YPos = YPos
        Projectile(MatrixPos).ShieldUpgrade = 0
        Projectile(MatrixPos).PlayerSpawned = Master
        Projectile(MatrixPos).Speed = 8

        IF Direction = 1 THEN Projectile(MatrixPos).MoveY = Projectile(MatrixPos).Speed * -1
        IF Direction = 2 THEN Projectile(MatrixPos).MoveX = Projectile(MatrixPos).Speed
        IF Direction = 3 THEN Projectile(MatrixPos).MoveY = Projectile(MatrixPos).Speed
        IF Direction = 4 THEN Projectile(MatrixPos).MoveX = Projectile(MatrixPos).Speed * -1
        IF LEFT$(Projectile(MatrixPos).Name, 1) = "G" THEN Projectile(MatrixPos).Frame = 1
        IF LEFT$(Projectile(MatrixPos).Name, 1) = "R" THEN Projectile(MatrixPos).Frame = 2
        IF LEFT$(Projectile(MatrixPos).Name, 1) = "B" THEN Projectile(MatrixPos).Frame = 3
        IF Settings.Debug > 2 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Projectile(MatrixPos).Direction), 3)

    ELSEIF Spawn$ = "Magic" THEN
        MatrixPos = EmptyProjectile(0)
        Projectile(MatrixPos).Active = 1
        Projectile(MatrixPos).Direction = Direction
        Projectile(MatrixPos).Damage = 4
        Projectile(MatrixPos).MoveX = 0
        Projectile(MatrixPos).MoveY = 0
        Projectile(MatrixPos).Size = Player1.Size
        Projectile(MatrixPos).Name = Spawn$
        Projectile(MatrixPos).XPos = XPos
        Projectile(MatrixPos).YPos = YPos
        Projectile(MatrixPos).ShieldUpgrade = 1
        Projectile(MatrixPos).Stage = 0
        Projectile(MatrixPos).Speed = 8
        Projectile(MatrixPos).PlayerSpawned = Master

        IF Direction = 1 THEN Projectile(MatrixPos).MoveY = Projectile(MatrixPos).Speed * -1
        IF Direction = 2 THEN Projectile(MatrixPos).MoveX = Projectile(MatrixPos).Speed
        IF Direction = 3 THEN Projectile(MatrixPos).MoveY = Projectile(MatrixPos).Speed
        IF Direction = 4 THEN Projectile(MatrixPos).MoveX = Projectile(MatrixPos).Speed * -1
        IF Settings.Debug > 2 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Projectile(MatrixPos).Direction), 3)

    ELSEIF Spawn$ = "Rope " OR Spawn$ = "Gibdo" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Frame2 = 1
        Sprites(MatrixPos).MaxDelay = 10
        Sprites(MatrixPos).MaxCount = RandomGen(50, 30, "+", 0)
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).HardCount = 1
        IF Spawn$ = "Rope " THEN Sprites(MatrixPos).Damage = 1
        IF Spawn$ = "Gibdo" THEN Sprites(MatrixPos).Damage = 4
        IF Spawn$ = "Rope " THEN Sprites(MatrixPos).Speed = 2
        IF Spawn$ = "Gibdo" THEN Sprites(MatrixPos).Speed = 1
        IF Spawn$ = "Rope " THEN Sprites(MatrixPos).Health = 1
        IF Spawn$ = "Gibdo" THEN Sprites(MatrixPos).Health = 7
        IF Spawn$ = "Rope " THEN Sprites(MatrixPos).LootCategory = 3
        IF Spawn$ = "Gibdo" THEN Sprites(MatrixPos).LootCategory = 2

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed: Sprites(MatrixPos).Frame = 2
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF RIGHT$(Spawn$, 4) = "Dark" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).MaxDelay = 10
        Sprites(MatrixPos).MaxCount = RandomGen(50, 30, "+", 0)
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).HardCount = 1
        Sprites(MatrixPos).Speed = 2
        IF Spawn$ = "RDark" THEN Sprites(MatrixPos).Frame = 1
        IF Spawn$ = "BDark" THEN Sprites(MatrixPos).Frame = 3
        IF Spawn$ = "RDark" THEN Sprites(MatrixPos).Health = 4
        IF Spawn$ = "BDark" THEN Sprites(MatrixPos).Health = 8
        IF Spawn$ = "RDark" THEN Sprites(MatrixPos).LootCategory = 2
        IF Spawn$ = "BDark" THEN Sprites(MatrixPos).LootCategory = 4

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF RIGHT$(Spawn$, 4) = "Lyne" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).MaxDelay = 10
        Sprites(MatrixPos).MaxCount = RandomGen(50, 30, "+", 0)
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).HardCount = 1
        IF Spawn$ = "RLyne" THEN Sprites(MatrixPos).Frame = 1
        IF Spawn$ = "BLyne" THEN Sprites(MatrixPos).Frame = 3
        IF Spawn$ = "RLyne" THEN Sprites(MatrixPos).Damage = 4
        IF Spawn$ = "BLyne" THEN Sprites(MatrixPos).Damage = 8
        IF Spawn$ = "RLyne" THEN Sprites(MatrixPos).Speed = 2
        IF Spawn$ = "BLyne" THEN Sprites(MatrixPos).Speed = 2
        IF Spawn$ = "RLyne" THEN Sprites(MatrixPos).Health = 4
        IF Spawn$ = "BLyne" THEN Sprites(MatrixPos).Health = 6
        IF Spawn$ = "RLyne" THEN Sprites(MatrixPos).LootCategory = 4
        IF Spawn$ = "BLyne" THEN Sprites(MatrixPos).LootCategory = 2

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF RIGHT$(Spawn$, 4) = "Swor" THEN
        MatrixPos = EmptyProjectile(0)
        Projectile(MatrixPos).Active = 1
        Projectile(MatrixPos).Direction = Direction
        IF Spawn$ = "RSwor" THEN Projectile(MatrixPos).Damage = 2
        IF Spawn$ = "BSwor" THEN Projectile(MatrixPos).Damage = 4
        Projectile(MatrixPos).Size = 12
        Projectile(MatrixPos).Name = Spawn$
        Projectile(MatrixPos).XPos = XPos
        Projectile(MatrixPos).YPos = YPos
        Projectile(MatrixPos).ShieldUpgrade = 1
        Projectile(MatrixPos).Speed = 10

        IF Direction = 1 THEN Projectile(MatrixPos).MoveY = Projectile(MatrixPos).Speed * -1
        IF Direction = 2 THEN Projectile(MatrixPos).MoveX = Projectile(MatrixPos).Speed
        IF Direction = 3 THEN Projectile(MatrixPos).MoveY = Projectile(MatrixPos).Speed
        IF Direction = 4 THEN Projectile(MatrixPos).MoveX = Projectile(MatrixPos).Speed * -1
        IF Settings.Debug > 2 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Projectile(MatrixPos).Direction), 3)


    ELSEIF Spawn$ = "Keese" OR Spawn$ = "Peaha" OR Spawn$ = "RKees" OR Spawn$ = "Fairy" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Damage = 1
        Sprites(MatrixPos).MaxDelay = 3
        Sprites(MatrixPos).MaxCount = RandomGen(50, 30, "+", 0)
        Sprites(MatrixPos).Size = 14
        Sprites(MatrixPos).Speed = 3
        Sprites(MatrixPos).Stage = 1
        Sprites(MatrixPos).Health = 1
        Sprites(MatrixPos).Flying = 1
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).HardCount = 1
        IF Spawn$ = "Fairy" THEN Sprites(MatrixPos).Stage = 0
        IF Spawn$ = "Peaha" THEN Sprites(MatrixPos).Speed = 2
        IF Spawn$ = "Peaha" THEN Sprites(MatrixPos).Health = 2
        IF Spawn$ = "Peaha" THEN Sprites(MatrixPos).Size = Player1.Size - 1
        IF Spawn$ = "Peaha" THEN Sprites(MatrixPos).LootCategory = 4

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1

        IF Spawn$ <> "Fairy" THEN
            IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)
        ELSE
            IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " item drop", 1)
        END IF

    ELSEIF Spawn$ = "Armos" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Damage = 1
        Sprites(MatrixPos).AnimationDelay = 0
        Sprites(MatrixPos).MaxDelay = 100
        Sprites(MatrixPos).MaxCount = RandomGen(50, 30, "+", 0)
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Speed = RandomGen(5, 1, "+", 0)
        Sprites(MatrixPos).Health = 3
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).HardCount = 1

        IF ActiveMap.SubType = 1 THEN Sprites(MatrixPos).SnakeNum = 19
        IF ActiveMap.SubType = 2 THEN Sprites(MatrixPos).SnakeNum = 20

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)


    ELSEIF Spawn$ = "Flame" THEN
        MatrixPos = EmptyProjectile(0)
        Projectile(MatrixPos).Active = 1
        Projectile(MatrixPos).Name = Spawn$
        Projectile(MatrixPos).XPos = XPos
        Projectile(MatrixPos).YPos = YPos
        Projectile(MatrixPos).Direction = Direction
        Projectile(MatrixPos).Frame = 1
        Projectile(MatrixPos).AnimationDelay = 0
        Projectile(MatrixPos).MaxDelay = 6
        Projectile(MatrixPos).Size = Player1.Size - 3
        Projectile(MatrixPos).Damage = 1
        Projectile(MatrixPos).Speed = 1
        Projectile(MatrixPos).PlayerSpawned = Master
        Projectile(MatrixPos).Counter = Player1.Size * 2
        Projectile(MatrixPos).Stage = 0

        IF Direction = 1 THEN Projectile(MatrixPos).MoveY = Projectile(MatrixPos).Speed * -1
        IF Direction = 2 THEN Projectile(MatrixPos).MoveX = Projectile(MatrixPos).Speed
        IF Direction = 3 THEN Projectile(MatrixPos).MoveY = Projectile(MatrixPos).Speed
        IF Direction = 4 THEN Projectile(MatrixPos).MoveX = Projectile(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Projectile(MatrixPos).Direction), 2)


    ELSEIF Spawn$ = "SWate" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).Frame = 1
        Special(MatrixPos).AnimationDelay = 1
        Special(MatrixPos).MaxDelay = 2
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Special(MatrixPos).Direction), 2)


    ELSEIF Spawn$ = "Water" THEN
        MatrixPos = EmptyProjectile(0)
        Projectile(MatrixPos).Active = 1
        Projectile(MatrixPos).Name = Spawn$
        Projectile(MatrixPos).Frame = 1
        Projectile(MatrixPos).AnimationDelay = 1
        Projectile(MatrixPos).MaxDelay = 2
        Projectile(MatrixPos).Size = Player1.Size
        Projectile(MatrixPos).XPos = XPos
        Projectile(MatrixPos).YPos = YPos
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Projectile(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "FSnak" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).SnakeNum = EmptySnake
        Snakes(Sprites(MatrixPos).SnakeNum) = 1
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).MaxCount = 16
        Sprites(MatrixPos).Health = 2
        Sprites(MatrixPos).HP = 2
        Sprites(MatrixPos).Size = 13
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Speed = 1
        Sprites(MatrixPos).Stage = 1
        Sprites(MatrixPos).Damage = 1
        Sprites(MatrixPos).SnakeDivider = 20
        Sprites(MatrixPos).SnakeSize = Sprites(MatrixPos).SnakeDivider * 6
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).LootCategory = 4
        Sprites(MatrixPos).HardCount = 1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "KFire" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Health = 1
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).MaxDelay = 6
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Damage = 1
        Sprites(MatrixPos).HardCount = 1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)


    ELSEIF RIGHT$(Spawn$, 4) = "Lanm" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).SnakeNum = EmptySnake
        Snakes(Sprites(MatrixPos).SnakeNum) = 1
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).MaxCount = 16
        Sprites(MatrixPos).Size = 15
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Stage = 1
        Sprites(MatrixPos).Damage = 4
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).HardCount = 1

        IF Sprites(MatrixPos).Name = "RLanm" THEN Sprites(MatrixPos).Frame = 1
        IF Sprites(MatrixPos).Name = "BLanm" THEN Sprites(MatrixPos).Frame = 2
        IF Sprites(MatrixPos).Name = "RLanm" THEN Sprites(MatrixPos).Health = 5
        IF Sprites(MatrixPos).Name = "BLanm" THEN Sprites(MatrixPos).Health = 6
        IF Sprites(MatrixPos).Name = "RLanm" THEN Sprites(MatrixPos).Speed = 4
        IF Sprites(MatrixPos).Name = "BLanm" THEN Sprites(MatrixPos).Speed = 5
        IF Sprites(MatrixPos).Name = "RLanm" THEN Sprites(MatrixPos).SnakeDivider = 7
        IF Sprites(MatrixPos).Name = "BLanm" THEN Sprites(MatrixPos).SnakeDivider = 6
        IF Sprites(MatrixPos).Name = "RLanm" THEN Sprites(MatrixPos).LootCategory = 4
        IF Sprites(MatrixPos).Name = "BLanm" THEN Sprites(MatrixPos).LootCategory = 3
        Sprites(MatrixPos).SnakeSize = Sprites(MatrixPos).SnakeDivider * 6
        Sprites(MatrixPos).HP = Sprites(MatrixPos).Health
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "Stalf" OR Spawn$ = "KStal" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).MaxDelay = 20
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Health = 2
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Damage = 1
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).MaxCount = RandomGen(50, 30, "+", 0)
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).Speed = 2
        Sprites(MatrixPos).LootCategory = 3
        Sprites(MatrixPos).HardCount = 1

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "Gel  " THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).MaxDelay = 2
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Health = 1
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Damage = 1
        Sprites(MatrixPos).Size = 10
        Sprites(MatrixPos).MaxCount = RandomGen(30, 10, "+", 0)
        Sprites(MatrixPos).WalkTime = 30
        Sprites(MatrixPos).WalkAdd = 10
        Sprites(MatrixPos).Speed = 3
        Sprites(MatrixPos).HardCount = 1

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "Zol  " THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).MaxDelay = 10
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Health = 2
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Damage = 1
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).MaxCount = RandomGen(100, 50, "+", 0)
        Sprites(MatrixPos).WalkTime = 100
        Sprites(MatrixPos).WalkAdd = 50
        Sprites(MatrixPos).Speed = .5
        Sprites(MatrixPos).LootCategory = 3
        Sprites(MatrixPos).HardCount = 1

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "Trap " THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Health = 1
        Sprites(MatrixPos).Damage = 1
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Speed = 6
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "Patra" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Health = 12
        Sprites(MatrixPos).Damage = 4
        Sprites(MatrixPos).Size = 15
        Sprites(MatrixPos).Speed = .25
        Sprites(MatrixPos).MaxDelay = 2
        Sprites(MatrixPos).MaxCount = RandomGen(100, 100, "+", 0)
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).WalkTime = 100
        Sprites(MatrixPos).WalkAdd = 100
        Sprites(MatrixPos).Ambient = 1
        Sprites(MatrixPos).Flying = 1
        Sprites(MatrixPos).LootCategory = 4
        Sprites(MatrixPos).HardCount = 1

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "SPatr" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).PatraLoc = MobControl
        Sprites(MatrixPos).Angle = PatraLoc
        Sprites(MatrixPos).Frame = RandomGen(2, 1, "+", 0)
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = Sprites(PatraLoc).XPos
        Sprites(MatrixPos).YPos = Sprites(PatraLoc).YPos
        Sprites(MatrixPos).Health = 4
        Sprites(MatrixPos).Damage = 4
        Sprites(MatrixPos).Size = 10
        Sprites(MatrixPos).Speed = .075
        Sprites(MatrixPos).MaxDelay = 2
        Sprites(MatrixPos).Flying = 1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "RWizz" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Health = 4
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).MaxDelay = 5
        Sprites(MatrixPos).LootCategory = 2
        Sprites(MatrixPos).HardCount = 1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "BWizz" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Health = 10
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).MaxDelay = 5
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).Speed = 2
        Sprites(MatrixPos).MaxCount = RandomGen(50, 30, "+", 0)
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).LootCategory = 1
        Sprites(MatrixPos).HardCount = 1

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)


    ELSEIF Spawn$ = "Ghini" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Health = 9
        Sprites(MatrixPos).Damage = 1
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).Frame = Sprites(MatrixPos).Direction
        Sprites(MatrixPos).Speed = 1
        Sprites(MatrixPos).MaxCount = RandomGen(100, 60, "+", 0)
        Sprites(MatrixPos).WalkTime = 100
        Sprites(MatrixPos).WalkAdd = 60
        Sprites(MatrixPos).LootCategory = 3
        Sprites(MatrixPos).Master = Master
        Sprites(MatrixPos).HardCount = 1

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)


    ELSEIF Spawn$ = "RLeev" OR Spawn$ = "BLeev" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Health = 2
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Damage = 1
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).MaxDelay = 5
        Sprites(MatrixPos).Speed = 1
        Sprites(MatrixPos).MaxCount = 50
        Sprites(MatrixPos).WalkTime = 100
        Sprites(MatrixPos).WalkAdd = 60
        Sprites(MatrixPos).HardCount = 1

        IF Spawn$ = "BLeev" THEN Sprites(MatrixPos).XPos = XPos
        IF Spawn$ = "BLeev" THEN Sprites(MatrixPos).YPos = YPos
        IF Spawn$ = "BLeev" THEN Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        IF Spawn$ = "RLeev" THEN Sprites(MatrixPos).Frame2 = 1
        IF Spawn$ = "BLeev" THEN Sprites(MatrixPos).Frame2 = 2
        IF Spawn$ = "RLeev" THEN Sprites(MatrixPos).LootCategory = 3
        IF Spawn$ = "BLeev" THEN Sprites(MatrixPos).LootCategory = 1

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF RIGHT$(Spawn$, 4) = "Tekt" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Health = 1
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Damage = 1
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).MaxDelay = 20
        Sprites(MatrixPos).Speed = 5
        Sprites(MatrixPos).MaxCount = 50
        Sprites(MatrixPos).HardCount = 1

        IF Spawn$ = "RTekt" THEN Sprites(MatrixPos).Frame2 = 1
        IF Spawn$ = "BTekt" THEN Sprites(MatrixPos).Frame2 = 2
        IF Spawn$ = "RTekt" THEN Sprites(MatrixPos).LootCategory = 1
        IF Spawn$ = "BTekt" THEN Sprites(MatrixPos).LootCategory = 3
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "Zora " THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Health = 2
        Sprites(MatrixPos).Frame = 0
        Sprites(MatrixPos).Damage = 1
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).LootCategory = 4
        Sprites(MatrixPos).HardCount = 1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "Bubbl" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).WalkTime = 100
        Sprites(MatrixPos).WalkAdd = 60
        Sprites(MatrixPos).Damage = 0.1
        Sprites(MatrixPos).Speed = 3
        Sprites(MatrixPos).Health = 1
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).HardCount = 0
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "LikeL" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).WalkTime = 100
        Sprites(MatrixPos).WalkAdd = 60
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).Speed = 2
        Sprites(MatrixPos).Health = 9
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).MaxDelay = 15
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).HardCount = 1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "PolsV" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Health = 10
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Damage = 4
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).MaxDelay = 10
        Sprites(MatrixPos).Speed = 2
        Sprites(MatrixPos).MaxCount = 50
        Sprites(MatrixPos).Counter = 50
        Sprites(MatrixPos).WalkTime = 100
        Sprites(MatrixPos).WalkAdd = 60
        Sprites(MatrixPos).LootCategory = 3
        Sprites(MatrixPos).HardCount = 1
        Sprites(MatrixPos).MoveCheckBypass = 1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "Aqua " THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Direction = RandomGen(2, 1, "+", 0)
        Sprites(MatrixPos).MaxCount = RandomGen(300, 60, "+", 0)
        Sprites(MatrixPos).MaxCount2 = RandomGen(50, 50, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Frame2 = 1
        Sprites(MatrixPos).Speed = 0.4
        Sprites(MatrixPos).MaxDelay = 18
        Sprites(MatrixPos).Health = 5
        Sprites(MatrixPos).LootCategory = 4
        Sprites(MatrixPos).Boss = 1
        Sprites(MatrixPos).HardCount = 1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "Dodon" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Speed = 1.8
        Sprites(MatrixPos).MaxDelay = 10
        Sprites(MatrixPos).Health = 2
        Sprites(MatrixPos).WalkTime = 70
        Sprites(MatrixPos).WalkAdd = 50
        Sprites(MatrixPos).MaxCount = RandomGen(50, 30, "+", 0)
        Sprites(MatrixPos).MaxCount2 = 60
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).LootCategory = 4
        Sprites(MatrixPos).Boss = 1
        Sprites(MatrixPos).HardCount = 1

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed * -1
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed * -1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "ManhM" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Direction = RandomGen(8, 1, "+", 0)
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).Size = Player1.Size * 3
        Sprites(MatrixPos).Speed = 1.8
        Sprites(MatrixPos).MaxDelay = 10
        Sprites(MatrixPos).Health = 4
        Sprites(MatrixPos).WalkTime = 50
        Sprites(MatrixPos).WalkAdd = 30
        Sprites(MatrixPos).MaxCount = RandomGen(50, 30, "+", 0)
        Sprites(MatrixPos).Counter = Sprites(MatrixPos).MaxCount
        Sprites(MatrixPos).Frame = 1
        CALL SpawnSprite("ManhN", Sprites(MatrixPos).XPos, Sprites(MatrixPos).YPos, 0, 0, MatrixPos, 0)
        CALL SpawnSprite("ManhE", Sprites(MatrixPos).XPos, Sprites(MatrixPos).YPos, 0, 0, MatrixPos, 0)
        CALL SpawnSprite("ManhS", Sprites(MatrixPos).XPos, Sprites(MatrixPos).YPos, 0, 0, MatrixPos, 0)
        CALL SpawnSprite("ManhW", Sprites(MatrixPos).XPos, Sprites(MatrixPos).YPos, 0, 0, MatrixPos, 0)
        Sprites(MatrixPos).LootCategory = 4
        Sprites(MatrixPos).Boss = 1
        Sprites(MatrixPos).HardCount = 1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF LEFT$(Spawn$, 4) = "Manh" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).PatraLoc = PatraLoc
        Sprites(MatrixPos).Health = Sprites(PatraLoc).Health
        Sprites(MatrixPos).Damage = Sprites(PatraLoc).Damage
        Sprites(MatrixPos).MaxDelay = Sprites(PatraLoc).MaxDelay
        Sprites(MatrixPos).MaxCount2 = RandomGen(50, 75, "+", 0)
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).AnimationDelay = RandomGen(Sprites(MatrixPos).MaxDelay - 1, 0, "+", 0)
        IF RIGHT$(Sprites(MatrixPos).Name, 1) = "N" THEN Sprites(MatrixPos).Frame2 = 1
        IF RIGHT$(Sprites(MatrixPos).Name, 1) = "E" THEN Sprites(MatrixPos).Frame2 = 2
        IF RIGHT$(Sprites(MatrixPos).Name, 1) = "S" THEN Sprites(MatrixPos).Frame2 = 3
        IF RIGHT$(Sprites(MatrixPos).Name, 1) = "W" THEN Sprites(MatrixPos).Frame2 = 4
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "GleeM" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Health = MobControl
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).XPos = Settings.RezX / 2
        Sprites(MatrixPos).MaxDelay = 25
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Size = Player1.Size * 2
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).LootCategory = 4
        Sprites(MatrixPos).Boss = 1
        Sprites(MatrixPos).HardCount = 1

        FOR Heads = 1 TO Sprites(MatrixPos).Health
            CALL SpawnSprite("GleeH", Sprites(MatrixPos).XPos, Sprites(MatrixPos).YPos + (Player1.Size * 4), RandomGen(8, 1, "+", 0), 0, MatrixPos, 0)
        NEXT Heads
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "GleeH" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).PatraLoc = PatraLoc
        Sprites(MatrixPos).Stage = 1
        Sprites(MatrixPos).XPos = Settings.RezX / 2
        Sprites(MatrixPos).MaxDelay = 2
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Speed = 0.5
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).WalkTime = 100
        Sprites(MatrixPos).WalkAdd = 50
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).Health = 10
        Sprites(MatrixPos).MaxCount2 = RandomGen(50, 75, "+", 0)
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "Digdo" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).Speed = 2
        Sprites(MatrixPos).MaxDelay = 5
        Sprites(MatrixPos).Health = 8
        Sprites(MatrixPos).WalkTime = 100
        Sprites(MatrixPos).WalkAdd = 50
        Sprites(MatrixPos).HardCount = 1
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Size = Player1.Size * 2.5
        Sprites(MatrixPos).Boss = 1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "MDigd" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).PatraLoc = PatraLoc
        Sprites(MatrixPos).Speed = 3
        Sprites(MatrixPos).MaxDelay = 5
        Sprites(MatrixPos).Health = 8
        Sprites(MatrixPos).WalkTime = 100
        Sprites(MatrixPos).WalkAdd = 50
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).LootCategory = 4
        Sprites(MatrixPos).Boss = 1
        Sprites(MatrixPos).HardCount = 1
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF RIGHT$(Spawn$, 4) = "Gohm" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Stage = -1
        Sprites(MatrixPos).XPos = Settings.RezX / 2
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Speed = 2
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).MaxDelay = 8
        Sprites(MatrixPos).LootCategory = 4
        Sprites(MatrixPos).Boss = 1
        Sprites(MatrixPos).HardCount = 1
        Sprites(MatrixPos).Frame = 1

        IF Sprites(MatrixPos).Name = "RGohm" THEN Sprites(MatrixPos).Frame2 = 1
        IF Sprites(MatrixPos).Name = "BGohm" THEN Sprites(MatrixPos).Frame2 = 2
        IF Sprites(MatrixPos).Name = "RGohm" THEN Sprites(MatrixPos).Health = 1
        IF Sprites(MatrixPos).Name = "BGohm" THEN Sprites(MatrixPos).Health = 3
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "Ganno" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).Stage = 0
        Sprites(MatrixPos).Speed = 3
        Sprites(MatrixPos).Damage = 2
        Sprites(MatrixPos).Health = 4
        Sprites(MatrixPos).Size = Player1.Size * 2.25
        Sprites(MatrixPos).MaxDelay = 100
        Sprites(MatrixPos).MaxCount = 60
        Sprites(MatrixPos).Direction = RandomGen(4, 1, "+", 0)
        Sprites(MatrixPos).YPos = Settings.RezX / 2
        Sprites(MatrixPos).XPos = Settings.RezY / 2
        Sprites(MatrixPos).Misc = 250
        Sprites(MatrixPos).HardCount = 1
        Sprites(MatrixPos).Boss = 1

        IF Sprites(MatrixPos).Direction = 1 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed: Sprites(MatrixPos).MoveY = (Sprites(MatrixPos).Speed * -1)
        IF Sprites(MatrixPos).Direction = 2 THEN Sprites(MatrixPos).MoveX = Sprites(MatrixPos).Speed: Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 3 THEN Sprites(MatrixPos).MoveX = (Sprites(MatrixPos).Speed * -1): Sprites(MatrixPos).MoveY = Sprites(MatrixPos).Speed
        IF Sprites(MatrixPos).Direction = 4 THEN Sprites(MatrixPos).MoveX = (Sprites(MatrixPos).Speed * -1): Sprites(MatrixPos).MoveY = (Sprites(MatrixPos).Speed * -1)
        IF Settings.Debug > 1 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " facing direction:" + STR$(Sprites(MatrixPos).Direction), 2)

    ELSEIF Spawn$ = "Heart" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).MaxDelay = 12
        Sprites(MatrixPos).Health = 1
        Sprites(MatrixPos).Size = 10
        Sprites(MatrixPos).Frame = 1
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " item drop", 1)


    ELSEIF Spawn$ = "Rupee" OR Spawn$ = "5Rupe" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).MaxDelay = 12
        Sprites(MatrixPos).Health = 1
        Sprites(MatrixPos).Size = 8
        Sprites(MatrixPos).Frame = 1
        IF Sprites(MatrixPos).Name = "5Rupe" THEN Sprites(MatrixPos).Frame = 2
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " item drop", 1)


    ELSEIF Spawn$ = "Clock" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).MaxDelay = 12
        Sprites(MatrixPos).Health = 1
        Sprites(MatrixPos).Size = 19
        Sprites(MatrixPos).Frame = 1
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " item drop", 1)

    ELSEIF RIGHT$(Spawn$, 4) = "Bloc" THEN
        MatrixPos = EmptySpecial(0)

        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).MaxCount = 15
        Special(MatrixPos).Speed = 1
        Special(MatrixPos).SizeW = (Settings.SquareWidth / 2) - 1
        Special(MatrixPos).SizeH = (Settings.SquareHeight / 2) - 1
        Special(MatrixPos).Frame = MobControl - Settings.SpriteDivider
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning special sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "Switc" THEN
        MatrixPos = EmptySpecial(1)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).SizeW = (Settings.SquareWidth / 2) - 1
        Special(MatrixPos).SizeH = (Settings.SquareHeight / 2) - 1
        Special(MatrixPos).Frame = MobControl - Settings.SpriteDivider
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning special sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "Zelda" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = Settings.RezX / 2
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).SizeH = Player1.Size * 2
        Special(MatrixPos).Frame = 4
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning special sprite " + Spawn$, 1)


    ELSEIF Spawn$ = "HStai" OR Spawn$ = "Stair" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).SizeW = (Settings.SquareWidth / 2) - 1
        Special(MatrixPos).SizeH = (Settings.SquareHeight / 2) - 1
        Special(MatrixPos).Frame = MobControl - Settings.SpriteDivider
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning special sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "Death" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Size = Player1.Size / 2
        Sprites(MatrixPos).Health = 1
        Sprites(MatrixPos).MaxDelay = 1
        Sprites(MatrixPos).Frame = 1
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "Cloud" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = Master
        Special(MatrixPos).Controller = MobControl
        Special(MatrixPos).Frame = 1
        Special(MatrixPos).Damage = 4
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "7Clou" THEN
        CALL SpawnSprite("Cloud", XPos, YPos, 0, 0, 0, 1)
        CALL SpawnSprite("Cloud", XPos - (Player1.Size * 2), YPos, 0, 0, 0, 1)
        CALL SpawnSprite("Cloud", XPos + (Player1.Size * 2), YPos, 0, 0, 0, 1)
        CALL SpawnSprite("Cloud", XPos - Player1.Size, YPos - (Player1.Size * 2), 0, 0, 0, 1)
        CALL SpawnSprite("Cloud", XPos + Player1.Size, YPos - (Player1.Size * 2), 0, 0, 0, 1)
        CALL SpawnSprite("Cloud", XPos - Player1.Size, YPos + (Player1.Size * 2), 0, 0, 0, 1)
        CALL SpawnSprite("Cloud", XPos + Player1.Size, YPos + (Player1.Size * 2), 0, 0, 0, 1)
        CALL SpawnSprite("Flash", XPos, YPos, 0, 0, 0, 1)

    ELSEIF Spawn$ = "Flash" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Stage = 0

        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)


    ELSEIF Spawn$ = "P-Swo" OR Spawn$ = "P-WSw" OR Spawn$ = "P-MSw" OR Spawn$ = "P-MAS" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl

        IF Spawn$ = "P-WSw" THEN Special(MatrixPos).Controller = 10: Special(MatrixPos).Damage = 1
        IF Spawn$ = "P-MSw" THEN Special(MatrixPos).Controller = 24: Special(MatrixPos).Damage = 2
        IF Spawn$ = "P-MAS" THEN Special(MatrixPos).Controller = 30: Special(MatrixPos).Damage = 3

        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "P-RPo" OR Spawn$ = "P-BPo" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "P-BCa" OR Spawn$ = "P-RCa" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "P-BRi" OR Spawn$ = "P-RRi" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "P-Boo" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "P-Bom" OR Spawn$ = "P-BBo" THEN
        MatrixPos = EmptySprite
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size / 2
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "P-Bow" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "Food " THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        Special(MatrixPos).Stage = 1
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "P-Hea" OR Spawn$ = "HHear" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "P-Bmb" OR Spawn$ = "P-Bm4" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Master = MobControl
        Sprites(MatrixPos).Health = 1
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "P-Key" OR Spawn$ = "P-MKe" OR Spawn$ = "HKKey" OR Spawn$ = "HOKey" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "Garg1" OR Spawn$ = "Garg2" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Stage = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).SizeW = (Settings.SquareWidth / 2) - 1
        Special(MatrixPos).SizeH = (Settings.SquareHeight / 2) - 1
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        Special(MatrixPos).Frame = 2
        IF Spawn$ = "Garg2" THEN Special(MatrixPos).Frame = 3
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "HBomb" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "OldMa" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = Settings.RezX / 2
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Master = MobControl
        Special(MatrixPos).Size = Player1.Size
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)


    ELSEIF Spawn$ = "Grumb" THEN
        MatrixPos = EmptySpecial(1)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = Settings.RezX / 2
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Master = MobControl
        Special(MatrixPos).Size = Player1.Size
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)


    ELSEIF Spawn$ = "P-Lad" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "P-SAr" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "P-Mwa" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "P-Raf" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "P-Flu" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Master = MobControl
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "Triph" THEN
        MatrixPos = EmptySprite
        Sprites(MatrixPos).Active = 1
        Sprites(MatrixPos).Name = Spawn$
        Sprites(MatrixPos).YPos = YPos
        Sprites(MatrixPos).XPos = XPos
        Sprites(MatrixPos).HardCount = 1
        Sprites(MatrixPos).MaxDelay = 10
        Sprites(MatrixPos).Size = Player1.Size
        Sprites(MatrixPos).Frame = 1
        Sprites(MatrixPos).Health = 1

        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning " + Spawn$, 1)

    ELSEIF Spawn$ = "Trip" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).MaxDelay = 10
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Frame = 1
        CALL SpawnSprite("Triph", 0, 0, 0, 0, 0, 1)

        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning " + Spawn$, 1)

    ELSEIF Spawn$ = "P-Tri" OR Spawn$ = "L-Tri" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).MaxDelay = 10
        Special(MatrixPos).Size = Player1.Size / 1.2
        Special(MatrixPos).Frame = 1
        Special(MatrixPos).Master = Master

        IF Spawn$ = "P-Tri" THEN
            Special(MatrixPos).XPos = Settings.RezX / 2
        ELSE
            Special(MatrixPos).XPos = XPos

        END IF
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning " + Spawn$ + " item drop", 1)


    ELSEIF Spawn$ = "BExRo" OR Spawn$ = "GExRo" OR Spawn$ = "WExRo" THEN
        MatrixPos = EmptySpecial(1)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).SizeW = (Settings.SquareWidth / 2) - 1
        Special(MatrixPos).SizeH = (Settings.SquareHeight / 2) - 1
        Special(MatrixPos).Frame = MobControl - Settings.SpriteDivider
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning special sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "BGTre" OR Spawn$ = "BBTre" THEN
        MatrixPos = EmptyProjectile(1)
        Projectile(MatrixPos).Active = 1
        Projectile(MatrixPos).Name = Spawn$
        Projectile(MatrixPos).XPos = XPos
        Projectile(MatrixPos).YPos = YPos
        Projectile(MatrixPos).SizeW = (Settings.SquareWidth / 2) - 1
        Projectile(MatrixPos).SizeH = (Settings.SquareHeight / 2) - 1
        Projectile(MatrixPos).Frame = MobControl - Settings.SpriteDivider
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning special sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "RTrig" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).SizeW = (Settings.SquareWidth / 2) - 1
        Special(MatrixPos).SizeH = (Settings.SquareHeight / 2) - 1
        Special(MatrixPos).Frame = (MobControl - Settings.SpriteDivider) - 40
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning special sprite " + Spawn$, 1)

    ELSEIF Spawn$ = "ISold" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).Frame = MobControl
        Special(MatrixPos).Size = Player1.Size
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning special sprite " + Spawn$, 1)


    ELSEIF Spawn$ = "Ladde" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).SizeW = (Settings.SquareWidth / 2) - 1
        Special(MatrixPos).SizeH = (Settings.SquareHeight / 2) - 1
        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning special sprite " + Spawn$, 1)


    ELSEIF Spawn$ = "Guy" OR Spawn$ = "OldWo" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = Settings.RezX / 2
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).Size = Player1.Size
        Special(MatrixPos).Frame = 1
        IF Spawn$ = "OldWo" THEN Special(MatrixPos).Frame = 3

        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning special sprite " + Spawn$, 1)

    ELSEIF LEFT$(Spawn$, 4) = "DLak" THEN
        MatrixPos = EmptySpecial(0)
        Special(MatrixPos).Active = 1
        Special(MatrixPos).Name = Spawn$
        Special(MatrixPos).XPos = XPos
        Special(MatrixPos).YPos = YPos
        Special(MatrixPos).SizeW = (Settings.SquareWidth / 2)
        Special(MatrixPos).SizeH = (Settings.SquareHeight / 2)
        Special(MatrixPos).Master = MobControl
        IF RIGHT$(Spawn$, 1) <> "X" THEN
            Special(MatrixPos).Frame = VAL(RIGHT$(Spawn$, 1))
        ELSE
            Special(MatrixPos).Frame = 5
        END IF


        IF Settings.Debug <> 0 THEN CALL PrintConsole("World -> Spawning special sprite " + Spawn$, 1)
    END IF
END SUB



'*********************************************************
'* Spawns Special case sprites. Done while map is loading
'*
'*
'*********************************************************

SUB SpawnSpecialSprite (SpriteNum, X, Y)
    IF ActiveMap.Type = 1 THEN
        IF SpriteNum = Settings.SpriteDivider + 90 THEN
            CALL SpawnSprite("BExRo", X, Y, 0, Settings.SpriteDivider + 90, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 91 THEN
            CALL SpawnSprite("GExRo", X, Y, 0, Settings.SpriteDivider + 91, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 92 THEN
            CALL SpawnSprite("WExRo", X, Y, 0, Settings.SpriteDivider + 92, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 93 THEN
            CALL SpawnSprite("BGTre", X, Y, 0, Settings.SpriteDivider + 93, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 94 THEN
            CALL SpawnSprite("BBTre", X, Y, 0, Settings.SpriteDivider + 94, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 96 THEN
            CALL SpawnSprite("RTrig", X, Y, 0, Settings.SpriteDivider + 96, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 97 THEN
            CALL SpawnSprite("DLak1", X, Y, 0, Settings.SpriteDivider + 97, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 98 THEN
            CALL SpawnSprite("DLak2", X, Y, 0, Settings.SpriteDivider + 98, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 99 THEN
            CALL SpawnSprite("DLak3", X, Y, 0, Settings.SpriteDivider + 99, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 100 THEN
            CALL SpawnSprite("DLak4", X, Y, 0, Settings.SpriteDivider + 100, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 101 THEN
            CALL SpawnSprite("DLak5", X, Y, 0, Settings.SpriteDivider + 101, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 102 THEN
            CALL SpawnSprite("DLak6", X, Y, 0, Settings.SpriteDivider + 102, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 103 THEN
            CALL SpawnSprite("DLak7", X, Y, 0, Settings.SpriteDivider + 103, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 104 THEN
            CALL SpawnSprite("DLak8", X, Y, 0, Settings.SpriteDivider + 104, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 105 THEN
            CALL SpawnSprite("DLak9", X, Y, 0, Settings.SpriteDivider + 105, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 106 THEN
            CALL SpawnSprite("DLakX", X, Y, 0, Settings.SpriteDivider + 106, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 107 THEN
            CALL SpawnSprite("DLakS", X, Y, 0, Settings.SpriteDivider + 106, 0, 0)
        END IF

    ELSEIF ActiveMap.Type = 2 THEN
        IF SpriteNum = Settings.SpriteDivider + 6 THEN
            CALL SpawnSprite("Stair", X, Y, 0, Settings.SpriteDivider + 6, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 7 THEN
            CALL SpawnSprite("Switc", X, Y, 0, Settings.SpriteDivider + 7, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 8 THEN
            CALL SpawnSprite("MBloc", X, Y, 0, Settings.SpriteDivider + 8, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 9 THEN
            CALL SpawnSprite("HStai", X, Y, 0, Settings.SpriteDivider + 9, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 10 THEN
            CALL SpawnSprite("SBloc", X, Y, 0, Settings.SpriteDivider + 10, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 11 THEN
            CALL SpawnSprite("HKKey", X, Y, 0, Settings.SpriteDivider + 11, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 12 THEN
            CALL SpawnSprite("HOKey", X, Y, 0, Settings.SpriteDivider + 12, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 15 THEN
            CALL SpawnSprite("Garg1", X, Y, 0, Settings.SpriteDivider + 15, 0, 0)
        ELSEIF SpriteNum = Settings.SpriteDivider + 16 THEN
            CALL SpawnSprite("Garg2", X, Y, 0, Settings.SpriteDivider + 16, 0, 0)

        END IF
    END IF
END SUB
