'*********************************************************
'* Sprites.bi                          6/13/2021
'*
'* Everything pretaining to spawning and modifying sprites are here
'*
'*********************************************************


'*********************************************************
'* LoadSprites
'*
'* Loads all the images for every sprite
'*********************************************************

SUB LoadSprites
    IF Settings.Debug <> 0 THEN
        CALL PrintConsole("Engine -> Loading sprites.", 1)
    ELSE
        PRINT "Engine -> Loading sprites."
    END IF

    UiBase = _LOADIMAGE("Images\Ui.png")

    IntroBackDrop = _LOADIMAGE("Images\Intro.png")
    WaterfallTop(1) = _LOADIMAGE("Images\Waterfall4.png")
    WaterfallTop(2) = _LOADIMAGE("Images\Waterfall5.png")
    IntroWaterfall(1) = _LOADIMAGE("Images\Waterfall6.png")
    IntroWaterfall(2) = _LOADIMAGE("Images\Waterfall7.png")
    IntroWaterfall(3) = _LOADIMAGE("Images\Waterfall8.png")
    IntroWaterfall(4) = _LOADIMAGE("Images\Waterfall81.png")
    IntroWaterfall(5) = _LOADIMAGE("Images\Waterfall82.png")
    IntroWaterfall(6) = _LOADIMAGE("Images\Waterfall83.png")

    LinkSprites(1, 1, 1) = _LOADIMAGE("Images\LinkN1.png")
    LinkSprites(1, 2, 1) = _LOADIMAGE("Images\LinkN2.png")
    LinkSprites(1, 3, 1) = _LOADIMAGE("Images\LinkN3.png")
    LinkSprites(2, 1, 1) = _LOADIMAGE("Images\LinkE1.png")
    LinkSprites(2, 2, 1) = _LOADIMAGE("Images\LinkE2.png")
    LinkSprites(2, 3, 1) = _LOADIMAGE("Images\LinkE3.png")
    LinkSprites(3, 1, 1) = _LOADIMAGE("Images\LinkS1.png")
    LinkSprites(3, 2, 1) = _LOADIMAGE("Images\LinkS2.png")
    LinkSprites(3, 3, 1) = _LOADIMAGE("Images\LinkS3.png")
    LinkSprites(3, 4, 1) = _LOADIMAGE("Images\LinkS4.png")
    LinkSprites(3, 5, 1) = _LOADIMAGE("Images\LinkS5.png")
    LinkSprites(4, 1, 1) = _LOADIMAGE("Images\LinkW1.png")
    LinkSprites(4, 2, 1) = _LOADIMAGE("Images\LinkW2.png")
    LinkSprites(4, 3, 1) = _LOADIMAGE("Images\LinkW3.png")

    LinkColor& = _RGB(184, 184, 248)
    FOR z = 2 TO 3
        FOR y = 1 TO 3
            FOR x = 1 TO 4
                LinkSprites(x, y, z) = _COPYIMAGE(LinkSprites(x, y, 1))
                LinkSprites(x, y, z) = SwapColor(LinkSprites(x, y, z), _RGB(184, 248, 24), LinkColor&)
            NEXT x
        NEXT y
        LinkColor& = _RGB(248, 56, 0)
    NEXT z

    LinkColor& = _RGB(184, 184, 248)
    FOR z = 2 TO 3
        FOR y = 4 TO 5
            LinkSprites(3, y, z) = _COPYIMAGE(LinkSprites(3, y, 1))
            LinkSprites(3, y, z) = SwapColor(LinkSprites(3, y, z), _RGB(184, 248, 24), LinkColor&)
        NEXT y
        LinkColor& = _RGB(248, 56, 0)
    NEXT z

    AttackSprites(1, 1) = _LOADIMAGE("Images\SwordN.png")
    AttackSprites(2, 1) = _LOADIMAGE("Images\SwordE.png")
    AttackSprites(3, 1) = _LOADIMAGE("Images\SwordS.png")
    AttackSprites(4, 1) = _LOADIMAGE("Images\SwordW.png")
    FOR x = 1 TO 4
        AttackSprites(x, 2) = _COPYIMAGE(AttackSprites(x, 1))
        AttackSprites(x, 2) = SwapColor(AttackSprites(x, 2), _RGB(228, 92, 16), _RGB(255, 255, 255))
        AttackSprites(x, 2) = SwapColor(AttackSprites(x, 2), _RGB(184, 248, 24), _RGB(0, 0, 188))
        AttackSprites(x, 2) = SwapColor(AttackSprites(x, 2), _RGB(255, 160, 68), _RGB(104, 136, 255))
    NEXT x
    FOR x = 1 TO 4
        AttackSprites(x, 3) = _COPYIMAGE(AttackSprites(x, 1))
        AttackSprites(x, 3) = SwapColor(AttackSprites(x, 3), _RGB(228, 92, 16), _RGB(255, 255, 255))
        AttackSprites(x, 3) = SwapColor(AttackSprites(x, 3), _RGB(184, 248, 24), _RGB(248, 56, 0))
    NEXT x
    FOR x = 1 TO 4
        AttackSprites(x, 4) = _COPYIMAGE(AttackSprites(x, 1))
        AttackSprites(x, 4) = SwapColor(AttackSprites(x, 4), _RGB(184, 248, 24), _RGB(0, 255, 0))
        AttackSprites(x, 4) = SwapColor(AttackSprites(x, 4), _RGB(255, 160, 68), _RGB(104, 136, 255))
    NEXT x

    AttackSprites(1, 5) = _LOADIMAGE("Images\MagicSword.png")
    AttackSprites(1, 6) = _COPYIMAGE(AttackSprites(1, 5))
    AttackSprites(1, 6) = SwapColor(AttackSprites(1, 6), _RGB(248, 56, 0), _RGB(0, 0, 188))
    AttackSprites(1, 6) = SwapColor(AttackSprites(1, 6), _RGB(255, 160, 68), _RGB(104, 136, 255))


    SparkSprites(1, 1) = _LOADIMAGE("Images\Spark11.png")
    SparkSprites(2, 1) = _LOADIMAGE("Images\Spark21.png")
    SparkSprites(3, 1) = _LOADIMAGE("Images\Spark31.png")
    SparkSprites(4, 1) = _LOADIMAGE("Images\Spark41.png")
    FOR x = 1 TO 4
        SparkSprites(x, 2) = _COPYIMAGE(SparkSprites(x, 1))
        SparkSprites(x, 2) = SwapColor(SparkSprites(x, 2), _RGB(248, 56, 0), _RGB(255, 255, 255))
        SparkSprites(x, 2) = SwapColor(SparkSprites(x, 2), _RGB(0, 136, 136), _RGB(255, 160, 68))
        SparkSprites(x, 2) = SwapColor(SparkSprites(x, 2), _RGB(254, 254, 254), _RGB(248, 56, 0))
    NEXT x
    FOR x = 1 TO 4
        SparkSprites(x, 3) = _COPYIMAGE(SparkSprites(x, 1))
        SparkSprites(x, 3) = SwapColor(SparkSprites(x, 3), _RGB(248, 56, 0), _RGB(228, 92, 16))
        SparkSprites(x, 3) = SwapColor(SparkSprites(x, 3), _RGB(0, 136, 136), _RGB(255, 160, 68))
        SparkSprites(x, 3) = SwapColor(SparkSprites(x, 3), _RGB(254, 254, 254), _RGB(184, 248, 24))
    NEXT x
    FOR x = 1 TO 4
        SparkSprites(x, 4) = _COPYIMAGE(SparkSprites(x, 1))
        SparkSprites(x, 4) = SwapColor(SparkSprites(x, 4), _RGB(248, 56, 0), _RGB(255, 255, 255))
        SparkSprites(x, 4) = SwapColor(SparkSprites(x, 4), _RGB(0, 136, 136), _RGB(104, 136, 255))
        SparkSprites(x, 4) = SwapColor(SparkSprites(x, 4), _RGB(254, 254, 254), _RGB(0, 0, 188))
    NEXT x


    OctorokSprites(1, 1) = _LOADIMAGE("Images\OctorokN1.png")
    OctorokSprites(1, 2) = _LOADIMAGE("Images\OctorokN2.png")
    OctorokSprites(2, 1) = _LOADIMAGE("Images\OctorokE1.png")
    OctorokSprites(2, 2) = _LOADIMAGE("Images\OctorokE2.png")
    OctorokSprites(3, 1) = _LOADIMAGE("Images\OctorokS1.png")
    OctorokSprites(3, 2) = _LOADIMAGE("Images\OctorokS2.png")
    OctorokSprites(4, 1) = _LOADIMAGE("Images\OctorokW1.png")
    OctorokSprites(4, 2) = _LOADIMAGE("Images\OctorokW2.png")
    FOR x = 1 TO 4
        FOR y = 3 TO 4
            OctorokSprites(x, y) = _COPYIMAGE(OctorokSprites(x, y - 2))
            OctorokSprites(x, y) = SwapColor(OctorokSprites(x, y), _RGB(248, 56, 0), _RGB(0, 0, 188))
            OctorokSprites(x, y) = SwapColor(OctorokSprites(x, y), _RGB(255, 160, 68), _RGB(104, 136, 255))
        NEXT y
    NEXT x

    OctoRockSprite = _LOADIMAGE("Images\OctoRock.png")

    GoriyaSprites(1, 1) = _LOADIMAGE("Images\GoriyaN1.png")
    GoriyaSprites(1, 2) = _LOADIMAGE("Images\GoriyaN2.png")
    GoriyaSprites(2, 1) = _LOADIMAGE("Images\GoriyaE1.png")
    GoriyaSprites(2, 2) = _LOADIMAGE("Images\GoriyaE2.png")
    GoriyaSprites(3, 1) = _LOADIMAGE("Images\GoriyaS1.png")
    GoriyaSprites(3, 2) = _LOADIMAGE("Images\GoriyaS2.png")
    GoriyaSprites(4, 1) = _LOADIMAGE("Images\GoriyaW1.png")
    GoriyaSprites(4, 2) = _LOADIMAGE("Images\GoriyaW2.png")
    FOR x = 1 TO 4
        FOR y = 3 TO 4
            GoriyaSprites(x, y) = _COPYIMAGE(GoriyaSprites(x, y - 2))
            GoriyaSprites(x, y) = SwapColor(GoriyaSprites(x, y), _RGB(248, 56, 0), _RGB(0, 0, 188))
            GoriyaSprites(x, y) = SwapColor(GoriyaSprites(x, y), _RGB(255, 160, 68), _RGB(104, 136, 255))
        NEXT y
    NEXT x


    BoomerangSprites(1, 1) = _LOADIMAGE("Images\Boom1.png")
    BoomerangSprites(2, 1) = _LOADIMAGE("Images\Boom2.png")
    BoomerangSprites(3, 1) = _LOADIMAGE("Images\Boom3.png")
    BoomerangSprites(4, 1) = _LOADIMAGE("Images\Boom4.png")
    BoomerangSprites(5, 1) = _LOADIMAGE("Images\Boom5.png")
    BoomerangSprites(6, 1) = _LOADIMAGE("Images\Boom6.png")
    BoomerangSprites(7, 1) = _LOADIMAGE("Images\Boom7.png")
    BoomerangSprites(8, 1) = _LOADIMAGE("Images\Boom8.png")
    FOR x = 1 TO 8
        BoomerangSprites(x, 2) = _COPYIMAGE(BoomerangSprites(x, 1))
        BoomerangSprites(x, 2) = SwapColor(BoomerangSprites(x, 2), _RGB(252, 152, 56), _RGB(92, 148, 252))
        BoomerangSprites(x, 2) = SwapColor(BoomerangSprites(x, 2), _RGB(128, 208, 16), _RGB(0, 0, 188))
        BoomerangSprites(x, 2) = SwapColor(BoomerangSprites(x, 2), _RGB(200, 76, 12), _RGB(255, 255, 255))
    NEXT x


    MoblinSprites(1, 1) = _LOADIMAGE("Images\MoblinN1.png")
    MoblinSprites(1, 2) = _LOADIMAGE("Images\MoblinN2.png")
    MoblinSprites(2, 1) = _LOADIMAGE("Images\MoblinE1.png")
    MoblinSprites(2, 2) = _LOADIMAGE("Images\MoblinE2.png")
    MoblinSprites(3, 1) = _LOADIMAGE("Images\MoblinS1.png")
    MoblinSprites(3, 2) = _LOADIMAGE("Images\MoblinS2.png")
    MoblinSprites(4, 1) = _LOADIMAGE("Images\MoblinW1.png")
    MoblinSprites(4, 2) = _LOADIMAGE("Images\MoblinW2.png")
    FOR x = 1 TO 4
        FOR y = 3 TO 4
            MoblinSprites(x, y) = _COPYIMAGE(MoblinSprites(x, y - 2))
            MoblinSprites(x, y) = SwapColor(MoblinSprites(x, y), _RGB(248, 56, 0), _RGB(1, 1, 1))
            MoblinSprites(x, y) = SwapColor(MoblinSprites(x, y), _RGB(255, 160, 68), _RGB(0, 136, 136))
            MoblinSprites(x, y) = SwapColor(MoblinSprites(x, y), _RGB(255, 255, 255), _RGB(248, 56, 0))
        NEXT y
    NEXT x


    ArrowSprites(1, 1) = _LOADIMAGE("Images\ArrowN.png")
    ArrowSprites(2, 1) = _LOADIMAGE("Images\ArrowE.png")
    ArrowSprites(3, 1) = _LOADIMAGE("Images\ArrowS.png")
    ArrowSprites(4, 1) = _LOADIMAGE("Images\ArrowW.png")
    FOR x = 1 TO 4
        ArrowSprites(x, 2) = _COPYIMAGE(ArrowSprites(x, 1))
        ArrowSprites(x, 2) = SwapColor(ArrowSprites(x, 2), _RGB(184, 248, 24), _RGB(248, 56, 0))
        ArrowSprites(x, 2) = SwapColor(ArrowSprites(x, 2), _RGB(228, 92, 16), _RGB(255, 255, 255))
    NEXT x
    FOR x = 1 TO 4
        ArrowSprites(x, 3) = _COPYIMAGE(ArrowSprites(x, 1))
        ArrowSprites(x, 3) = SwapColor(ArrowSprites(x, 3), _RGB(184, 248, 24), _RGB(0, 0, 188))
        ArrowSprites(x, 3) = SwapColor(ArrowSprites(x, 3), _RGB(228, 92, 16), _RGB(255, 255, 255))
        ArrowSprites(x, 3) = SwapColor(ArrowSprites(x, 3), _RGB(255, 160, 68), _RGB(104, 136, 255))
    NEXT x


    RopeSprites(1, 1) = _LOADIMAGE("Images\Rope1.png")
    RopeSprites(1, 2) = _LOADIMAGE("Images\Rope2.png")
    RopeSprites(2, 1) = _LOADIMAGE("Images\Rope3.png")
    RopeSprites(2, 2) = _LOADIMAGE("Images\Rope4.png")


    DarknutSprites(1, 1) = _LOADIMAGE("Images\DarknutN1.png")
    DarknutSprites(1, 2) = _LOADIMAGE("Images\DarknutN2.png")
    DarknutSprites(2, 1) = _LOADIMAGE("Images\DarknutE1.png")
    DarknutSprites(2, 2) = _LOADIMAGE("Images\DarknutE2.png")
    DarknutSprites(3, 1) = _LOADIMAGE("Images\DarknutS1.png")
    DarknutSprites(3, 2) = _LOADIMAGE("Images\DarknutS2.png")
    DarknutSprites(4, 1) = _LOADIMAGE("Images\DarknutW1.png")
    DarknutSprites(4, 2) = _LOADIMAGE("Images\DarknutW2.png")
    FOR x = 1 TO 4
        FOR y = 3 TO 4
            DarknutSprites(x, y) = _COPYIMAGE(DarknutSprites(x, y - 2))
            DarknutSprites(x, y) = SwapColor(DarknutSprites(x, y), _RGB(248, 56, 0), _RGB(0, 0, 188))
            DarknutSprites(x, y) = SwapColor(DarknutSprites(x, y), _RGB(255, 160, 68), _RGB(104, 136, 255))
        NEXT y
    NEXT x


    LynelSprites(1, 1) = _LOADIMAGE("Images\LynelN1.png")
    LynelSprites(1, 2) = _LOADIMAGE("Images\LynelN2.png")
    LynelSprites(2, 1) = _LOADIMAGE("Images\LynelE1.png")
    LynelSprites(2, 2) = _LOADIMAGE("Images\LynelE2.png")
    LynelSprites(3, 1) = _LOADIMAGE("Images\LynelS1.png")
    LynelSprites(3, 2) = _LOADIMAGE("Images\LynelS2.png")
    LynelSprites(4, 1) = _LOADIMAGE("Images\LynelW1.png")
    LynelSprites(4, 2) = _LOADIMAGE("Images\LynelW2.png")
    FOR x = 1 TO 4
        FOR y = 3 TO 4
            LynelSprites(x, y) = _COPYIMAGE(LynelSprites(x, y - 2))
            LynelSprites(x, y) = SwapColor(LynelSprites(x, y), _RGB(248, 56, 0), _RGB(0, 0, 188))
            LynelSprites(x, y) = SwapColor(LynelSprites(x, y), _RGB(255, 160, 68), _RGB(104, 136, 255))
        NEXT y
    NEXT x

    KeeseSprites(1) = _LOADIMAGE("Images\Keese1.png")
    KeeseSprites(2) = _LOADIMAGE("Images\Keese2.png")
    FOR y = 3 TO 4
        KeeseSprites(y) = _COPYIMAGE(KeeseSprites(y - 2))
        KeeseSprites(y) = SwapColor(KeeseSprites(y), _RGB(0, 0, 188), _RGB(248, 56, 0))
        KeeseSprites(y) = SwapColor(KeeseSprites(y), _RGB(104, 136, 255), _RGB(255, 160, 68))
    NEXT y


    PeahatSprites(1) = _LOADIMAGE("Images\Peahat1.png")
    PeahatSprites(2) = _LOADIMAGE("Images\Peahat2.png")

    GibdoSprites(1) = _LOADIMAGE("Images\Gibdo1.png")
    GibdoSprites(2) = _LOADIMAGE("Images\Gibdo2.png")

    ArmosSprites(1, 1) = _LOADIMAGE("Images\Armos11.png")
    ArmosSprites(1, 2) = _LOADIMAGE("Images\Armos12.png")
    ArmosSprites(2, 1) = _LOADIMAGE("Images\Armos21.png")
    ArmosSprites(2, 2) = _LOADIMAGE("Images\Armos22.png")

    FlameSprites(1) = _LOADIMAGE("Images\Fire1.png")
    FlameSprites(2) = _LOADIMAGE("Images\Fire2.png")

    FireballSprite& = _LOADIMAGE("Images\Fireball.png")

    LanmolaSprites(1, 1) = _LOADIMAGE("Images\Lanmola1.png")
    LanmolaSprites(1, 2) = _LOADIMAGE("Images\Lanmola2.png")
    FOR x = 1 TO 2
        LanmolaSprites(2, x) = _COPYIMAGE(LanmolaSprites(1, x))
        LanmolaSprites(2, x) = SwapColor(LanmolaSprites(2, x), _RGB(248, 56, 0), _RGB(0, 0, 188))
        LanmolaSprites(2, x) = SwapColor(LanmolaSprites(2, x), _RGB(255, 160, 68), _RGB(104, 136, 255))
    NEXT x

    StalfosSprites(1) = _LOADIMAGE("Images\Stalfos1.png")
    StalfosSprites(2) = _LOADIMAGE("Images\Stalfos2.png")

    GelSprites(1) = _LOADIMAGE("Images\Gel1.png")
    GelSprites(2) = _LOADIMAGE("Images\Gel2.png")

    ZolSprites(1) = _LOADIMAGE("Images\Zol1.png")
    ZolSprites(2) = _LOADIMAGE("Images\Zol2.png")

    TrapSprite = _LOADIMAGE("Images\Trap.png")

    PatraSprites(1, 1) = _LOADIMAGE("Images\Patra11.png")
    PatraSprites(1, 2) = _LOADIMAGE("Images\Patra12.png")
    PatraSprites(2, 1) = _LOADIMAGE("Images\Patra21.png")
    PatraSprites(2, 2) = _LOADIMAGE("Images\Patra22.png")

    WizzrobeSprites(1, 1) = _LOADIMAGE("Images\Wizzrobe12.png")
    WizzrobeSprites(1, 2) = _LOADIMAGE("Images\Wizzrobe22.png")
    WizzrobeSprites(2, 1) = _LOADIMAGE("Images\Wizzrobe13.png")
    WizzrobeSprites(2, 2) = _LOADIMAGE("Images\Wizzrobe23.png")
    WizzrobeSprites(3, 1) = _LOADIMAGE("Images\Wizzrobe13.png")
    WizzrobeSprites(3, 2) = _LOADIMAGE("Images\Wizzrobe23.png")
    WizzrobeSprites(4, 1) = _LOADIMAGE("Images\Wizzrobe11.png")
    WizzrobeSprites(4, 2) = _LOADIMAGE("Images\Wizzrobe21.png")
    FOR x = 5 TO 8
        FOR y = 1 TO 2
            WizzrobeSprites(x, y) = _COPYIMAGE(WizzrobeSprites(x - 4, y))
            WizzrobeSprites(x, y) = SwapColor(WizzrobeSprites(x, y), _RGB(248, 56, 0), _RGB(0, 0, 188))
            WizzrobeSprites(x, y) = SwapColor(WizzrobeSprites(x, y), _RGB(255, 160, 68), _RGB(104, 136, 255))
        NEXT y
    NEXT x

    MagicSprites(1) = _LOADIMAGE("Images\MagicN.png")
    MagicSprites(2) = _LOADIMAGE("Images\MagicE.png")
    MagicSprites(3) = _LOADIMAGE("Images\MagicS.png")
    MagicSprites(4) = _LOADIMAGE("Images\MagicW.png")

    GhiniSprites(1) = _LOADIMAGE("Images\Ghini1.png")
    GhiniSprites(2) = _LOADIMAGE("Images\Ghini2.png")
    GhiniSprites(3) = _LOADIMAGE("Images\Ghini3.png")
    GhiniSprites(4) = _LOADIMAGE("Images\Ghini4.png")

    LeeverSprites(1, 1) = _LOADIMAGE("Images\Leever1.png")
    LeeverSprites(1, 2) = _LOADIMAGE("Images\Leever2.png")
    LeeverSprites(1, 3) = _LOADIMAGE("Images\Leever3.png")
    LeeverSprites(1, 4) = _LOADIMAGE("Images\Leever4.png")
    LeeverSprites(1, 5) = _LOADIMAGE("Images\Leever5.png")
    LeeverSprites(2, 1) = _COPYIMAGE(LeeverSprites(1, 1))
    LeeverSprites(2, 2) = _COPYIMAGE(LeeverSprites(1, 2))
    FOR y = 3 TO 5
        LeeverSprites(2, y) = _COPYIMAGE(LeeverSprites(1, y))
        LeeverSprites(2, y) = SwapColor(LeeverSprites(2, y), _RGB(248, 56, 0), _RGB(0, 0, 188))
        LeeverSprites(2, y) = SwapColor(LeeverSprites(2, y), _RGB(255, 160, 68), _RGB(104, 136, 255))
    NEXT y


    TektiteSprites(1, 1) = _LOADIMAGE("Images\Tektite1.png")
    TektiteSprites(1, 2) = _LOADIMAGE("Images\Tektite2.png")
    FOR x = 1 TO 2
        TektiteSprites(2, x) = _COPYIMAGE(TektiteSprites(1, x))
        TektiteSprites(2, x) = SwapColor(TektiteSprites(2, x), _RGB(248, 56, 0), _RGB(0, 0, 188))
        TektiteSprites(2, x) = SwapColor(TektiteSprites(2, x), _RGB(255, 160, 68), _RGB(104, 136, 255))
    NEXT x

    WaterfallSprites(1) = _LOADIMAGE("Images\Waterfall1.png")
    WaterfallSprites(2) = _LOADIMAGE("Images\Waterfall2.png")
    WaterfallSprites(3) = _LOADIMAGE("Images\Waterfall3.png")

    ZoraSprites(1) = _LOADIMAGE("Images\Zora1.png")
    ZoraSprites(2) = _LOADIMAGE("Images\Zora2.png")
    ZoraSprites(3) = _LOADIMAGE("Images\Zora3.png")

    VireSprites(1, 1) = _LOADIMAGE("Images\Vire11.png")
    VireSprites(1, 2) = _LOADIMAGE("Images\Vire12.png")
    VireSprites(2, 1) = _LOADIMAGE("Images\Vire21.png")
    VireSprites(2, 2) = _LOADIMAGE("Images\Vire22.png")

    BubbleSprite = _LOADIMAGE("Images\Bubble.png")

    LikeLikeSprites(1) = _LOADIMAGE("Images\Like1.png")
    LikeLikeSprites(2) = _LOADIMAGE("Images\Like2.png")
    LikeLikeSprites(3) = _LOADIMAGE("Images\Like3.png")

    PolsVoiceSprites(1) = _LOADIMAGE("Images\Pol1.png")
    PolsVoiceSprites(2) = _LOADIMAGE("Images\Pol2.png")

    AquamentusSprites(1, 1) = _LOADIMAGE("Images\Aqua1.png")
    AquamentusSprites(2, 1) = _LOADIMAGE("Images\Aqua2.png")
    AquamentusSprites(1, 2) = _LOADIMAGE("Images\Aqua3.png")
    AquamentusSprites(2, 2) = _LOADIMAGE("Images\Aqua4.png")

    DodongoSprites(1, 1) = _LOADIMAGE("Images\DodongoN1.png")
    DodongoSprites(2, 1) = _LOADIMAGE("Images\DodongoE1.png")
    DodongoSprites(3, 1) = _LOADIMAGE("Images\DodongoS1.png")
    DodongoSprites(4, 1) = _LOADIMAGE("Images\DodongoW1.png")
    DodongoSprites(1, 2) = _LOADIMAGE("Images\DodongoN2.png")
    DodongoSprites(2, 2) = _LOADIMAGE("Images\DodongoE2.png")
    DodongoSprites(3, 2) = _LOADIMAGE("Images\DodongoS2.png")
    DodongoSprites(4, 2) = _LOADIMAGE("Images\DodongoW2.png")
    DodongoSprites(1, 3) = _LOADIMAGE("Images\DodongoN3.png")
    DodongoSprites(2, 3) = _LOADIMAGE("Images\DodongoE3.png")
    DodongoSprites(3, 3) = _LOADIMAGE("Images\DodongoS3.png")
    DodongoSprites(4, 3) = _LOADIMAGE("Images\DodongoW3.png")

    ManhandlaSprites(1, 1) = _LOADIMAGE("Images\ManhandlaN1.png")
    ManhandlaSprites(1, 2) = _LOADIMAGE("Images\ManhandlaN2.png")
    ManhandlaSprites(2, 1) = _LOADIMAGE("Images\ManhandlaE1.png")
    ManhandlaSprites(2, 2) = _LOADIMAGE("Images\ManhandlaE2.png")
    ManhandlaSprites(3, 1) = _LOADIMAGE("Images\ManhandlaS1.png")
    ManhandlaSprites(3, 2) = _LOADIMAGE("Images\ManhandlaS2.png")
    ManhandlaSprites(4, 1) = _LOADIMAGE("Images\ManhandlaW1.png")
    ManhandlaSprites(4, 2) = _LOADIMAGE("Images\ManhandlaW2.png")
    ManhandlaSprites(5, 1) = _LOADIMAGE("Images\ManhandlaM.png")

    GleeokSprites(1, 1) = _LOADIMAGE("Images\GleeokM1.png")
    GleeokSprites(1, 2) = _LOADIMAGE("Images\GleeokM2.png")
    GleeokSprites(1, 3) = _LOADIMAGE("Images\GleeokM3.png")
    GleeokSprites(2, 1) = _LOADIMAGE("Images\GleeokNeck.png")
    GleeokSprites(3, 1) = _LOADIMAGE("Images\GleeokHead1.png")
    GleeokSprites(3, 2) = _LOADIMAGE("Images\GleeokHead2.png")
    GleeokSprites(3, 3) = _LOADIMAGE("Images\GleeokHead3.png")

    DigdoggerSprites(1, 1) = _LOADIMAGE("Images\Digdogger11.png")
    DigdoggerSprites(1, 2) = _LOADIMAGE("Images\Digdogger12.png")
    DigdoggerSprites(2, 1) = _LOADIMAGE("Images\Digdogger21.png")
    DigdoggerSprites(2, 2) = _LOADIMAGE("Images\Digdogger22.png")

    GohmaSprites(1, 1) = _LOADIMAGE("Images\Gohma1.png")
    GohmaSprites(2, 1) = _LOADIMAGE("Images\Gohma2.png")
    GohmaSprites(3, 1) = _LOADIMAGE("Images\Gohma3.png")
    GohmaSprites(4, 1) = _LOADIMAGE("Images\Gohma4.png")
    GohmaSprites(5, 1) = _LOADIMAGE("Images\Gohma5.png")
    GohmaSprites(6, 1) = _LOADIMAGE("Images\Gohma6.png")
    GohmaSprites(7, 1) = _LOADIMAGE("Images\Gohma7.png")
    GohmaSprites(8, 1) = _LOADIMAGE("Images\Gohma8.png")
    FOR x = 1 TO 8
        GohmaSprites(x, 2) = _COPYIMAGE(GohmaSprites(x, 1))
        GohmaSprites(x, 2) = SwapColor(GohmaSprites(x, 2), _RGB(248, 56, 0), _RGB(0, 0, 188))
        GohmaSprites(x, 2) = SwapColor(GohmaSprites(x, 2), _RGB(255, 160, 68), _RGB(104, 136, 255))
    NEXT x

    GannonSprites(1) = _LOADIMAGE("Images\Gannon1.png")
    GannonSprites(2) = _LOADIMAGE("Images\Gannon2.png")
    GannonSprites(3) = _LOADIMAGE("Images\Gannon3.png")
    GannonSprites(4) = _LOADIMAGE("Images\Gannon4.png")
    GannonSprites(5) = _LOADIMAGE("Images\Gannon5.png")
    GannonSprites(6) = _LOADIMAGE("Images\Gannon6.png")

    WaterSprites(1) = _LOADIMAGE("Images\Water1.png")
    WaterSprites(2) = _LOADIMAGE("Images\Water2.png")
    WaterSprites(3) = _LOADIMAGE("Images\Water3.png")
    WaterSprites(4) = _LOADIMAGE("Images\Water4.png")

    HeartSprites(3) = _LOADIMAGE("Images\BigHeart.png")
    HeartSprites(1) = _LOADIMAGE("Images\Heart.png")
    HeartSprites(2) = _COPYIMAGE(HeartSprites(1))
    HeartSprites(2) = SwapColor(HeartSprites(2), _RGB(0, 0, 188), _RGB(248, 56, 0))
    HeartSprites(4) = _COPYIMAGE(HeartSprites(1))
    HeartSprites(4) = SwapColor(HeartSprites(4), _RGB(0, 0, 188), _RGB(252, 188, 176))
    HeartSprites(5) = _LOADIMAGE("Images\Heart2.png")
    HeartSprites(6) = _LOADIMAGE("Images\Heart3.png")
    HeartSprites(7) = _LOADIMAGE("Images\Heart4.png")

    RupeeSprites(1) = _LOADIMAGE("Images\Rupee.png")
    RupeeSprites(2) = _COPYIMAGE(RupeeSprites(1))
    RupeeSprites(2) = SwapColor(RupeeSprites(2), _RGB(255, 160, 68), _RGB(104, 136, 255))

    FairySprites(1) = _LOADIMAGE("Images\Fairy1.png")
    FairySprites(2) = _LOADIMAGE("Images\Fairy2.png")

    WandSprites(1) = _LOADIMAGE("Images\Wand1.png")
    WandSprites(2) = _LOADIMAGE("Images\Wand2.png")
    WandSprites(3) = _LOADIMAGE("Images\Wand3.png")
    WandSprites(4) = _LOADIMAGE("Images\Wand4.png")

    CandleSprites(1) = _LOADIMAGE("Images\Candle.png")
    CandleSprites(2) = _COPYIMAGE(CandleSprites(1))
    CandleSprites(2) = SwapColor(CandleSprites(2), _RGB(0, 0, 188), _RGB(248, 56, 0))
    CandleSprites(2) = SwapColor(CandleSprites(2), _RGB(104, 136, 255), _RGB(255, 160, 68))

    DeathSprites(1) = _LOADIMAGE("Images\Death1.png")
    DeathSprites(2) = _LOADIMAGE("Images\Death2.png")
    DeathSprites(3) = _LOADIMAGE("Images\Death3.png")

    CloudSprites(1) = _LOADIMAGE("Images\Cloud1.png")
    CloudSprites(2) = _LOADIMAGE("Images\Cloud2.png")
    CloudSprites(3) = _LOADIMAGE("Images\Cloud3.png")
    CloudSprites(4) = _LOADIMAGE("Images\Cloud4.png")

    PotionSprites(2) = _LOADIMAGE("Images\Potion.png")
    PotionSprites(1) = _COPYIMAGE(PotionSprites(2))
    PotionSprites(1) = SwapColor(PotionSprites(1), _RGB(248, 56, 0), _RGB(0, 0, 188))
    PotionSprites(1) = SwapColor(PotionSprites(1), _RGB(255, 160, 68), _RGB(104, 136, 255))

    RingSprites(1) = _LOADIMAGE("Images\Ring.png")
    RingSprites(2) = _COPYIMAGE(RingSprites(1))
    RingSprites(2) = SwapColor(RingSprites(2), _RGB(0, 0, 188), _RGB(248, 56, 0))
    RingSprites(2) = SwapColor(RingSprites(2), _RGB(104, 136, 255), _RGB(255, 160, 68))

    KeySprites(1) = _LOADIMAGE("Images\Key.png")
    KeySprites(2) = _LOADIMAGE("Images\MasterKey.png")

    TriforceSprites(1) = _LOADIMAGE("Images\Triforce.png")
    TriforceSprites(2) = _COPYIMAGE(TriforceSprites(1))
    TriforceSprites(2) = SwapColor(TriforceSprites(2), _RGB(104, 136, 255), _RGB(255, 160, 68))
    TriforceSprites(3) = _LOADIMAGE("Images\Triforce2.png")
    TriforceSprites(4) = _LOADIMAGE("Images\Triforce3.png")

    ShieldSprites(2) = _LOADIMAGE("Images\Shield3.png")
    ShieldSprites(3) = _LOADIMAGE("Images\Shield2.png")
    ShieldSprites(4) = _LOADIMAGE("Images\Shield1.png")

    RaftSprites(1) = _LOADIMAGE("Images\Raft1.png")
    RaftSprites(2) = _LOADIMAGE("Images\Raft2.png")
    RaftSprites(3) = _LOADIMAGE("Images\Raft3.png")
    RaftSprites(4) = _LOADIMAGE("Images\Raft4.png")

    CharacterSprites(1) = _LOADIMAGE("Images\Guy.png")
    CharacterSprites(2) = _LOADIMAGE("Images\OldMan.png")
    CharacterSprites(3) = _LOADIMAGE("Images\OldWoman.png")
    CharacterSprites(4) = _LOADIMAGE("Images\Zelda.png")
    CharacterSprites(5) = _LOADIMAGE("Images\Zelda2.png")

    TriforceUISprites(1) = _LOADIMAGE("Images\UITri1.png")
    TriforceUISprites(2) = _LOADIMAGE("Images\UITri2.png")
    TriforceUISprites(3) = _LOADIMAGE("Images\UITri3.png")
    TriforceUISprites(4) = _LOADIMAGE("Images\UITri4.png")

    BombSprite = _LOADIMAGE("Images\Bomb.png")
    FluteSprite = _LOADIMAGE("Images\Flute.png")
    BowSprite = _LOADIMAGE("Images\Bow.png")
    ClockSprite = _LOADIMAGE("Images\Clock.png")
    BookSprite = _LOADIMAGE("Images\Book.png")
    FoodSprite = _LOADIMAGE("Images\Food.png")
    LadderSprite = _LOADIMAGE("Images\Ladder2.png")
    CursorSprite = _LOADIMAGE("Images\Cursor.png")

    StoreItemSprites(1) = _COPYIMAGE(BombSprite)
    StoreItemSprites(2) = _LOADIMAGE("Images\Shield4.png")
    StoreItemSprites(3) = _COPYIMAGE(CandleSprites(1))
    StoreItemSprites(4) = _COPYIMAGE(HeartSprites(2))
    StoreItemSprites(5) = _COPYIMAGE(KeySprites(1))
    StoreItemSprites(6) = _COPYIMAGE(RingSprites(1))
    StoreItemSprites(7) = _COPYIMAGE(PotionSprites(1))
    StoreItemSprites(8) = _COPYIMAGE(PotionSprites(2))
    StoreItemSprites(9) = _COPYIMAGE(FoodSprite)
END SUB




'*********************************************************
'* Runs through the level data and spawns all sprites needed
'*
'*
'*********************************************************
SUB SpawnSpriteMatrix (Cleared)
    FOR y = 1 TO ActiveMap.SpriteLimitY
        FOR x = 1 TO ActiveMap.SpriteLimitX
            Spawn = SpriteMatrix(x, y)
            SpawnName$ = ""
            Health = 0
            IF Spawn = 2 AND Cleared = 0 THEN SpawnName$ = "RDark"
            IF Spawn = 3 AND Cleared = 0 THEN SpawnName$ = "BDark"
            IF Spawn = 4 AND Cleared = 0 THEN SpawnName$ = "Gibdo"
            IF Spawn = 5 AND Cleared = 0 THEN SpawnName$ = "RGori"
            IF Spawn = 6 AND Cleared = 0 THEN SpawnName$ = "BGori"
            IF Spawn = 7 AND Cleared = 0 THEN SpawnName$ = "Keese"
            IF Spawn = 8 AND Cleared = 0 THEN SpawnName$ = "RLanm"
            IF Spawn = 9 AND Cleared = 0 THEN SpawnName$ = "FSnak"
            IF Spawn = 10 AND Cleared = 0 THEN SpawnName$ = "RLyne"
            IF Spawn = 11 AND Cleared = 0 THEN SpawnName$ = "BLyne"
            IF Spawn = 12 AND Cleared = 0 THEN SpawnName$ = "RMobl"
            IF Spawn = 13 AND Cleared = 0 THEN SpawnName$ = "BMobl"
            IF Spawn = 14 AND Cleared = 0 THEN SpawnName$ = "ROcto"
            IF Spawn = 15 AND Cleared = 0 THEN SpawnName$ = "BOcto"
            IF Spawn = 16 AND Cleared = 0 THEN SpawnName$ = "Rope "
            IF Spawn = 17 AND Cleared = 0 THEN SpawnName$ = "Peaha"
            IF Spawn = 18 AND Cleared = 0 THEN SpawnName$ = "BLanm"
            IF Spawn = 19 AND Cleared = 0 THEN SpawnName$ = "Stalf"
            IF Spawn = 20 AND Cleared = 0 THEN SpawnName$ = "Gel  "
            IF Spawn = 21 AND Cleared = 0 THEN SpawnName$ = "Zol  "
            IF Spawn = 22 AND Cleared = 0 THEN SpawnName$ = "Patra"
            IF Spawn = 23 AND Cleared = 0 THEN SpawnName$ = "RWizz"
            IF Spawn = 24 AND Cleared = 0 THEN SpawnName$ = "BWizz"
            IF Spawn = 25 AND Cleared = 0 THEN SpawnName$ = "Ghini"
            IF Spawn = 26 AND Cleared = 0 THEN SpawnName$ = "RTekt"
            IF Spawn = 27 AND Cleared = 0 THEN SpawnName$ = "BTekt"
            IF Spawn = 28 AND Cleared = 0 THEN SpawnName$ = "RLeev"
            IF Spawn = 29 AND Cleared = 0 THEN SpawnName$ = "BLeev"
            IF Spawn = 30 AND Cleared = 0 THEN SpawnName$ = "Trap "
            IF Spawn = 31 THEN SpawnName$ = "Flame"
            IF Spawn = 32 THEN SpawnName$ = "SWate"
            IF Spawn = 33 AND Cleared = 0 THEN SpawnName$ = "Zora "
            IF Spawn = 34 AND Cleared = 0 THEN SpawnName$ = "Vire "
            IF Spawn = 35 AND Cleared = 0 THEN SpawnName$ = "Bubbl"
            IF Spawn = 36 AND Cleared = 0 THEN SpawnName$ = "LikeL"
            IF Spawn = 37 AND Cleared = 0 THEN SpawnName$ = "PolsV"
            IF Spawn = 38 AND Cleared = 0 THEN SpawnName$ = "Aqua "
            IF Spawn = 39 AND Cleared = 0 THEN SpawnName$ = "Dodon"
            IF Spawn = 40 AND Cleared = 0 THEN SpawnName$ = "ManhM"
            IF Spawn = 41 AND Cleared = 0 THEN
                SpawnName$ = "GleeM"
                Health = SpriteMatrix(x, y + 1)
                SpriteMatrix(x, y + 1) = 0
                IF Health = 0 THEN Health = 1
                IF Health > 8 THEN Health = 8
            END IF
            IF Spawn = 42 AND Cleared = 0 THEN SpawnName$ = "Digdo"
            IF Spawn = 43 AND Cleared = 0 THEN SpawnName$ = "RGohm"
            IF Spawn = 44 AND Cleared = 0 THEN SpawnName$ = "BGohm"
            IF Spawn = 45 AND Cleared = 0 THEN SpawnName$ = "Ganno"

            'IF Spawn = 46 THEN SpawnName$ = "P-RPo": Health = Spawn
            IF Spawn = 47 THEN SpawnName$ = "P-BCa": Health = Spawn
            IF Spawn = 48 THEN SpawnName$ = "P-BRi": Health = Spawn
            IF Spawn = 49 THEN SpawnName$ = "P-Boo": Health = Spawn
            IF Spawn = 50 THEN SpawnName$ = "P-Bom": Health = Spawn
            IF Spawn = 51 THEN SpawnName$ = "P-Bow": Health = Spawn
            'IF Spawn = 52 THEN SpawnName$ = "P-Foo": Health = Spawn
            IF Spawn = 53 THEN SpawnName$ = "P-Hea": Health = Spawn
            IF Spawn = 54 THEN SpawnName$ = "P-Key": Health = Spawn
            IF Spawn = 55 THEN SpawnName$ = "P-Lad": Health = Spawn
            'IF Spawn = 56 THEN SpawnName$ = "P-BPo": Health = Spawn
            IF Spawn = 57 THEN SpawnName$ = "P-SAr": Health = Spawn
            IF Spawn = 58 THEN SpawnName$ = "P-MSw": Health = Spawn
            IF Spawn = 59 THEN SpawnName$ = "P-BBo": Health = Spawn
            IF Spawn = 60 THEN SpawnName$ = "P-MKe": Health = Spawn
            IF Spawn = 61 THEN SpawnName$ = "P-Mwa": Health = Spawn
            IF Spawn = 62 THEN SpawnName$ = "P-Raf": Health = Spawn
            IF Spawn = 63 THEN SpawnName$ = "P-Flu": Health = Spawn
            IF Spawn = 64 THEN SpawnName$ = "P-RCa": Health = Spawn
            IF Spawn = 65 THEN SpawnName$ = "P-RRi": Health = Spawn
            IF Spawn = 66 THEN SpawnName$ = "P-Swo": Health = Spawn
            IF Spawn = 67 THEN SpawnName$ = "P-Tri": Health = Spawn
            IF Spawn = 68 THEN SpawnName$ = "P-WSw": Health = Spawn
            IF Spawn = 69 THEN SpawnName$ = "P-MAS": Health = Spawn
            IF Spawn = 70 THEN SpawnName$ = "KStal"
            IF Spawn = 71 THEN SpawnName$ = "Water"
            IF Spawn = 72 THEN SpawnName$ = "Guy"
            IF Spawn = 73 THEN SpawnName$ = "OldMa"
            IF Spawn = 74 THEN SpawnName$ = "OldWo"
            IF Spawn = 75 THEN SpawnName$ = "Zelda"
            IF Spawn = 76 THEN SpawnName$ = "HHear"
            IF Spawn = 77 THEN SpawnName$ = "HBomb"
            IF Spawn = 78 THEN SpawnName$ = "Grumb"
            IF Spawn = 79 THEN SpawnName$ = "KFire"


            SpriteWidth = (Settings.SquareWidth / 2) - 1
            SpriteHeight = (Settings.SquareHeight / 2) - 1
            SpriteX = (Settings.SquareWidth * (x - 1)) + Settings.LeftLimit + SpriteWidth
            SpriteY = (Settings.SquareHeight * (y - 1)) + Settings.TopLimit + SpriteHeight

            IF Spawn > Settings.SpriteDivider + 5 AND ActiveMap.Type = 2 THEN
                CALL SpawnSpecialSprite(Spawn, SpriteX, SpriteY)
            ELSEIF Spawn > Settings.SpriteDivider + 89 AND ActiveMap.Type = 1 THEN
                CALL SpawnSpecialSprite(Spawn, SpriteX, SpriteY)
            ELSEIF Spawn <> 0 AND Spawn < Settings.SpriteDivider + 1 THEN
                CALL SpawnSprite(SpawnName$, SpriteX, SpriteY, 0, Health, 0, 0)
            END IF

        NEXT x
    NEXT y
END SUB



'*********************************************************
'* Draws and executes everything in the 'Sprites' matrix
'*
'*
'*********************************************************

SUB DrawMobs
    FOR x = 1 TO Settings.MatrixSize
        IF Sprites(x).Active = 1 THEN
            IF Sprites(x).Health < 1 THEN CALL SpriteDeath(x)

            IF Sprites(x).Name = "Spark" THEN
                CALL SwordSparks(x)

            ELSEIF RIGHT$(Sprites(x).Name, 4) = "Octo" THEN
                CALL OctorockMain(x)

            ELSEIF RIGHT$(Sprites(x).Name, 4) = "Gori" THEN
                CALL GoriyaMain(x)

            ELSEIF RIGHT$(Sprites(x).Name, 4) = "Mobl" THEN
                CALL MoblinMain(x)

            ELSEIF Sprites(x).Name = "Rope " THEN
                CALL RopeMain(x)

            ELSEIF RIGHT$(Sprites(x).Name, 4) = "Dark" THEN
                CALL DarknutMain(x)

            ELSEIF RIGHT$(Sprites(x).Name, 4) = "Lyne" THEN
                CALL LynelMain(x)

            ELSEIF Sprites(x).Name = "KFire" THEN
                CALL AttackableFire(x)

            ELSEIF Sprites(x).Name = "Keese" OR Sprites(x).Name = "Peaha" OR Sprites(x).Name = "RKees" THEN
                CALL FlyersMain(x)

            ELSEIF Sprites(x).Name = "Gibdo" THEN
                CALL GibdoMain(x)

            ELSEIF Sprites(x).Name = "Armos" THEN
                CALL ArmosMain(x)

            ELSEIF Sprites(x).Name = "FSnak" OR RIGHT$(Sprites(x).Name, 4) = "Lanm" THEN
                CALL BigSnakesMain(x)

            ELSEIF Sprites(x).Name = "Stalf" OR Sprites(x).Name = "KStal" THEN
                CALL StalfosMain(x)

            ELSEIF Sprites(x).Name = "Gel  " THEN
                CALL GelMain(x)

            ELSEIF Sprites(x).Name = "Zol  " THEN
                CALL ZolMain(x)

            ELSEIF Sprites(x).Name = "Trap " THEN
                CALL TrapMain(x)

            ELSEIF Sprites(x).Name = "Patra" THEN
                CALL PatraMain(x)

            ELSEIF Sprites(x).Name = "SPatr" THEN
                CALL SmallPatraMain(x)

            ELSEIF Sprites(x).Name = "RWizz" THEN
                CALL RedWizzrobeMain(x)

            ELSEIF Sprites(x).Name = "BWizz" THEN
                CALL BlueWizzrobeMain(x)

            ELSEIF Sprites(x).Name = "Ghini" THEN
                CALL GhiniMain(x)

            ELSEIF Sprites(x).Name = "RLeev" THEN
                CALL RedLeeverMain(x)

            ELSEIF Sprites(x).Name = "BLeev" THEN
                CALL BlueLeeverMain(x)

            ELSEIF RIGHT$(Sprites(x).Name, 4) = "Tekt" THEN
                CALL TektiteMain(x)

            ELSEIF Sprites(x).Name = "Zora " THEN
                CALL ZoraMain(x)

            ELSEIF Sprites(x).Name = "Vire " THEN
                CALL VireMain(x)

            ELSEIF Sprites(x).Name = "Bubbl" THEN
                CALL BubbleMain(x)

            ELSEIF Sprites(x).Name = "LikeL" THEN
                CALL LikeLikeMain(x)

            ELSEIF Sprites(x).Name = "PolsV" THEN
                CALL PolsVoiceMain(x)

            ELSEIF Sprites(x).Name = "Aqua " THEN
                CALL AquamentusMain(x)

            ELSEIF Sprites(x).Name = "Dodon" THEN
                CALL DoDongoMain(x)

            ELSEIF Sprites(x).Name = "ManhM" THEN
                CALL ManhalaMain(x)

            ELSEIF LEFT$(Sprites(x).Name, 4) = "Manh" THEN
                CALL ManhalaArms(x)

            ELSEIF Sprites(x).Name = "GleeM" THEN
                CALL GleeoskMain(x)

            ELSEIF Sprites(x).Name = "GleeH" THEN
                CALL GleeoskHead(x)

            ELSEIF Sprites(x).Name = "Digdo" THEN
                CALL LargeDigDogger(x)

            ELSEIF Sprites(x).Name = "MDigd" THEN
                CALL MiniDigDogger(x)

            ELSEIF RIGHT$(Sprites(x).Name, 4) = "Gohm" THEN
                CALL GohmaMain(x)

            ELSEIF Sprites(x).Name = "Ganno" THEN
                CALL GanonMain(x)

            ELSEIF Sprites(x).Name = "Heart" THEN
                CALL DrawHeart(x)

            ELSEIF Sprites(x).Name = "Rupee" OR Sprites(x).Name = "5Rupe" THEN
                CALL DrawRupees(x)

            ELSEIF Sprites(x).Name = "P-Bmb" OR Sprites(x).Name = "P-Bm4" THEN
                CALL DrawBomb(x)

            ELSEIF Sprites(x).Name = "Clock" THEN
                CALL DrawClock(x)

            ELSEIF Sprites(x).Name = "Death" THEN
                CALL DeathSprite(x)

            ELSEIF Sprites(x).Name = "Fairy" THEN
                CALL FairyMain(x)
            END IF
        END IF
        SkipToEnd:
    NEXT x
END SUB






'*********************************************************
'* Draws all special sprite, ran once per frame
'*
'*
'*********************************************************

SUB DrawSpecial
    FOR x = 1 TO Settings.MatrixSize
        IF Special(x).Active = 1 THEN

            IF RIGHT$(Special(x).Name, 4) = "Bloc" THEN
                CALL MoveableBlockMain(x)

            ELSEIF Special(x).Name = "Switc" THEN
                CALL SwitchMain(x)

            ELSEIF Special(x).Name = "Zelda" THEN
                CALL ZeldaMain(x)

            ELSEIF Special(x).Name = "Trip " THEN
                CALL PowerTriforceMain(x)

            ELSEIF Special(x).Name = "Flash" THEN
                CALL FlashSprite(x)

            ELSEIF LEFT$(Special(x).Name, 4) = "Garg" THEN
                CALL GargoyleMain(x)

            ELSEIF Special(x).Name = "HHear" THEN 'hidden heart container
                CALL HiddenHeartContainer(x)

            ELSEIF Special(x).Name = "HBomb" THEN 'hidden bomb
                CALL HiddenBomb(x)

            ELSEIF Special(x).Name = "Ladde" THEN
                CALL LadderMain(x)

            ELSEIF Special(x).Name = "OldMa" THEN
                CALL OldGuyMain(x)

            ELSEIF Special(x).Name = "Grumb" THEN
                CALL GrumbleMain(x)

            ELSEIF Special(x).Name = "SWate" THEN
                CALL SolidWaterfallMain(x)

            ELSEIF Special(x).Name = "BExRo" OR Special(x).Name = "GExRo" OR Special(x).Name = "WExRo" THEN
                CALL BombableRockMain(x)

            ELSEIF Special(x).Name = "Stair" THEN
                CALL StairBox(x)

            ELSEIF Special(x).Name = "HStai" THEN
                CALL HiddenStair(x)

            ELSEIF Special(x).Name = "Cloud" THEN
                CALL CloudMain(x)

            ELSEIF Special(x).Name = "P-Swo" OR Special(x).Name = "P-WSw" OR Special(x).Name = "P-MSw" OR Special(x).Name = "P-MAS" THEN
                CALL CollectableSword(x)

            ELSEIF Special(x).Name = "P-BCa" OR Special(x).Name = "P-RCa" THEN
                CALL CollectableCandle(x)

            ELSEIF Special(x).Name = "P-Boo" THEN
                CALL CollectableBook(x)

            ELSEIF Special(x).Name = "P-BRi" OR Special(x).Name = "P-RRi" THEN
                CALL CollectableRing(x)

            ELSEIF Special(x).Name = "P-Bom" OR Special(x).Name = "P-BBo" THEN
                CALL CollectableBoomerang(x)

            ELSEIF Special(x).Name = "P-Bow" THEN
                CALL CollectableBow(x)

            ELSEIF Special(x).Name = "Food " THEN
                CALL FoodMain(x)

            ELSEIF Special(x).Name = "P-Hea" THEN
                CALL CollectableHeartContainer(x)

            ELSEIF Special(x).Name = "HKKey" OR Special(x).Name = "HOKey" THEN
                CALL SpawnKey(x)

            ELSEIF Special(x).Name = "P-Key" OR Special(x).Name = "P-MKe" THEN
                CALL CollectableKey(x)

            ELSEIF Special(x).Name = "P-Lad" THEN
                CALL CollectableLadder(x)

            ELSEIF Special(x).Name = "P-SAr" THEN
                CALL CollectableSilverArrow(x)

            ELSEIF Special(x).Name = "P-Mwa" THEN
                CALL CollectableWand(x)

            ELSEIF Special(x).Name = "P-Raf" THEN
                CALL CollectableRaft(x)

            ELSEIF Special(x).Name = "P-Flu" THEN
                CALL CollectableFlute(x)

            ELSEIF Special(x).Name = "P-Tri" OR Special(x).Name = "L-Tri" THEN
                CALL TriforceMain(x)

            ELSEIF Special(x).Name = "RTrig" THEN
                CALL RaftBox(x)

            ELSEIF RTRIM$(Special(x).Name) = "Guy" THEN
                CALL GuyMain(x)

            ELSEIF Special(x).Name = "OldWo" THEN
                CALL OldWomanMain(x)

            ELSEIF LEFT$(Special(x).Name, 4) = "DLak" THEN
                CALL DryLakeMain(x)

            ELSEIF Special(x).Name = "ISold" THEN
                CALL ItemSoldTrigger(x)
            END IF
        END IF
    NEXT x
END SUB



'*********************************************************
'* When a sprites health reaches 0
'*
'*
'*********************************************************
SUB SpriteDeath (x)
    IF Sprites(x).Name = "GleeH" AND Sprites(Sprites(x).PatraLoc).Health > 0 THEN
        Sprites(x).Health = 1
        Sprites(x).Stage = 2
        CALL SoundBoard("BossHit", -1)
        CALL SoundBoard("Kill", -1)
        EXIT SUB
    END IF

    IF Sprites(x).Name = "GleeM" THEN CALL MasterProc2(x)

    IF Sprites(x).Name$ <> "Dodon" AND Sprites(x).Name$ <> "Aqua " AND LEFT$(Sprites(x).Name$, 4) <> "Manh" AND Sprites(x).Name$ <> "GleeM" AND Sprites(x).Name <> "MDigd" AND Sprites(x).Name <> "Digdo" AND RIGHT$(Sprites(x).Name$, 4) <> "Gohm" AND Sprites(x).Name$ <> "Ganno" THEN
        CALL SoundBoard("Kill", -1)
        Settings.KillCount = Settings.KillCount + 1
        IF Settings.KillCount >= 11 THEN Settings.KillCount = 1
        CALL DropLoot(x)
    ELSE
        IF Sprites(x).Name$ = "ManhM" OR Sprites(x).Name$ = "Aqua " OR Sprites(x).Name$ = "Dodon" OR Sprites(x).Name$ = "GleeM" OR Sprites(x).Name$ = "Digdo" OR RIGHT$(Sprites(x).Name$, 4) = "Gohm" THEN
            CALL SoundBoard("BossHit", 0)
        ELSEIF Sprites(x).Name$ <> "Ganno" THEN
            CALL SoundBoard("BossHit", -1)
            CALL SoundBoard("Kill", -1)
        END IF
        CALL BossDeath(Sprites(x).Name$)
    END IF

    IF Player1.LikeLocked = 1 THEN CALL LikeLikeLock(-1)

    IF Sprites(x).Segments > 0 THEN
        Sprites(x).Segments = Sprites(x).Segments - 1
        Sprites(x).Health = Sprites(x).HP
    ELSE
        IF Sprites(x).Name = "SPatr" THEN Sprites(Sprites(x).PatraLoc).Segments = Sprites(Sprites(x).PatraLoc).Segments - 1
        IF Sprites(x).SnakeNum <> 0 THEN Snakes(Sprites(x).SnakeNum) = 0
        IF Sprites(x).Master = 1 THEN CALL MasterProc(x)
        IF Sprites(x).Name = "ManhN" OR Sprites(x).Name = "ManhE" OR Sprites(x).Name = "ManhS" OR Sprites(x).Name = "ManhW" OR Sprites(x).Name = "GleeH" THEN
            Sprites(Sprites(x).PatraLoc).Health = Sprites(Sprites(x).PatraLoc).Health - 1
            Sprites(Sprites(x).PatraLoc).Speed = Sprites(Sprites(x).PatraLoc).Speed * 1.4
        ELSEIF Sprites(x).Name = "MDigd" THEN
            Sprites(Sprites(x).PatraLoc).Health = Sprites(Sprites(x).PatraLoc).Health - 1
            IF Sprites(Sprites(x).PatraLoc).Health = 0 THEN CALL SoundBoard("", 0)
        END IF

        IF Sprites(x).Name$ = "Ganno" THEN
            CALL GanonDeath(x)
            EXIT SUB
        ELSE
            CALL SpawnSprite("Death", Sprites(x).XPos, Sprites(x).YPos, 0, 0, 0, 0)
            IF Sprites(x).Name = "KStal" THEN
                CALL ReplaceSprite(70, 54, 1)
                CALL SpawnSprite("P-Key", Sprites(x).XPos, Sprites(x).YPos, 0, 54, 0, 0)

            END IF
            CALL KillSprite(x)
            EXIT SUB
        END IF
    END IF
END SUB






'*********************************************************
'* Checks if sprite has collided with anything and will damage Link
'* change direction etc
'*
'*********************************************************
SUB MobCollision (X)
    _SOURCE Collision&
    _DEST Sprites&

    Segments = Sprites(X).Segments

    IF Sprites(X).Name = "Dodon" THEN
        Check3 = 1
    ELSE
        Check3 = 0
    END IF

    IF Sprites(X).SnakeNum <> 0 THEN
        Xpos = SnakePosX(Sprites(X).SnakeNum, 1)
        Ypos = SnakePosY(Sprites(X).SnakeNum, 1)
    ELSE
        Xpos = Sprites(X).XPos
        Ypos = Sprites(X).YPos
    END IF


    IF Sprites(X).Direction = 1 THEN
        Check1& = POINT(Xpos - Sprites(X).Size, Ypos - Sprites(X).Size)
        Check2& = POINT(Xpos + Sprites(X).Size, Ypos - Sprites(X).Size)
        IF Check3 = 1 THEN Check3& = POINT(Xpos, Ypos - Sprites(X).Size)
        IF Settings.Debug <> 0 THEN
            _DEST DebugScreen&
            CIRCLE (Xpos - Sprites(X).Size, Ypos - Sprites(X).Size), 5, _RGB(216, 0, 28)
            CIRCLE (Xpos + Sprites(X).Size, Ypos - Sprites(X).Size), 5, _RGB(216, 0, 28)
            IF Check3 = 1 THEN CIRCLE (Xpos, Ypos - Sprites(X).Size), 5, _RGB(40, 0, 200)
            _DEST Sprites&
        END IF

    ELSEIF Sprites(X).Direction = 2 THEN
        Check1& = POINT(Xpos + Sprites(X).Size, Ypos - Sprites(X).Size)
        Check2& = POINT(Xpos + Sprites(X).Size, Ypos + Sprites(X).Size)
        IF Check3 = 1 THEN Check3& = POINT(Xpos + Sprites(X).Size, Ypos)
        IF Settings.Debug <> 0 THEN
            _DEST DebugScreen&
            CIRCLE (Xpos + Sprites(X).Size, Ypos - Sprites(X).Size), 5, _RGB(216, 0, 28)
            CIRCLE (Xpos + Sprites(X).Size, Ypos + Sprites(X).Size), 5, _RGB(216, 0, 28)
            IF Check3 = 1 THEN CIRCLE (Xpos + Sprites(X).Size, Ypos), 5, _RGB(40, 0, 200)
            _DEST Sprites&
        END IF

    ELSEIF Sprites(X).Direction = 3 THEN
        Check1& = POINT(Xpos - Sprites(X).Size, Ypos + Sprites(X).Size)
        Check2& = POINT(Xpos + Sprites(X).Size, Ypos + Sprites(X).Size)
        IF Check3 = 1 THEN Check3& = POINT(Xpos, Ypos + Sprites(X).Size)
        IF Settings.Debug <> 0 THEN
            _DEST DebugScreen&
            CIRCLE (Xpos - Sprites(X).Size, Ypos + Sprites(X).Size), 5, _RGB(216, 0, 28)
            CIRCLE (Xpos + Sprites(X).Size, Ypos + Sprites(X).Size), 5, _RGB(216, 0, 28)
            IF Check3 = 1 THEN CIRCLE (Xpos, Ypos + Sprites(X).Size), 5, _RGB(40, 0, 200)
            _DEST Sprites&
        END IF

    ELSEIF Sprites(X).Direction = 4 THEN
        Check1& = POINT(Xpos - Sprites(X).Size, Ypos - Sprites(X).Size)
        Check2& = POINT(Xpos - Sprites(X).Size, Ypos + Sprites(X).Size)
        IF Check3 = 1 THEN Check3& = POINT(Xpos - Sprites(X).Size, Ypos)
        IF Settings.Debug <> 0 THEN
            _DEST DebugScreen&
            CIRCLE (Xpos - Sprites(X).Size, Ypos - Sprites(X).Size), 5, _RGB(216, 0, 28)
            CIRCLE (Xpos - Sprites(X).Size, Ypos + Sprites(X).Size), 5, _RGB(216, 0, 28)
            IF Check3 = 1 THEN CIRCLE (Xpos - Sprites(X).Size, Ypos), 5, _RGB(40, 0, 200)
            _DEST Sprites&
        END IF
    END IF


    '---- Collision with Link ----
    IF _GREEN(Check1&) = 254 OR _GREEN(Check2&) = 254 AND Sprites(X).Name <> "Trap " THEN
        IF Sprites(X).Name <> "Fairy" THEN
            IF Sprites(X).Name = "LikeL" THEN
                CALL LikeLikeLock(X)
            ELSEIF LEFT$(Sprites(X).Name, 4) = "Manh" THEN
                'Do not hurt link
            ELSEIF Sprites(X).Name = "BLeev" AND Sprites(X).Stage <> 4 THEN 'Blue Leever is above ground
                'Do not hurt link
            ELSEIF Sprites(X).Name = "RLeev" AND Sprites(X).Stage <> 3 THEN 'Red Leever is above ground
                'Do not hurt link
            ELSE
                Settings.PlayerCollisionDetected = 0
                IF Settings.DelayLinkHurt = 0 THEN
                    Player1.Hurt = Sprites(X).Damage
                    Launch& = Check1&
                    IF _GREEN(Check2&) = 254 THEN Launch& = Check2&
                    Player1.HurtMove = ThrowBack(_BLUE(Launch&)) 'player1.diection
                    Sprites(X).Counter = Sprites(X).MaxCount
                    IF Player1.Hurt = 0.1 THEN CALL BubbleHit
                END IF
            END IF
        END IF

        '---- Collision with anything but link ----
    ELSEIF _RED(Check1&) <> 0 OR _RED(Check2&) <> 0 THEN
        IF _RED(Check1&) = 250 OR _RED(Check2&) = 250 OR _RED(Check1&) = 20 OR _RED(Check2&) = 20 THEN
            IF Sprites(X).Flying = 0 THEN
                Sprites(X).Counter = Sprites(X).MaxCount
                Sprites(X).Attacking = 0
            END IF

            IF _BLUE(Check1&) <> 200 AND _BLUE(Check2&) <> 200 THEN
                IF Sprites(_BLUE(Check1&)).Name = "Trap " OR Sprites(_BLUE(Check2&)).Name = "Trap " THEN

                    Blue = _BLUE(Check1&)
                    IF _BLUE(Check2&) > Blue THEN Blue = _BLUE(Check2&)
                    IF Sprites(Blue).Stage < 2 AND Sprites(Blue).Stage <> 0 THEN
                        Sprites(Blue).Stage = 2
                        Sprites(Blue).Counter = Sprites(Blue).MaxCount
                    END IF
                END IF
            END IF

            '---- Collision with explosion ----
        ELSEIF _RED(Check1&) = 70 OR _RED(Check2&) = 70 THEN
            IF Sprites(X).Name <> "ManhM" AND Sprites(X).Name <> "Dodon" AND Sprites(X).Name <> "Patra" THEN
                Check& = Check1&
                IF _RED(Check2&) = 70 THEN Check& = Check2&

                Sprites(X).Health = Sprites(X).Health - Special(_BLUE(Check&)).Damage
                Sprites(X).Hurt = 1
                Sprites(_BLUE(Check&)).HurtMove = ThrowBack(Sprites(X).Direction)
            END IF

        ELSEIF _RED(Check1&) <> 40 AND _RED(Check2&) <> 40 THEN 'if ran into anything other than a bomb
            IF Sprites(X).Flying = 0 THEN Sprites(X).Counter = Sprites(X).MaxCount
        END IF
    END IF

    '---- Dodongo mouth check ----
    IF Check3 = 1 AND _RED(Check3&) = 40 THEN
        IF _BLUE(Check3&) = 200 THEN Sprites(X).Hurt = 1
    END IF

    IF Sprites(X).Name <> "Trap " THEN
        IF Sprites(X).XPos < Settings.LeftLimit + Sprites(X).Size + 5 THEN
            Sprites(X).XPos = Settings.LeftLimit + Sprites(X).Size + 6
            Sprites(X).Counter = Sprites(X).MaxCount
        ELSEIF Sprites(X).XPos > Settings.RightLimit - Sprites(X).Size - 5 THEN
            Sprites(X).XPos = Settings.RightLimit - Sprites(X).Size - 6
            Sprites(X).Counter = Sprites(X).MaxCount
        ELSEIF Sprites(X).YPos < Settings.TopLimit + Sprites(X).Size + 5 THEN
            Sprites(X).YPos = Settings.TopLimit + Sprites(X).Size + 6
            Sprites(X).Counter = Sprites(X).MaxCount
        ELSEIF Sprites(X).YPos > Settings.BottomLimit - Sprites(X).Size - 5 THEN
            Sprites(X).YPos = Settings.BottomLimit - Sprites(X).Size - 6
            Sprites(X).Counter = Sprites(X).MaxCount
        END IF
    END IF
END SUB





'*********************************************************
'* MobCollision2
'*
'* Used for collision detection for stationary objects, or "tails".
'* Also used for big objects
'*
'* PosX and PosY - Position you want checked
'* Size - Size of object
'* SpriteNum - Location of object in matrix if needs to be modified
'*********************************************************

SUB MobCollision2 (PosX, PosY, Size, SpriteNum)
    _SOURCE Collision&

    IF Sprites(SpriteNum).Name = "Aqua " THEN
        Check1& = POINT(PosX - Size, PosY - Size)
        Check2& = POINT(PosX + (Size * 3), PosY - Size)
        Check3& = POINT(PosX - Size, PosY + (Size * 3))
        Check4& = POINT(PosX + (Size * 3), PosY + (Size * 3))
    ELSEIF Sprites(SpriteNum).Name = "GleeM" THEN
        Check1& = POINT(PosX - Size, PosY)
        Check2& = POINT(PosX + Size, PosY)
        Check3& = POINT(PosX - Size, PosY + Size)
        Check4& = POINT(PosX + Size, PosY + Size)
    ELSE
        Check1& = POINT(PosX - Size, PosY - Size)
        Check2& = POINT(PosX + Size, PosY - Size)
        Check3& = POINT(PosX - Size, PosY + Size)
        Check4& = POINT(PosX + Size, PosY + Size)
    END IF

    IF _GREEN(Check1&) = 254 OR _GREEN(Check2&) = 254 OR _GREEN(Check3&) = 254 OR _GREEN(Check4&) = 254 THEN
        Settings.PlayerCollisionDetected = 1
        IF Player1.Hurt = 0 AND Settings.DelayLinkHurt = 0 THEN Player1.Hurt = Sprites(SpriteNum).Damage: Player1.HurtMove = ThrowBack(Player1.Direction)
    ELSEIF Sprites(SpriteNum).Direction = 1 AND _GREEN(Check1&) <> 0 AND _GREEN(Check2&) <> 0 THEN
        Sprites(SpriteNum).Counter = Sprites(SpriteNum).MaxCount
    ELSEIF Sprites(SpriteNum).Direction = 2 AND _GREEN(Check2&) <> 0 AND _GREEN(Check4&) <> 0 THEN
        Sprites(SpriteNum).Counter = Sprites(SpriteNum).MaxCount
    ELSEIF Sprites(SpriteNum).Direction = 3 AND _GREEN(Check3&) <> 0 AND _GREEN(Check4&) <> 0 THEN
        Sprites(SpriteNum).Counter = Sprites(SpriteNum).MaxCount
    ELSEIF Sprites(SpriteNum).Direction = 4 AND _GREEN(Check1&) <> 0 AND _GREEN(Check3&) <> 0 THEN
        Sprites(SpriteNum).Counter = Sprites(SpriteNum).MaxCount
    END IF

    IF _RED(Check1&) = 254 OR _RED(Check2&) = 254 OR _RED(Check3&) = 254 OR _RED(Check4&) = 254 THEN
        Check& = Check1&
        IF _RED(Check2&) = 254 THEN Check& = Check2&
        IF _RED(Check3&) = 254 THEN Check& = Check3&
        IF _RED(Check4&) = 254 THEN Check& = Check4&

        IF Sprites(_BLUE(Check&)).Name = "Trap " THEN Sprites(_BLUE(Check&)).Stage = 2
    END IF

    IF _RED(Check1&) = 70 OR _RED(Check2&) = 70 OR _RED(Check3&) = 70 OR _RED(Check4&) = 70 THEN 'if ran into exploding bomb
        Check& = Check1&
        IF _RED(Check2&) = 70 THEN Check& = Check2&
        IF _RED(Check3&) = 70 THEN Check& = Check3&
        IF _RED(Check4&) = 70 THEN Check& = Check4&

        IF Sprites(SpriteNum).Name = "Dodon" THEN
            Sprites(SpriteNum).Stunned = 120
        ELSE
            Sprites(SpriteNum).Health = Sprites(SpriteNum).Health - Special(_BLUE(Check&)).Damage
            Sprites(SpriteNum).Hurt = 1
            Sprites(_BLUE(Check&)).HurtMove = ThrowBack(Sprites(SpriteNum).Direction)
        END IF
    END IF

    IF Settings.Debug <> 0 THEN
        _DEST DebugScreen&
        IF Sprites(SpriteNum).Name = "Aqua " THEN
            CIRCLE (PosX - Size, PosY - Size), 5, _RGB(216, 0, 72)
            CIRCLE (PosX + (Size * 3), PosY - Size), 5, _RGB(216, 0, 72)
            CIRCLE (PosX - Size, PosY + (Size * 3)), 5, _RGB(216, 0, 72)
            CIRCLE (PosX + (Size * 3), PosY + (Size * 3)), 5, _RGB(216, 0, 72)
        ELSEIF Sprites(SpriteNum).Name = "GleeM" THEN
            CIRCLE (PosX - Size, PosY), 5, _RGB(216, 0, 72)
            CIRCLE (PosX + Size, PosY), 5, _RGB(216, 0, 72)
            CIRCLE (PosX - Size, PosY + Size), 5, _RGB(216, 0, 72)
            CIRCLE (PosX + Size, PosY + Size), 5, _RGB(216, 0, 72)
        ELSE
            CIRCLE (PosX - Size, PosY - Size), 5, _RGB(216, 0, 72)
            CIRCLE (PosX + Size, PosY - Size), 5, _RGB(216, 0, 72)
            CIRCLE (PosX - Size, PosY + Size), 5, _RGB(216, 0, 72)
            CIRCLE (PosX + Size, PosY + Size), 5, _RGB(216, 0, 72)
        END IF
        _DEST Sprites&
    END IF
END SUB





'*********************************************************
'* MobHurt
'*
'* Handles throwing back the mob when taking damage, sprite flashing
'* and for vires and gels spawning more sprites when coming in contact
'* with solid object
'*
'* x - Sprites location in matrix
'* Sprite& - Objects current sprite to modify
'* ColorSwitch& - RGB value of the color you want to flash on the above sprite
'* EnableMove - Use 0 if you want object to stay in place and not get thrown back
'* XAdd - used if you want to back a mob off an object more than normal
'*********************************************************
SUB MobHurt (x, Sprite&, ColorSwitch&, EnableMove, XAdd)
    IF Sprites(x).Hurt < 10 AND Sprites(x).Hurt > 0 THEN
        Sprites(x).Flash = 0
        Sprites(x).MaxFlash = 16
        IF EnableMove > 1 THEN Sprites(x).MaxFlash = 150
        CALL SoundBoard("Hit", -1)
        IF Sprites(x).Name = "FSnak" OR Sprites(x).Name = "Patra" OR Sprites(x).Name = "Aqua " OR LEFT$(Sprites(x).Name, 4) = "Manh" OR Sprites(x).Name = "GleeH" OR Sprites(x).Name = "MDigd" OR Sprites(x).Name = "BGohm" THEN CALL SoundBoard("BossHit", -1)
        Sprites(x).Hurt = 10

        IF RIGHT$(Sprites(x).Name, 4) = "Gori" AND Sprites(x).Attacking = 1 THEN
            Sprites(x).Attacking = 0
            Sprites(x).Pause = 0
            Projectile(Sprites(x).AttackPointer).Active = 0
        END IF
    END IF


    IF Sprites(x).Hurt = 10 OR Sprites(x).Hurt < 0 THEN
        BustSprite& = SwapColor(Sprite&, ColorSwitch&, _RGB(RandomGen(254, 0, "+", 0), RandomGen(254, 0, "+", 0), RandomGen(254, 0, "+", 0)))


        IF EnableMove > 0 THEN
            _SOURCE Collision&
            XCheck = Sprites(x).XPos
            YCheck = Sprites(x).YPos
            IF Sprites(x).HurtMove = 1 AND Sprites(x).YPos > Settings.TopLimit + Sprites(x).Size + 5 AND _RED(POINT(Sprites(x).XPos, Sprites(x).YPos - Sprites(x).Size - 10)) = 0 THEN Sprites(x).YPos = Sprites(x).YPos - 10
            IF Sprites(x).HurtMove = 2 AND Sprites(x).XPos < Settings.RightLimit - Sprites(x).Size - 5 AND _RED(POINT(Sprites(x).XPos + Sprites(x).Size + 10, Sprites(x).YPos)) = 0 THEN: Sprites(x).XPos = Sprites(x).XPos + 10
            IF Sprites(x).HurtMove = 3 AND Sprites(x).YPos < Settings.BottomLimit - Sprites(x).Size - 5 AND _RED(POINT(Sprites(x).XPos, Sprites(x).YPos + Sprites(x).Size + 10)) = 0 THEN Sprites(x).YPos = Sprites(x).YPos + 10
            IF Sprites(x).HurtMove = 4 AND Sprites(x).XPos > Settings.LeftLimit + Sprites(x).Size + 5 AND _RED(POINT(Sprites(x).XPos - Sprites(x).Size - 10, Sprites(x).YPos)) = 0 THEN Sprites(x).XPos = Sprites(x).XPos - 10


            IF XCheck = Sprites(x).XPos AND YCheck = Sprites(x).YPos AND Sprites(x).MaxFlash = 150 THEN Sprites(x).Flash = 148

            IF Sprites(x).YPos < Settings.TopLimit + Sprites(x).Size + 5 THEN
                Sprites(x).YPos = Settings.TopLimit + Sprites(x).Size + 6
                IF EnableMove > 1 THEN Sprites(x).Hurt = 30
            ELSEIF Sprites(x).XPos > Settings.RightLimit - Sprites(x).Size - 5 THEN
                Sprites(x).XPos = Settings.RightLimit - Sprites(x).Size - 6
                IF EnableMove > 1 THEN Sprites(x).Hurt = 30
            ELSEIF Sprites(x).YPos > Settings.BottomLimit - Sprites(x).Size - 5 THEN
                Sprites(x).YPos = Settings.BottomLimit - Sprites(x).Size - 6
                IF EnableMove > 1 THEN Sprites(x).Hurt = 30
            ELSEIF Sprites(x).XPos < Settings.LeftLimit + Sprites(x).Size + 5 THEN
                Sprites(x).XPos = Settings.LeftLimit + Sprites(x).Size + 6
                IF EnableMove > 1 THEN Sprites(x).Hurt = 30
            END IF
        END IF

        Sprites(x).Flash = Sprites(x).Flash + 1
        IF Sprites(x).Flash = 149 AND Sprites(x).Hurt >= 0 THEN Sprites(x).Hurt = 30
        IF Sprites(x).Flash = Sprites(x).MaxFlash THEN Sprites(x).Hurt = 20

        _DEST Sprites&

        IF Sprites(x).Name = "Aqua " THEN
            _PUTIMAGE (Sprites(x).XPos - Sprites(x).Size - XAdd, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + (Sprites(x).Size * 3), Sprites(x).YPos + (Sprites(x).Size * 3)), BustSprite&, Sprites&
        ELSEIF Sprites(x).Name = "GleeH" THEN
            _PUTIMAGE (Sprites(Sprites(x).PatraLoc).XPos - Sprites(Sprites(x).PatraLoc).Size - XAdd, Sprites(Sprites(x).PatraLoc).YPos - Sprites(Sprites(x).PatraLoc).Size)-(Sprites(Sprites(x).PatraLoc).XPos + Sprites(Sprites(x).PatraLoc).Size, Sprites(Sprites(x).PatraLoc).YPos + Sprites(Sprites(x).PatraLoc).Size), BustSprite&, Sprites&
        ELSEIF Sprites(x).Name = "BGohm" THEN
            _PUTIMAGE (Sprites(x).XPos - (Sprites(x).Size * 3), Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + (Sprites(x).Size * 3), Sprites(x).YPos + Sprites(x).Size), BustSprite&, Sprites&
        ELSE
            _PUTIMAGE (Sprites(x).XPos - Sprites(x).Size - XAdd, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + Sprites(x).Size + XAdd, Sprites(x).YPos + Sprites(x).Size), BustSprite&, Sprites&
            'IF Sprites(x).Hurt < 0 THEN
            '_DEST Collision&
            'LINE (Sprites(x).XPos - Sprites(x).Size, Sprites(x).YPos - Sprites(x).Size)-(Sprites(x).XPos + Sprites(x).Size, Sprites(x).YPos + Sprites(x).Size), _RGB(254, 1, x), BF
            '_DEST Sprites&
            'END IF
        END IF

        _FREEIMAGE BustSprite&
    END IF

    IF Sprites(x).Hurt = 20 THEN
        Sprites(x).Hurt = 0
        Sprites(x).HurtMove = 0
    END IF

    IF Sprites(x).Hurt = 30 THEN
        IF EnableMove = 2 THEN
            CALL SpawnSprite("Gel  ", Sprites(x).XPos, Sprites(x).YPos, 0, 0, 0, 0)
            CALL SpawnSprite("Gel  ", Sprites(x).XPos, Sprites(x).YPos, 0, 0, 0, 0)
            CALL SpawnSprite("Cloud", Sprites(x).XPos, Sprites(x).YPos, 0, 0, 0, 0)
            CALL KillSprite(x)
        ELSEIF EnableMove = 3 THEN
            CALL SpawnSprite("RKees", Sprites(x).XPos, Sprites(x).YPos, 0, 0, 0, 0)
            CALL SpawnSprite("RKees", Sprites(x).XPos, Sprites(x).YPos, 0, 0, 0, 0)
            CALL SpawnSprite("Cloud", Sprites(x).XPos, Sprites(x).YPos, 0, 0, 0, 0)
            CALL KillSprite(x)
        END IF
    END IF
END SUB






'*********************************************************
'* MoveMob
'*
'* Used to move mob, change directions, and detect if facing
'*
'* Directions - Directions mob can move, 4 for U,D,L,R.. 8 for diagnals as well
'* WalkTime - Used to set the largest number that can be generated
'* WalkAdd - Added to Walktime, used to set the minimum distance to travel
'* Magnet - when <> 0 will also detect if mob is facing like and go straight to him. Ex: Rope
'*********************************************************

SUB MoveMob (Directions, SpriteNumber, WalkTime, WalkAdd, Magnet)
    IF Sprites(SpriteNumber).Counter >= Sprites(SpriteNumber).MaxCount AND Sprites(SpriteNumber).Attacking = 0 AND Sprites(SpriteNumber).Jumping = 0 AND Sprites(SpriteNumber).Stunned = 0 THEN
        Sprites(SpriteNumber).Direction = MobCanGoThere(SpriteNumber, Directions)

        Sprites(SpriteNumber).Counter = 0
        Sprites(SpriteNumber).MaxCount = RandomGen(WalkTime, WalkAdd, "+", 0)
        Sprites(SpriteNumber).Pause = RandomGen(5, 15, "+", 0)
        Sprites(SpriteNumber).MoveX = 0
        Sprites(SpriteNumber).MoveY = 0
        IF Sprites(SpriteNumber).Direction = 5 THEN Sprites(SpriteNumber).MoveX = Sprites(SpriteNumber).Speed: Sprites(SpriteNumber).Direction = 1
        IF Sprites(SpriteNumber).Direction = 6 THEN Sprites(SpriteNumber).MoveY = Sprites(SpriteNumber).Speed: Sprites(SpriteNumber).Direction = 2
        IF Sprites(SpriteNumber).Direction = 7 THEN Sprites(SpriteNumber).MoveX = Sprites(SpriteNumber).Speed * -1: Sprites(SpriteNumber).Direction = 3
        IF Sprites(SpriteNumber).Direction = 8 THEN Sprites(SpriteNumber).MoveY = Sprites(SpriteNumber).Speed * -1: Sprites(SpriteNumber).Direction = 4
        IF Sprites(SpriteNumber).Direction = 1 THEN Sprites(SpriteNumber).MoveY = Sprites(SpriteNumber).Speed * -1
        IF Sprites(SpriteNumber).Direction = 2 THEN Sprites(SpriteNumber).MoveX = Sprites(SpriteNumber).Speed
        IF Sprites(SpriteNumber).Direction = 3 THEN Sprites(SpriteNumber).MoveY = Sprites(SpriteNumber).Speed
        IF Sprites(SpriteNumber).Direction = 4 THEN Sprites(SpriteNumber).MoveX = Sprites(SpriteNumber).Speed * -1

    ELSEIF Sprites(SpriteNumber).Stunned <> 0 THEN
        Sprites(SpriteNumber).Stunned = Sprites(SpriteNumber).Stunned - 1
        Sprites(SpriteNumber).Attacking = 0
        Sprites(SpriteNumber).Jumping = 0
        EXIT SUB

    ELSEIF Sprites(SpriteNumber).Attacking = 0 THEN
        Sprites(SpriteNumber).Counter = Sprites(SpriteNumber).Counter + 1
        IF Sprites(SpriteNumber).Name = "GleeH" AND Sprites(SpriteNumber).Stage = 1 THEN
            IF Sprites(SpriteNumber).XPos < (Settings.RezX / 2) - (Player1.Size * 4) OR Sprites(SpriteNumber).XPos > (Settings.RezX / 2) + (Player1.Size * 4) THEN Sprites(SpriteNumber).MoveX = Sprites(SpriteNumber).MoveX * -1
            IF Sprites(SpriteNumber).YPos < Sprites(Sprites(SpriteNumber).PatraLoc).YPos + (Player1.Size * 3) OR Sprites(SpriteNumber).YPos > Sprites(Sprites(SpriteNumber).PatraLoc).YPos + (Player1.Size * 6) THEN Sprites(SpriteNumber).MoveY = Sprites(SpriteNumber).MoveY * -1
        END IF
    END IF

    IF Magnet <> 0 THEN
        IF Sprites(SpriteNumber).Direction = 1 AND Player1.XPos > Sprites(SpriteNumber).XPos - Sprites(SpriteNumber).Size AND Player1.XPos < Sprites(SpriteNumber).XPos + Sprites(SpriteNumber).Size AND Player1.YPos < Sprites(SpriteNumber).YPos THEN
            Sprites(SpriteNumber).Attacking = 1
            Sprites(SpriteNumber).MoveY = Sprites(SpriteNumber).Speed * (Magnet * -1)
        ELSEIF Sprites(SpriteNumber).Direction = 2 AND Player1.YPos > Sprites(SpriteNumber).YPos - Sprites(SpriteNumber).Size AND Player1.YPos < Sprites(SpriteNumber).YPos + Sprites(SpriteNumber).Size AND Player1.XPos > Sprites(SpriteNumber).XPos THEN
            Sprites(SpriteNumber).Attacking = 1
            Sprites(SpriteNumber).MoveX = Sprites(SpriteNumber).Speed * Magnet
        ELSEIF Sprites(SpriteNumber).Direction = 3 AND Player1.XPos > Sprites(SpriteNumber).XPos - Sprites(SpriteNumber).Size AND Player1.XPos < Sprites(SpriteNumber).XPos + Sprites(SpriteNumber).Size AND Player1.YPos > Sprites(SpriteNumber).YPos THEN
            Sprites(SpriteNumber).Attacking = 1
            Sprites(SpriteNumber).MoveY = Sprites(SpriteNumber).Speed * Magnet
        ELSEIF Sprites(SpriteNumber).Direction = 4 AND Player1.YPos > Sprites(SpriteNumber).YPos - Sprites(SpriteNumber).Size AND Player1.YPos < Sprites(SpriteNumber).YPos + Sprites(SpriteNumber).Size AND Player1.XPos < Sprites(SpriteNumber).XPos THEN
            Sprites(SpriteNumber).Attacking = 1
            Sprites(SpriteNumber).MoveX = Sprites(SpriteNumber).Speed * (Magnet * -1)

            'ELSEIF Sprites(SpriteNumber).Frame = 1 AND Player1.YPos > Sprites(SpriteNumber).YPos - Sprites(SpriteNumber).Size AND Player1.YPos < Sprites(SpriteNumber).YPos + Sprites(SpriteNumber).Size AND Player1.XPos < Sprites(SpriteNumber).XPos THEN
            'Sprites(SpriteNumber).Attacking = 1
            'Sprites(SpriteNumber).MoveY = 0
            'Sprites(SpriteNumber).MoveX = Sprites(SpriteNumber).Speed * (Magnet * -1)
            'ELSEIF Sprites(SpriteNumber).Frame = 2 AND Player1.YPos > Sprites(SpriteNumber).YPos - Sprites(SpriteNumber).Size AND Player1.YPos < Sprites(SpriteNumber).YPos + Sprites(SpriteNumber).Size AND Player1.XPos > Sprites(SpriteNumber).XPos THEN
            'Sprites(SpriteNumber).Attacking = 1
            'Sprites(SpriteNumber).MoveY = 0
            'Sprites(SpriteNumber).MoveX = Sprites(SpriteNumber).Speed * Magnet
        ELSE
            Sprites(SpriteNumber).Attacking = 0
            Sprites(SpriteNumber).MoveX = 0
            Sprites(SpriteNumber).MoveY = 0
            IF Sprites(SpriteNumber).Direction = 1 THEN Sprites(SpriteNumber).MoveY = Sprites(SpriteNumber).Speed * -1
            IF Sprites(SpriteNumber).Direction = 2 THEN Sprites(SpriteNumber).MoveX = Sprites(SpriteNumber).Speed
            IF Sprites(SpriteNumber).Direction = 3 THEN Sprites(SpriteNumber).MoveY = Sprites(SpriteNumber).Speed
            IF Sprites(SpriteNumber).Direction = 4 THEN Sprites(SpriteNumber).MoveX = Sprites(SpriteNumber).Speed * -1
        END IF
    END IF

    Sprites(SpriteNumber).XPos = Sprites(SpriteNumber).XPos + Sprites(SpriteNumber).MoveX
    Sprites(SpriteNumber).YPos = Sprites(SpriteNumber).YPos + Sprites(SpriteNumber).MoveY

    CALL MobCollision(SpriteNumber)
END SUB





'*********************************************************
'* MobCanGoThere
'*
'* Checks if there is a wall there when mob changes direction.
'* Used by MoveMob
'*
'* SpriteNumber - Sprites position on matrix
'* Directions - 4 or 8 degrees of freedom
'*********************************************************
FUNCTION MobCanGoThere (SpriteNumber, Directions)
    MobCanGoThere = 0
    IF Directions < 5 AND Sprites(SpriteNumber).MoveCheckBypass = 0 THEN CALL BackMobOffWall(SpriteNumber)
    DirectionChange = RandomGen(Directions, 1, "+", Sprites(SpriteNumber).Direction)

    DO
        IF Directions > 4 OR Sprites(SpriteNumber).MoveCheckBypass = 1 THEN EXIT DO
        Failsafe = Failsafe + 1

        IF DirectionChange = 1 THEN
            Check1 = WallVerify(POINT(Sprites(SpriteNumber).XPos - Sprites(SpriteNumber).Size, Sprites(SpriteNumber).YPos - (Sprites(SpriteNumber).Size * 2)))
            Check2 = WallVerify(POINT(Sprites(SpriteNumber).XPos + Sprites(SpriteNumber).Size, Sprites(SpriteNumber).YPos - (Sprites(SpriteNumber).Size * 2)))
        ELSEIF DirectionChange = 2 THEN
            Check1 = WallVerify(POINT(Sprites(SpriteNumber).XPos + (Sprites(SpriteNumber).Size * 2), Sprites(SpriteNumber).YPos + Sprites(SpriteNumber).Size))
            Check2 = WallVerify(POINT(Sprites(SpriteNumber).XPos + (Sprites(SpriteNumber).Size * 2), Sprites(SpriteNumber).YPos - Sprites(SpriteNumber).Size))
        ELSEIF DirectionChange = 3 THEN
            Check1 = WallVerify(POINT(Sprites(SpriteNumber).XPos + Sprites(SpriteNumber).Size, Sprites(SpriteNumber).YPos + (Sprites(SpriteNumber).Size * 2)))
            Check2 = WallVerify(POINT(Sprites(SpriteNumber).XPos - Sprites(SpriteNumber).Size, Sprites(SpriteNumber).YPos + (Sprites(SpriteNumber).Size * 2)))
        ELSEIF DirectionChange = 4 THEN
            Check1 = WallVerify(POINT(Sprites(SpriteNumber).XPos - (Sprites(SpriteNumber).Size * 2), Sprites(SpriteNumber).YPos + Sprites(SpriteNumber).Size))
            Check2 = WallVerify(POINT(Sprites(SpriteNumber).XPos - (Sprites(SpriteNumber).Size * 2), Sprites(SpriteNumber).YPos - Sprites(SpriteNumber).Size))
        END IF

        IF Check1 = 0 AND Check2 = 0 THEN EXIT DO
        DirectionChange = DirectionChange + 1
        IF DirectionChange = 5 THEN DirectionChange = 1

        IF Failsafe = 1000 THEN
            Settings.ErrorTracker = "Mob#:" + STR$(SpriteNumber) + " :G: " + STR$(DirectionChange)
            ERROR 99
        END IF
    LOOP

    MobCanGoThere = DirectionChange
END FUNCTION



'*********************************************************
'* BackMobOffWall
'*
'* Used by MobCanGoThere to first back mob away from solid
'* object if it has traveled to the point the collision boxes
'* are inside a solid object.
'*
'* SpriteNumber - Sprites position in its matrix
'*********************************************************
SUB BackMobOffWall (SpriteNumber)
    X = Sprites(SpriteNumber).XPos
    Y = Sprites(SpriteNumber).YPos
    Direction = Sprites(SpriteNumber).Direction

    IF Direction = 1 THEN
        Check1 = WallVerify(POINT(X - Sprites(SpriteNumber).Size, Y - Sprites(SpriteNumber).Size))
        Check2 = WallVerify(POINT(X + Sprites(SpriteNumber).Size, Y - Sprites(SpriteNumber).Size))

        IF Check1 = 1 AND Check2 = 0 THEN Direction = 2
        IF Check1 = 0 AND Check2 = 1 THEN Direction = 4
        IF Check1 = 1 AND Check2 = 1 THEN Direction = 3
        IF Check1 = 0 AND Check2 = 0 THEN EXIT SUB

    ELSEIF Direction = 2 THEN
        Check1 = WallVerify(POINT(X + Sprites(SpriteNumber).Size, Y - Sprites(SpriteNumber).Size))
        Check2 = WallVerify(POINT(X + Sprites(SpriteNumber).Size, Y + Sprites(SpriteNumber).Size))

        IF Check1 = 1 AND Check2 = 0 THEN Direction = 3
        IF Check1 = 0 AND Check2 = 1 THEN Direction = 1
        IF Check1 = 1 AND Check2 = 1 THEN Direction = 4
        IF Check1 = 0 AND Check2 = 0 THEN EXIT SUB

    ELSEIF Direction = 3 THEN
        Check1 = WallVerify(POINT(X + Sprites(SpriteNumber).Size, Y + Sprites(SpriteNumber).Size))
        Check2 = WallVerify(POINT(X - Sprites(SpriteNumber).Size, Y + Sprites(SpriteNumber).Size))

        IF Check1 = 1 AND Check2 = 0 THEN Direction = 4
        IF Check1 = 0 AND Check2 = 1 THEN Direction = 2
        IF Check1 = 1 AND Check2 = 1 THEN Direction = 1
        IF Check1 = 0 AND Check2 = 0 THEN EXIT SUB

    ELSEIF Direction = 4 THEN
        Check1 = WallVerify(POINT(X - Sprites(SpriteNumber).Size, Y + Sprites(SpriteNumber).Size))
        Check2 = WallVerify(POINT(X - Sprites(SpriteNumber).Size, Y - Sprites(SpriteNumber).Size))

        IF Check1 = 1 AND Check2 = 0 THEN Direction = 1
        IF Check1 = 0 AND Check2 = 1 THEN Direction = 3
        IF Check1 = 1 AND Check2 = 1 THEN Direction = 2
        IF Check1 = 0 AND Check2 = 0 THEN EXIT SUB
    END IF


    DO
        Failsafe = Failsafe + 1

        IF Direction = 1 THEN
            Y = Y - 1
            Check1 = WallVerify(POINT(X - Sprites(SpriteNumber).Size, Y - Sprites(SpriteNumber).Size))
            Check2 = WallVerify(POINT(X + Sprites(SpriteNumber).Size, Y - Sprites(SpriteNumber).Size))

        ELSEIF Direction = 2 THEN
            X = X + 1
            Check1 = WallVerify(POINT(X + Sprites(SpriteNumber).Size, Y - Sprites(SpriteNumber).Size))
            Check2 = WallVerify(POINT(X + Sprites(SpriteNumber).Size, Y + Sprites(SpriteNumber).Size))

        ELSEIF Direction = 3 THEN
            Y = Y + 1
            Check1 = WallVerify(POINT(X + Sprites(SpriteNumber).Size, Y + Sprites(SpriteNumber).Size))
            Check2 = WallVerify(POINT(X - Sprites(SpriteNumber).Size, Y + Sprites(SpriteNumber).Size))

        ELSEIF Direction = 4 THEN
            X = X - 1
            Check1 = WallVerify(POINT(X - Sprites(SpriteNumber).Size, Y + Sprites(SpriteNumber).Size))
            Check2 = WallVerify(POINT(X - Sprites(SpriteNumber).Size, Y - Sprites(SpriteNumber).Size))
        END IF

        IF Check1 = 0 AND Check2 = 0 THEN EXIT DO
        IF Failsafe = 1000 THEN
            Settings.ErrorTracker = "Mob#:" + STR$(SpriteNumber)
            ERROR 99
        END IF
    LOOP

    Sprites(SpriteNumber).XPos = X
    Sprites(SpriteNumber).YPos = Y
END SUB




'*********************************************************
'* WallVerify
'*
'* Used by BackMobOffWall to set what is and isnt considered
'* a solid object
'*********************************************************
FUNCTION WallVerify (Check&)
    WallVerify = 0
    IF _RED(Check&) = 20 OR _RED(Check&) = 30 OR _RED(Check&) = 130 THEN WallVerify = 1
END FUNCTION





'*********************************************************
'* CheckIfCanTeleport
'*
'* Checks if a sprite can reappear at a location after being
'* randomly sent there
'*
'* SpriteNum - Sprites position in its matrix, use 0 for a generic check
'* Xpos and Ypos and Size - only used during a generic check
'*********************************************************
FUNCTION CheckIfCanTeleport (SpriteNum, XPos, YPos, Size)
    CheckIfCanTeleport = 0
    _SOURCE Collision&

    IF SpriteNum <> 0 THEN
        Check1& = _GREEN(POINT(Sprites(SpriteNum).XPos - Sprites(SpriteNum).Size, Sprites(SpriteNum).YPos - Sprites(SpriteNum).Size))
        Check2& = _GREEN(POINT(Sprites(SpriteNum).XPos + Sprites(SpriteNum).Size, Sprites(SpriteNum).YPos - Sprites(SpriteNum).Size))
        Check3& = _GREEN(POINT(Sprites(SpriteNum).XPos - Sprites(SpriteNum).Size, Sprites(SpriteNum).YPos + Sprites(SpriteNum).Size))
        Check4& = _GREEN(POINT(Sprites(SpriteNum).XPos + Sprites(SpriteNum).Size, Sprites(SpriteNum).YPos + Sprites(SpriteNum).Size))
        Check5& = _GREEN(POINT(Sprites(SpriteNum).XPos, Sprites(SpriteNum).YPos))

        IF Check1& = 0 AND Check2& = 0 AND Check3& = 0 AND Check4& = 0 AND Check5& = 0 THEN CheckIfCanTeleport = 1

        IF Settings.Debug = 1 THEN
            _DEST DebugScreen&
            CIRCLE (Sprites(SpriteNum).XPos - Sprites(SpriteNum).Size, Sprites(SpriteNum).YPos - Sprites(SpriteNum).Size), 5, _RGB(200, 50, 255)
            CIRCLE (Sprites(SpriteNum).XPos + Sprites(SpriteNum).Size, Sprites(SpriteNum).YPos - Sprites(SpriteNum).Size), 5, _RGB(200, 50, 255)
            CIRCLE (Sprites(SpriteNum).XPos - Sprites(SpriteNum).Size, Sprites(SpriteNum).YPos + Sprites(SpriteNum).Size), 5, _RGB(200, 50, 255)
            CIRCLE (Sprites(SpriteNum).XPos + Sprites(SpriteNum).Size, Sprites(SpriteNum).YPos + Sprites(SpriteNum).Size), 5, _RGB(200, 50, 255)
            _DEST Sprites&
        END IF

        IF Sprites(SpriteNum).XPos < Settings.LeftLimit OR Sprites(SpriteNum).XPos > Settings.RightLimit THEN CheckIfCanTeleport = 0
        IF Sprites(SpriteNum).YPos < Settings.TopLimit OR Sprites(SpriteNum).YPos > Settings.BottomLimit THEN CheckIfCanTeleport = 0
    ELSE
        Check1& = _GREEN(POINT(XPos - Size, YPos - Size))
        Check2& = _GREEN(POINT(XPos + Size, YPos - Size))
        Check3& = _GREEN(POINT(XPos - Size, YPos + Size))
        Check4& = _GREEN(POINT(XPos + Size, YPos + Size))
        Check5& = _GREEN(POINT(XPos, YPos))

        IF Check1& = 0 AND Check2& = 0 AND Check3& = 0 AND Check4& = 0 AND Check5& = 0 THEN CheckIfCanTeleport = 1

        IF Settings.Debug = 1 THEN
            _DEST DebugScreen&
            CIRCLE (XPos - Size, YPos - Size), 5, _RGB(200, 50, 255)
            CIRCLE (XPos + Size, YPos - Size), 5, _RGB(200, 50, 255)
            CIRCLE (XPos - Size, YPos + Size), 5, _RGB(200, 50, 255)
            CIRCLE (XPos + Size, YPos + Size), 5, _RGB(200, 50, 255)
            _DEST Sprites&
        END IF

        IF XPos < Settings.LeftLimit OR XPos > Settings.RightLimit THEN CheckIfCanTeleport = 0
        IF YPos < Settings.TopLimit OR YPos > Settings.BottomLimit THEN CheckIfCanTeleport = 0
    END IF
END FUNCTION



'*********************************************************
'* Checks if a projectile has collided with anything.
'* this version is for special cases and not typically used
'*
'*********************************************************
SUB ProjectileCollision2 (SpriteNum, Stage)
    _SOURCE Collision&

    Check1& = POINT(Projectile(SpriteNum).XPos - Projectile(SpriteNum).Size, Projectile(SpriteNum).YPos - Projectile(SpriteNum).Size)
    Check2& = POINT(Projectile(SpriteNum).XPos + Projectile(SpriteNum).Size, Projectile(SpriteNum).YPos - Projectile(SpriteNum).Size)
    Check3& = POINT(Projectile(SpriteNum).XPos - Projectile(SpriteNum).Size, Projectile(SpriteNum).YPos + Projectile(SpriteNum).Size)
    Check4& = POINT(Projectile(SpriteNum).XPos + Projectile(SpriteNum).Size, Projectile(SpriteNum).YPos + Projectile(SpriteNum).Size)


    IF _GREEN(Check1&) = 254 OR _GREEN(Check2&) = 254 OR _GREEN(Check3&) = 254 OR _GREEN(Check4&) = 254 THEN
        IF Player1.Hurt = 0 THEN Player1.Hurt = Projectile(SpriteNum).Damage: Player1.HurtMove = ThrowBack(Player1.Direction)

    ELSEIF _RED(Check1&) = 254 OR _RED(Check2&) = 254 OR _RED(Check3&) = 254 OR _RED(Check4&) = 254 THEN
        IF _RED(Check1&) = 254 THEN
            Check& = Check1&
        ELSEIF _RED(Check2&) = 254 THEN
            Check& = Check2&
        ELSEIF _RED(Check3&) = 254 THEN
            Check& = Check3&
        ELSEIF _RED(Check4&) = 254 THEN
            Check& = Check4&
        END IF

        Sprites(_BLUE(Check&)).Health = Sprites(_BLUE(Check&)).Health - Projectile(SpriteNum).Damage
        Sprites(_BLUE(Check&)).Hurt = 1

        IF Stage = 1 THEN
            Sprites(_BLUE(Check&)).HurtMove = Projectile(SpriteNum).Direction
        ELSE
            Sprites(_BLUE(Check&)).HurtMove = ThrowBack(Sprites(_BLUE(Check&)).Direction)
        END IF
    END IF


    IF Settings.Debug <> 0 THEN
        _DEST DebugScreen&
        CIRCLE (Projectile(SpriteNum).XPos - Projectile(SpriteNum).Size, Projectile(SpriteNum).YPos - Projectile(SpriteNum).Size), 5, _RGB(216, 50, 0)
        CIRCLE (Projectile(SpriteNum).XPos + Projectile(SpriteNum).Size, Projectile(SpriteNum).YPos - Projectile(SpriteNum).Size), 5, _RGB(216, 50, 0)
        CIRCLE (Projectile(SpriteNum).XPos - Projectile(SpriteNum).Size, Projectile(SpriteNum).YPos + Projectile(SpriteNum).Size), 5, _RGB(216, 50, 0)
        CIRCLE (Projectile(SpriteNum).XPos + Projectile(SpriteNum).Size, Projectile(SpriteNum).YPos + Projectile(SpriteNum).Size), 5, _RGB(216, 50, 0)
    END IF
END SUB



'*********************************************************
'* Checks if a projectile has collided with anything
'*
'*
'*********************************************************

SUB ProjectileCollision (x)
    _SOURCE Collision&
    Check& = POINT(Projectile(x).XPos, Projectile(x).YPos)
    ShieldHit = 0

    IF Projectile(x).PlayerSpawned = 0 THEN
        IF _GREEN(Check&) = 254 THEN
            IF CheckIfHitShield(_BLUE(Check&), Projectile(x).ShieldUpgrade) = 1 THEN
                CALL SoundBoard("Shield", -1)
                IF RIGHT$(Projectile(x).Name, 4) = "Boom" AND Projectile(x).Stage = 1 THEN
                    Projectile(x).Stage = 2
                ELSE
                    CALL KillProjectile(x)
                    Sprites(Projectile(x).MobControl).Pause = 0
                END IF
            ELSE
                Player1.Hurt = Projectile(x).Damage

                Player1.HurtMove = ThrowBack(_BLUE(Check&))


                CALL KillProjectile(x)
                IF RIGHT$(Projectile(x).Name, 4) = "Boom" THEN Sprites(Projectile(x).MobControl).Pause = 0
            END IF
        END IF

    ELSE
        IF _GREEN(Check&) = 254 AND Projectile(x).Stage > 1 THEN
            CALL KillProjectile(x)

        ELSEIF _RED(Check&) > 251 THEN
            IF _RED(Check&) = 252 THEN
                IF RIGHT$(Projectile(x).Name, 4) <> "Arro" THEN ShieldHit = 1
            ELSEIF _RED(Check&) = 253 THEN
                IF Projectile(x).Name <> "BArro" THEN ShieldHit = 1
            ELSEIF _RED(Check&) = 254 THEN
                IF RIGHT$(Sprites(_BLUE(Check&)).Name, 4) = "Dark" THEN
                    IF Direction = 1 AND Sprites(_BLUE(Check&)).Direction = 3 THEN ShieldHit = 1
                    IF Direction = 2 AND Sprites(_BLUE(Check&)).Direction = 4 THEN ShieldHit = 1
                    IF Direction = 3 AND Sprites(_BLUE(Check&)).Direction = 1 THEN ShieldHit = 1
                    IF Direction = 4 AND Sprites(_BLUE(Check&)).Direction = 2 THEN ShieldHit = 1
                END IF
            ELSE
                ShieldHit = 1
            END IF

            IF RIGHT$(Projectile(x).Name, 4) = "Boom" THEN
                IF Projectile(x).Stage = 1 THEN Projectile(x).Stage = 2

                IF _RED(Check&) = 254 THEN
                    IF RIGHT$(Sprites(_BLUE(Check&)).Name, 4) = "Dark" THEN
                        CALL SoundBoard("Shield", -1)

                    ELSE
                        IF Sprites(_BLUE(Check&)).Name = "Keese" OR Sprites(_BLUE(Check&)).Name = "RKees" OR Sprites(_BLUE(Check&)).Name = "Gel  " THEN
                            Sprites(_BLUE(Check&)).Health = 0
                        ELSE
                            CALL SoundBoard("Hit", -1)
                        END IF

                        IF Sprites(_BLUE(Check&)).Stunned >= 0 THEN
                            Sprites(_BLUE(Check&)).Stunned = 70
                            Sprites(_BLUE(Check&)).MoveX = 0
                            Sprites(_BLUE(Check&)).MoveY = 0
                            Sprites(_BLUE(Check&)).Hurt = 10
                            Sprites(_BLUE(Check&)).Flash = 0
                            Sprites(_BLUE(Check&)).MaxFlash = 16
                        END IF
                    END IF
                END IF


            ELSEIF ShieldHit = 0 THEN
                IF RIGHT$(Sprites(_BLUE(Check&)).Name, 4) = "Gohm" THEN
                    Sprites(_BLUE(Check&)).Health = Sprites(_BLUE(Check&)).Health - 1
                ELSE
                    Sprites(_BLUE(Check&)).Health = Sprites(_BLUE(Check&)).Health - Projectile(x).Damage
                END IF
                Sprites(_BLUE(Check&)).Hurt = 1
                Sprites(_BLUE(Check&)).HurtMove = Projectile(x).Direction
                CALL KillProjectile(x)

            ELSE
                CALL SoundBoard("Shield", -1)
                CALL KillProjectile(x)
            END IF

        ELSEIF _RED(Check&) = 50 AND RIGHT$(Projectile(x).Name, 4) = "Boom" THEN
            CALL ItemCollected(_BLUE(Check&))
        END IF
    END IF
END SUB




'*********************************************************
'* Spawns all projectile sprites
'*
'*
'*********************************************************

SUB DrawProjectiles
    FOR x = 1 TO Settings.MatrixSize
        IF Projectile(x).Active = 1 THEN
            IF Projectile(x).Name = "OctoR" THEN
                CALL OctorockRock(x)

            ELSEIF RIGHT$(Projectile(x).Name, 4) = "Arro" THEN
                CALL ArrowMain(x)

            ELSEIF Projectile(x).Name = "FireB" THEN
                CALL FireballMain(x)

            ELSEIF Projectile(x).Name = "Water" THEN
                CALL NonSolidWaterfall(x)

            ELSEIF Projectile(x).Name = "BGTre" OR Projectile(x).Name = "BBTre" THEN
                CALL BurnableTreeMain(x)

            ELSEIF Projectile(x).Name = "RBoom" OR Projectile(x).Name = "BBoom" THEN
                CALL BoomerangMain(x)

            ELSEIF RIGHT$(Projectile(x).Name, 4) = "Swor" THEN
                CALL LynelSword(x)

            ELSEIF Projectile(x).Name = "Magic" THEN
                CALL MagicMain(x)

            ELSEIF Projectile(x).Name = "Flame" THEN
                CALL FlameMain(x)

            ELSEIF Projectile(x).Name = "Wand " THEN
                CALL WandMain(x)

            END IF
        END IF
    NEXT x
END SUB

