'*********************************************************
'* Store.bi                              6/13/2021
'* Subs used to setup and get the store system working.
'*
'*********************************************************





'*********************************************************
'* Draws the store layout on the screen. along with price tags
'* and hitboxes
'*
'*********************************************************
SUB DrawStore
    IF Settings.SetupStore = 0 THEN CALL SetupStore
    Item1x = 344
    Item2x = Settings.RezX / 2
    Item3x = 666
    Item1y = 528
    Item2y = Item1y
    Item3y = Item1y
    ItemSize = Player1.Size * .75
    Texty = 36
    Item1TextX = 18
    Item2TextX = 28
    Item3TextX = 36

    _DEST Scene&
    _FONT Settings.Font
    IF Settings.SoldItem = 0 THEN
        IF Settings.Item1Type > 0 THEN
            _PUTIMAGE (Item1x - ItemSize, Item1y - ItemSize)-(Item1x + ItemSize, Item1y + ItemSize), StoreItemSprites(Settings.Item1Type), Sprites&
            LOCATE Texty, Item1TextX
            PRINT Settings.Item1Cost
        END IF

        IF Settings.Item2Type > 0 THEN
            _PUTIMAGE (Item2x - ItemSize, Item2y - ItemSize)-(Item2x + ItemSize, Item2y + ItemSize), StoreItemSprites(Settings.Item2Type), Sprites&
            LOCATE Texty, Item2TextX
            PRINT Settings.Item2Cost
        END IF

        IF Settings.Item3Type > 0 THEN
            _PUTIMAGE (Item3x - ItemSize, Item3y - ItemSize)-(Item3x + ItemSize, Item3y + ItemSize), StoreItemSprites(Settings.Item3Type), Sprites&
            LOCATE Texty, Item3TextX
            PRINT Settings.Item3Cost
        END IF

        _DEST Collision&

        IF Settings.Item1Type > 0 THEN LINE (Item1x - Player1.Size, Item1y - Player1.Size)-(Item1x + Player1.Size, Item1y + Player1.Size), _RGB(110, 0, 1), BF
        IF Settings.Item2Type > 0 THEN LINE (Item2x - Player1.Size, Item2y - Player1.Size)-(Item2x + Player1.Size, Item2y + Player1.Size), _RGB(110, 0, 2), BF
        IF Settings.Item3Type > 0 THEN LINE (Item3x - Player1.Size, Item3y - Player1.Size)-(Item3x + Player1.Size, Item3y + Player1.Size), _RGB(110, 0, 3), BF
    END IF
END SUB





'*********************************************************
'* Sets up the store when entered. Will set items for sale,
'* price, and text.
'*
'*********************************************************
SUB SetupStore
    Player1.XPos = Settings.RezX / 2
    Player1.YPos = Settings.RezY - ((Player1.Size * 2) + 10)
    CALL DrawPlayerSprite(Sprites&)
    CALL DrawSpecial
    CALL DrawProjectiles
    CALL AssembleDisplay

    IF RTRIM$(ActiveMap.Name) = "1" THEN
        ActiveMap.Name = "Shop"
        CALL PrintTxT("Buy somethin' will ya.")
        Settings.Item1Type = 2
        Settings.Item2Type = 1
        Settings.Item3Type = 3
        Settings.Item1Cost = 130
        Settings.Item2Cost = 20
        Settings.Item3Cost = 80
        Settings.UpdateUI = 1

    ELSEIF RTRIM$(ActiveMap.Name) = "2" THEN
        ActiveMap.Name = "Shop"
        CALL PrintTxT("Boy, this is really expensive!")
        Settings.Item1Type = 5
        Settings.Item2Type = 6
        Settings.Item3Type = 9
        Settings.Item1Cost = 80
        Settings.Item2Cost = 250
        Settings.Item3Cost = 60
        Settings.UpdateUI = 1


    ELSEIF RTRIM$(ActiveMap.Name) = "P" THEN
        ActiveMap.Name = "Potion Shop"
        CALL PrintTxT("Buy medicine before you go.")
        Settings.Item1Type = 7
        Settings.Item2Type = 0
        Settings.Item3Type = 8
        Settings.Item1Cost = 40
        Settings.Item2Cost = 0
        Settings.Item3Cost = 68
        Settings.UpdateUI = 1
    END IF


    Settings.SetupStore = 1
END SUB