'*********************************************************
'* UI.bi                               12/19/2021
'*
'* All code used to draw the UI
'*********************************************************




'*********************************************************
'* Main UI Code
'*
'*
'*********************************************************

SUB DrawUI
    CALL MakeUIComposite

    _DEST UI&
    CLS
    _CLEARCOLOR _RGB(0, 0, 0)

    LINE (0, 0)-(Settings.RezX, 200), _RGB(1, 1, 1), BF
    LINE (0, 200)-(Settings.RezX, Settings.RezY), _RGBA(1, 1, 1, Settings.Alpha), BF

    _PUTIMAGE (0, Settings.UiTop + Settings.UiOffset)-(Settings.RezX, 200 + Settings.UiOffset), UiComposite, UI&
END SUB



'*********************************************************
'* Creates a composite of the UI
'*
'*
'*********************************************************

SUB MakeUIComposite
    _DEST UiComposite&

    ItemSize = 10
    Shrink = 0
    VShrink = 0
    SecondaryX = Settings.RezX / 2
    SecondaryY = 50

    _PUTIMAGE (0, 0)-(Settings.RezX, 500), UiBase, UiComposite&

    IF Player1.Sword > 0 THEN
        Sword = Player1.Sword
        IF Sword > 2 THEN Sword = Sword + 2
        _PUTIMAGE (608, 400)-(637, 450), AttackSprites(1, Sword), UiComposite&
    END IF

    IF Player1.SecondaryWeapon > 0 THEN
        IF Player1.SecondaryWeapon = 1 THEN
            Tmp& = _COPYIMAGE(BoomerangSprites(5, Player1.Boomerang))
            DrawImage = 1
            Shrink = 12
            VShrink = 10

        ELSEIF Player1.SecondaryWeapon = 2 THEN
            Tmp& = _COPYIMAGE(BombSprite)
            DrawImage = 1

        ELSEIF Player1.SecondaryWeapon = 3 THEN
            IF Player1.SilverArrow = 1 THEN
                Tmp& = _COPYIMAGE(ArrowSprites(1, 3))
            ELSE
                Tmp& = _COPYIMAGE(ArrowSprites(1, 1))
            END IF
            DrawImage = 1
            Shrink = 12

        ELSEIF Player1.SecondaryWeapon = 4 THEN
            Tmp& = _COPYIMAGE(CandleSprites(Player1.Candle))
            DrawImage = 1
            Shrink = 10

        ELSEIF Player1.SecondaryWeapon = 5 THEN
            Tmp& = _COPYIMAGE(FluteSprite)
            DrawImage = 1
            Shrink = 4

        ELSEIF Player1.SecondaryWeapon = 6 THEN
            Tmp& = _COPYIMAGE(FoodSprite)
            DrawImage = 1

        ELSEIF Player1.SecondaryWeapon = 7 THEN
            Tmp& = _COPYIMAGE(PotionSprites(Player1.Potion))
            DrawImage = 1

        ELSEIF Player1.SecondaryWeapon = 8 THEN
            Tmp& = _COPYIMAGE(WandSprites(1))
            DrawImage = 1
            Shrink = 13
        END IF

        IF DrawImage = 1 THEN
            _PUTIMAGE (504 + Shrink, 400 + VShrink)-(548 - Shrink, 450 - VShrink), Tmp&, UiComposite&
            _FREEIMAGE Tmp&
        END IF
    END IF


    IF Player1.HaveRaft = 1 THEN _PUTIMAGE (504, 80)-(548, 130), RaftSprites(1), UiComposite&
    IF Player1.HaveBook = 1 THEN _PUTIMAGE (564, 80)-(608, 130), BookSprite, UiComposite&
    IF Player1.Ring > 1 THEN _PUTIMAGE (634, 90)-(658, 120), RingSprites(Player1.Ring - 1), UiComposite&
    IF Player1.HaveLadder = 1 THEN _PUTIMAGE (684, 80)-(728, 130), LadderSprite, UiComposite&
    IF Player1.HaveMasterKey = 1 THEN _PUTIMAGE (754, 80)-(778, 130), KeySprites(2), UiComposite&

    IF Player1.Boomerang > 0 THEN
        _PUTIMAGE (519, 160)-(533, 180), BoomerangSprites(5, Player1.Boomerang), UiComposite&
        IF Player1.SecondaryWeapon = 1 THEN _PUTIMAGE (500, 145)-(555, 200), CursorSprite, UiComposite&
    END IF

    IF Player1.Bombs > -1 THEN
        _PUTIMAGE (584, 150)-(643, 190), BombSprite, UiComposite&
        IF Player1.SecondaryWeapon = 2 THEN _PUTIMAGE (584, 145)-(643, 200), CursorSprite, UiComposite&
    END IF

    IF Player1.HaveBow = 1 THEN
        _PUTIMAGE (706, 150)-(765, 190), BowSprite, UiComposite&
        IF Player1.SilverArrow = 1 THEN
            _PUTIMAGE (695, 150)-(715, 190), ArrowSprites(1, 3), UiComposite&
        ELSE
            _PUTIMAGE (695, 150)-(715, 190), ArrowSprites(1, 1), UiComposite&
        END IF
        IF Player1.SecondaryWeapon = 3 THEN _PUTIMAGE (690, 145)-(750, 200), CursorSprite, UiComposite&
    END IF

    IF Player1.Candle > 0 THEN
        _PUTIMAGE (820, 150)-(850, 190), CandleSprites(Player1.Candle), UiComposite&
        IF Player1.SecondaryWeapon = 4 THEN _PUTIMAGE (805, 145)-(865, 200), CursorSprite, UiComposite&
    END IF

    IF Player1.HaveFlute > 0 THEN
        _PUTIMAGE (505, 205)-(550, 255), FluteSprite, UiComposite&
        IF Player1.SecondaryWeapon = 5 THEN _PUTIMAGE (500, 205)-(555, 255), CursorSprite, UiComposite&
    END IF

    IF Player1.HaveFood = 1 THEN
        _PUTIMAGE (595, 210)-(630, 250), FoodSprite, UiComposite&
        IF Player1.SecondaryWeapon = 6 THEN _PUTIMAGE (584, 205)-(643, 255), CursorSprite, UiComposite&
    END IF

    IF Player1.Potion > 0 THEN
        _PUTIMAGE (702, 205)-(737, 255), PotionSprites(Player1.Potion), UiComposite&
        IF Player1.SecondaryWeapon = 7 THEN _PUTIMAGE (690, 205)-(750, 255), CursorSprite, UiComposite&
    END IF

    IF Player1.HaveWand = 1 THEN
        _PUTIMAGE (825, 205)-(845, 255), WandSprites(1), UiComposite&
        IF Player1.SecondaryWeapon = 8 THEN _PUTIMAGE (805, 205)-(865, 255), CursorSprite, UiComposite&
    END IF

    IF Player1.Triforce > 0 THEN _PUTIMAGE (187, 145)-(250, 195), TriforceUISprites(1), UiComposite&
    IF Player1.Triforce > 1 THEN _PUTIMAGE (250, 145)-(315, 195), TriforceUISprites(2), UiComposite&
    IF Player1.Triforce > 2 THEN _PUTIMAGE (124, 195)-(187, 246), TriforceUISprites(1), UiComposite&
    IF Player1.Triforce = 4 THEN _PUTIMAGE (187, 195)-(250, 246), TriforceUISprites(3), UiComposite&
    IF Player1.Triforce > 4 THEN _PUTIMAGE (187, 195)-(250, 246), TriforceUISprites(4), UiComposite&
    IF Player1.Triforce = 6 THEN _PUTIMAGE (250, 195)-(315, 246), TriforceUISprites(3), UiComposite&
    IF Player1.Triforce > 6 THEN _PUTIMAGE (250, 195)-(315, 246), TriforceUISprites(4), UiComposite&
    IF Player1.Triforce = 8 THEN _PUTIMAGE (315, 195)-(380, 246), TriforceUISprites(2), UiComposite&

    _FONT Settings.FontUi
    IF ActiveMap.Name <> "NULL" THEN
        LOCATE 17, 1
        PRINT LTRIM$(RTRIM$(ActiveMap.Name))
    END IF

    LOCATE 20, 14
    PRINT LTRIM$(STR$(Player1.Cash))

    LOCATE 22, 14
    IF Player1.Keys < 200 THEN
        PRINT LTRIM$(STR$(Player1.Keys))
    ELSE
        PRINT "A"
    END IF

    LOCATE 24, 14
    IF Player1.Bombs = -1 THEN
        PRINT "0"
    ELSE
        PRINT LTRIM$(STR$(Player1.Bombs))
    END IF

    Hearts = Player1.MaxHealth / 2
    Filled = Player1.Health
    YLoc = 410
    XLoc = 730
    Spacer = 5
    Size = 12

    FOR x = 1 TO Hearts
        IF Filled >= 2 THEN
            _PUTIMAGE (XLoc - Size, YLoc - Size)-(XLoc + Size, YLoc + Size), HeartSprites(2), UiComposite&
            Filled = Filled - 2
        ELSEIF Filled >= 1.5 THEN
            _PUTIMAGE (XLoc - Size, YLoc - Size)-(XLoc + Size, YLoc + Size), HeartSprites(6), UiComposite&
            Filled = Filled - 1.5
        ELSEIF Filled >= 1 THEN
            _PUTIMAGE (XLoc - Size, YLoc - Size)-(XLoc + Size, YLoc + Size), HeartSprites(5), UiComposite&
            Filled = Filled - 1
        ELSEIF Filled >= 0.5 THEN
            _PUTIMAGE (XLoc - Size, YLoc - Size)-(XLoc + Size, YLoc + Size), HeartSprites(7), UiComposite&
            Filled = Filled - 1
        ELSE
            _PUTIMAGE (XLoc - Size, YLoc - Size)-(XLoc + Size, YLoc + Size), HeartSprites(4), UiComposite&
        END IF
        XLoc = XLoc + Spacer + (Size * 2)
        IF x = 8 THEN
            XLoc = 730
            YLoc = YLoc + Spacer + (Size * 2)
        END IF
    NEXT x
END SUB


'*********************************************************
'* Pause screen.
'*
'*
'*********************************************************

SUB PauseScreen
    Menuspeed = 5
    LockTemp = Settings.LockInput
    Settings.LockInput = 0

    FOR Drop = 0 TO ABS(Settings.UiTop) STEP Menuspeed
        _LIMIT 60
        Settings.UiOffset = Drop
        Settings.UpdateUI = 1
        CALL AssembleDisplay
        CALL CheckForAudioLoop
    NEXT Drop

    _SNDVOL BGM&, 0.25

    DO
        _LIMIT 30

        IF Controller.Enabled = 1 THEN CALL ReadController

        IF _KEYDOWN(9) = -1 OR ControllerInput.Start = -1 THEN
            EXIT DO
        ELSEIF _KEYDOWN(49) = -1 AND Settings.LockAccKeys = 0 THEN
            CALL InputHandle("Prev")

        ELSEIF _KEYDOWN(50) = -1 AND Settings.LockAccKeys = 0 THEN
            CALL InputHandle("Next")
        ELSEIF ControllerInput.DpadH = -1 AND Settings.LockAccKeys = 0 THEN
            CALL InputHandle("Prev")
        ELSEIF ControllerInput.DpadH = 1 AND Settings.LockAccKeys = 0 THEN
            CALL InputHandle("Next")
        ELSEIF _KEYDOWN(65) = -1 OR _KEYDOWN(97) = -1 THEN
            IF Settings.LockAccKeys = 0 THEN CALL InputHandle("Prev")
        ELSEIF _KEYDOWN(68) = -1 OR _KEYDOWN(100) = -1 THEN
            IF Settings.LockAccKeys = 0 THEN CALL InputHandle("Next")
        END IF

        Settings.UpdateUI = 1
        CALL AssembleDisplay

        IF _SNDPLAYING(BGM&) = 0 AND Settings.SetLoop <> 0 THEN
            _SNDSETPOS BGM&, Settings.SetLoop
            _SNDPLAY BGM&
        END IF

        IF _SNDPLAYING(SFX(22)) = 0 THEN Settings.LockAccKeys = 0
    LOOP

    FOR Drop = Settings.UiOffset TO 0 STEP Menuspeed * -1
        _LIMIT 60
        Settings.UiOffset = Drop
        Settings.UpdateUI = 1
        CALL AssembleDisplay
        CALL CheckForAudioLoop
    NEXT Drop

    _SNDVOL BGM&, 1
    Settings.LockInput = LockTemp
END SUB


'*********************************************************
'* Cycles to next weapon when used or depleted
'*
'*
'*********************************************************

FUNCTION CycleWeapon (Direction)
    FailSafe = 0
    Count = Player1.SecondaryWeapon

    DO
        Count = Count + Direction
        FailSafe = FailSafe + 1
        IF Count = 0 THEN Count = 8
        IF Count = 9 THEN Count = 1

        IF Count = 1 AND Player1.Boomerang > 0 THEN EXIT DO
        IF Count = 2 AND Player1.Bombs > -1 THEN EXIT DO
        IF Count = 3 AND Player1.HaveBow = 1 THEN EXIT DO
        IF Count = 4 AND Player1.Candle > 0 THEN EXIT DO
        IF Count = 5 AND Player1.HaveFlute = 1 THEN EXIT DO
        IF Count = 6 AND Player1.HaveFood = 1 THEN EXIT DO
        IF Count = 7 AND Player1.Potion > 0 THEN EXIT DO
        IF Count = 8 AND Player1.HaveWand = 1 THEN EXIT DO
    LOOP UNTIL FailSafe = 100
    IF FailSafe = 100 THEN Count = 0

    Settings.UpdateUI = 1
    Settings.LockAccKeys = 1
    CALL SoundBoard("Rupee", -1)
    CycleWeapon = Count
END FUNCTION





